"""Autogenerated API schema"""
from argus_api import session


add_alarm = {'tags': ['alarms/v1'], 'summary': 'Add a new alarm (INTERNAL)', 'description': '', 'operationId': 'addAlarm', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'shortName': {'type': 'str', 'description': 'Short name of the alarm', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'description': {'type': 'str', 'description': 'Alarm description', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'attackCategoryID': {'type': 'int', 'default': 0, 'description': 'Alarm attack category ID', 'minimum': 1}, 'info': {'type': 'str', 'description': 'Alarm verbose information [format:html]', 'x-Argus-Format': 'html'}, 'references': {'type': 'list', 'description': 'Alarm vulnerability references (CVE-numbers, BID-numbers, URLs etc)', 'items': {'type': 'str', 'description': 'Alarm vulnerability references (CVE-numbers, BID-numbers, URLs etc)'}, 'pattern': '^((?!(https?|ftp|gopher|telnet|file|javascript|mailto):))([\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=])*|((https?|ftp|gopher|telnet|file):((/)|(\\\\))+[\\w\\d:\\#@%/;$()~_?\\\\+-=\\\\\\.&]*)', 'uniqueItems': True}, 'links': {'type': 'list', 'description': 'Links to external descriptions of this alarm', 'items': {'type': 'str', 'description': 'Links to external descriptions of this alarm'}, 'pattern': '((https?|ftp|gopher|telnet|file):((/)|(\\\\))+[\\w\\d:\\#@%/;$()~_?\\\\+-=\\\\\\.&]*)', 'uniqueItems': True}, 'labels': {'type': 'list', 'description': 'Tag an alarm with labels', 'items': {'type': 'str', 'description': 'Tag an alarm with labels'}, 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'uniqueItems': True}, 'internalReference': {'type': 'str', 'description': 'A link to an internal reference for the alarm', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'internalInformation': {'type': 'str', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC. Contents may be HTML, which will be sanitized.'}, 'signatures': {'type': 'list', 'description': 'List of signatures to map to this alarm', 'items': {'type': 'str', 'description': 'List of signatures to map to this alarm'}, 'pattern': '[a-zA-Z0-9_/:@~!\\+\\-\\.\\?]*', 'uniqueItems': True}}, 'required': ['description']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Add a new alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addAlarm'], 'x-Argus-ApiStatus': 'INTERNAL'}
add_alarm_comment = {'tags': ['alarms/v1'], 'summary': 'Add a comment to an alarm (INTERNAL)', 'description': '', 'operationId': 'addAlarmComment', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'comment': {'type': 'str', 'description': 'Comment content. Html is allowed, will be sanitized. [format:html]', 'x-Argus-Format': 'html'}}, 'required': ['comment']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Add a comment to an alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addAlarmComment'], 'x-Argus-ApiStatus': 'INTERNAL'}
add_alarm_mitre_relationship = {'tags': ['alarms/v1'], 'summary': 'Adds a new relationship between an alarm and a MITRE category (DEV)', 'description': '', 'operationId': 'addAlarmMitreRelationship', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'ID or short name of the alarm', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'mitreCategory': {'type': 'str', 'description': 'ID or external ID of the MITRE category (external ID requires setting additional attributes: categoryModel, categoryVersion)'}, 'categoryModel': {'type': 'str', 'description': 'Which threat model to use with external ID of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'categoryVersion': {'type': 'str', 'description': 'Which version to use with external ID of the MITRE category'}}, 'required': ['mitreCategory']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Adds a new relationship between an alarm and a MITRE category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'alarm': {'type': 'object', 'description': 'Info object of the alarm that is part of the relationship', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'description': {'type': 'string', 'description': 'Short description about the alarm'}}}, 'mitreCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addAlarmMitreRelationship'], 'x-Argus-ApiStatus': 'DEV'}
delete_alarm = {'tags': ['alarms/v1'], 'summary': 'Delete an existing alarm (INTERNAL)', 'description': '', 'operationId': 'deleteAlarm', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Delete an existing alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteAlarm'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_alarm_comment = {'tags': ['alarms/v1'], 'summary': 'Delete an existing comment from an alarm (INTERNAL)', 'description': '', 'operationId': 'deleteAlarmComment', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}, {'name': 'timestamp', 'in': 'path', 'description': 'Timestamp of the comment', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Delete an existing comment from an alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['removeAlarmComment'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_alarm_mitre_relationship = {'tags': ['alarms/v1'], 'summary': 'Deletes an existing relationship between an alarm and a MITRE category (DEV)', 'description': '', 'operationId': 'deleteAlarmMitreRelationship', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'ID or short name of the alarm', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category (external ID requires additional query parameters: categoryModel, categoryVersion)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'categoryModel', 'in': 'query', 'description': 'Which threat model to use with external ID of the MITRE category', 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'categoryVersion', 'in': 'query', 'description': 'Which version to use with external ID of the MITRE category', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Deletes an existing relationship between an alarm and a MITRE category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'alarm': {'type': 'object', 'description': 'Info object of the alarm that is part of the relationship', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'description': {'type': 'string', 'description': 'Short description about the alarm'}}}, 'mitreCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteAlarmMitreRelationship'], 'x-Argus-ApiStatus': 'DEV'}
get_alarm_by_id = {'tags': ['alarms/v1'], 'summary': 'Get an alarm by ID (PUBLIC)', 'description': '', 'operationId': 'getAlarmById', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Get an alarm by ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarm'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_alarms = {'tags': ['alarms/v1'], 'summary': 'Get all alarms (PUBLIC)', 'description': '', 'operationId': 'getAlarms', 'parameters': [{'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywordMatch', 'in': 'query', 'description': 'Set match strategy for keyword search', 'schema': {'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, 'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, {'name': 'keywordField', 'in': 'query', 'description': 'Set field strategy for keyword search', 'schema': {'type': 'list', 'default': 'all', 'items': {'type': 'str', 'enum': ['reference', 'description', 'label', 'signature', 'attackIdentifier', 'id', 'shortName', 'all']}, 'uniqueItems': True}, 'type': 'list', 'default': 'all', 'items': {'type': 'str', 'enum': ['reference', 'description', 'label', 'signature', 'attackIdentifier', 'id', 'shortName', 'all']}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of alarms', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned alarms', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'Get all alarms', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarm'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_alarm_mitre_relationships = {'tags': ['alarms/v1'], 'summary': 'List relationships between an alarm and MITRE categories (DEV)', 'description': '', 'operationId': 'listAlarmMitreRelationships', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'ID or short name of the alarm', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'categoryType', 'in': 'query', 'description': 'Type(s) of the MITRE categories (all by default)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, {'name': 'categoryModel', 'in': 'query', 'description': 'The threat model(s) of the MITRE categories (all by default)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, {'name': 'categoryVersion', 'in': 'query', 'description': 'The version(s) of the MITRE categories (all by default)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includeDeleted', 'in': 'query', 'description': 'To include deleted relationships or not (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'sortBy', 'in': 'query', 'description': "Field(s) to sort results by (without sign is ascending, with '-' sign is descending)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'limit', 'in': 'query', 'description': 'The max amount of items to return (25 by default, 0 means no limit)', 'schema': {'type': 'int', 'minimum': 0}, 'type': 'int', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'The amount of items to skip from the beginning (0 by default)', 'schema': {'type': 'int', 'minimum': 0}, 'type': 'int', 'minimum': 0}], 'responses': {'default': {'description': 'List relationships between an alarm and MITRE categories', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'alarm': {'type': 'object', 'description': 'Info object of the alarm that is part of the relationship', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'description': {'type': 'string', 'description': 'Short description about the alarm'}}}, 'mitreCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarm', 'viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
map_to_alarm = {'tags': ['alarms/v1'], 'summary': 'Map signatures to an alarm (INTERNAL)', 'description': '', 'operationId': 'mapToAlarm', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'signatures': {'type': 'list', 'description': 'Signatures (exist/new) to be mapped to the alarm', 'items': {'type': 'str', 'description': 'Signatures (exist/new) to be mapped to the alarm'}, 'maxItems': 2147483647, 'minItems': 1, 'pattern': '[a-zA-Z0-9_/:@~!\\+\\-\\.\\?]*', 'uniqueItems': True}}, 'required': ['signatures']}}}, 'required': True}, 'responses': {'default': {'description': 'Map signatures to an alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addAlarmMapping'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_alarm_mitre_relationships = {'tags': ['alarms/v1'], 'summary': 'Searches for relationships between alarms and MITRE categories (DEV)', 'description': '', 'operationId': 'searchAlarmMitreRelationships', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'id': {'type': 'list', 'description': 'A set of IDs of the searched relationships', 'items': {'type': 'str', 'description': 'A set of IDs of the searched relationships'}, 'uniqueItems': True}, 'alarm': {'type': 'list', 'description': 'A set of IDs or short names of the alarms that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of IDs or short names of the alarms that take part in the relationships'}, 'uniqueItems': True}, 'category': {'type': 'list', 'description': 'A set of IDs, external IDs or short names of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of IDs, external IDs or short names of the MITRE categories that take part in the relationships'}, 'uniqueItems': True}, 'categoryType': {'type': 'list', 'description': 'A set of enumerated types of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of enumerated types of the MITRE categories that take part in the relationships', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, 'categoryModel': {'type': 'list', 'description': 'A set of enumerated threat models of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of enumerated threat models of the MITRE categories that take part in the relationships', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, 'categoryVersion': {'type': 'list', 'description': 'A set of versions of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of versions of the MITRE categories that take part in the relationships'}, 'uniqueItems': True}, 'includeFlags': {'type': 'list', 'description': 'A set of included enumerated flags of the searched relationships', 'items': {'type': 'str', 'description': 'A set of included enumerated flags of the searched relationships', 'enum': ['deleted']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'A set of excluded enumerated flags of the searched relationships', 'items': {'type': 'str', 'description': 'A set of excluded enumerated flags of the searched relationships', 'enum': ['deleted']}, 'uniqueItems': True}, 'subCriteria': {'type': 'list', 'description': 'Set additional search criteria with AND, OR or AND NOT', 'items': {'type': 'dict', 'properties': {'id': {'type': 'list', 'description': 'A set of IDs of the searched relationships', 'items': {'type': 'str', 'description': 'A set of IDs of the searched relationships'}, 'uniqueItems': True}, 'alarm': {'type': 'list', 'description': 'A set of IDs or short names of the alarms that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of IDs or short names of the alarms that take part in the relationships'}, 'uniqueItems': True}, 'category': {'type': 'list', 'description': 'A set of IDs, external IDs or short names of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of IDs, external IDs or short names of the MITRE categories that take part in the relationships'}, 'uniqueItems': True}, 'categoryType': {'type': 'list', 'description': 'A set of enumerated types of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of enumerated types of the MITRE categories that take part in the relationships', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, 'categoryModel': {'type': 'list', 'description': 'A set of enumerated threat models of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of enumerated threat models of the MITRE categories that take part in the relationships', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, 'categoryVersion': {'type': 'list', 'description': 'A set of versions of the MITRE categories that take part in the relationships', 'items': {'type': 'str', 'description': 'A set of versions of the MITRE categories that take part in the relationships'}, 'uniqueItems': True}, 'includeFlags': {'type': 'list', 'description': 'A set of included enumerated flags of the searched relationships', 'items': {'type': 'str', 'description': 'A set of included enumerated flags of the searched relationships', 'enum': ['deleted']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'A set of excluded enumerated flags of the searched relationships', 'items': {'type': 'str', 'description': 'A set of excluded enumerated flags of the searched relationships', 'enum': ['deleted']}, 'uniqueItems': True}, 'required': {'type': 'bool', 'default': False, 'description': 'Is this sub-criteria required? If false it is OR-ed, if true it is AND-ed'}, 'exclude': {'type': 'bool', 'default': False, 'description': 'Exclude objects matching sub-criteria? If true, the criteria is NOT-ed.'}}}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'default': 'mitreCategoryShortName, -createdTimestamp', 'description': "Fields to sort results by (without sign is ascending, with '-' sign is descending)", 'items': {'type': 'str', 'default': 'mitreCategoryShortName, -createdTimestamp', 'description': "Fields to sort results by (without sign is ascending, with '-' sign is descending)", 'enum': ['id', 'alarmId', 'alarmShortName', 'mitreCategoryId', 'mitreCategoryExternalId', 'mitreCategoryShortName', 'mitreCategoryType', 'mitreCategoryModel', 'mitreCategoryVersion', 'createdTimestamp', 'lastUpdatedTimestamp', 'deletedTimestamp', '-id', '-alarmId', '-alarmShortName', '-mitreCategoryId', '-mitreCategoryExternalId', '-mitreCategoryShortName', '-mitreCategoryType', '-mitreCategoryModel', '-mitreCategoryVersion', '-createdTimestamp', '-lastUpdatedTimestamp', '-deletedTimestamp']}}, 'limit': {'type': 'int', 'default': 25, 'description': 'The max amount of items to return', 'minimum': 0}, 'offset': {'type': 'int', 'default': 0, 'description': 'The amount of items to skip from the beginning', 'minimum': 0}}}}}, 'required': True}, 'responses': {'default': {'description': 'Searches for relationships between alarms and MITRE categories', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'alarm': {'type': 'object', 'description': 'Info object of the alarm that is part of the relationship', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'description': {'type': 'string', 'description': 'Short description about the alarm'}}}, 'mitreCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between alarm and MITRE category', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between alarm and MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarm', 'viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
search_alarms = {'tags': ['alarms/v1'], 'summary': 'Get all alarms matching a given search criteria (PUBLIC)', 'description': '', 'operationId': 'searchAlarms', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'attackCategoryID': {'type': 'list', 'description': 'A set of IDs for attack categories (alarm category).', 'items': {'type': 'int', 'description': 'A set of IDs for attack categories (alarm category).'}, 'uniqueItems': True}, 'alarmID': {'type': 'list', 'description': 'A set of IDs for alarms.', 'items': {'type': 'int', 'description': 'A set of IDs for alarms.'}, 'uniqueItems': True}, 'alarm': {'type': 'list', 'description': 'A set of IDs or short names for alarms.', 'items': {'type': 'str', 'description': 'A set of IDs or short names for alarms.'}, 'uniqueItems': True}, 'alarmReferences': {'type': 'list', 'description': 'A set of references. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of references. It does an exact match.'}, 'uniqueItems': True}, 'labels': {'type': 'list', 'description': 'A set of labels. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of labels. It does an exact match.'}, 'uniqueItems': True}, 'includeMappings': {'type': 'bool', 'default': False, 'description': 'Set to include mappings in the search result.'}, 'includeComments': {'type': 'bool', 'default': False, 'description': 'Set to include comments in the search result.'}, 'startTimestamp': {'type': 'str', 'description': 'Only include alarms based on the set TimeFieldStrategy and TimeMatchStrategy (start timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Only include alarms based on the set TimeFieldStrategy and TimeMatchStrategy (end timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeFieldStrategy': {'type': 'list', 'default': 'lastUpdatedTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'items': {'type': 'str', 'default': 'lastUpdatedTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastCheckTimestamp', 'nextCheckTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'TimeMatchStrategy to define how to match startTimestamp and endTimestamp with fields.', 'enum': ['all', 'any']}, 'keywords': {'type': 'list', 'description': 'A set of keywords matched against alarms based on the set KeywordFieldStrategy and KeywordMatchStrategy.', 'items': {'type': 'str', 'description': 'A set of keywords matched against alarms based on the set KeywordFieldStrategy and KeywordMatchStrategy.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'items': {'type': 'str', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'enum': ['reference', 'description', 'label', 'signature', 'attackIdentifier', 'id', 'shortName', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'KeywordMatchStrategy to define how to match keywords with fields.', 'enum': ['all', 'any']}, 'signature': {'type': 'list', 'description': 'A set of signatures. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of signatures. It does an exact match.'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'lastUpdatedTimestamp', 'description', 'attackCategory', '-id', '-lastUpdatedTimestamp', '-description', '-attackCategory']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'attackCategoryID': {'type': 'list', 'description': 'A set of IDs for attack categories (alarm category).', 'items': {'type': 'int', 'description': 'A set of IDs for attack categories (alarm category).'}, 'uniqueItems': True}, 'alarmID': {'type': 'list', 'description': 'A set of IDs for alarms.', 'items': {'type': 'int', 'description': 'A set of IDs for alarms.'}, 'uniqueItems': True}, 'alarm': {'type': 'list', 'description': 'A set of IDs or short names for alarms.', 'items': {'type': 'str', 'description': 'A set of IDs or short names for alarms.'}, 'uniqueItems': True}, 'alarmReferences': {'type': 'list', 'description': 'A set of references. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of references. It does an exact match.'}, 'uniqueItems': True}, 'labels': {'type': 'list', 'description': 'A set of labels. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of labels. It does an exact match.'}, 'uniqueItems': True}, 'includeMappings': {'type': 'bool', 'default': False, 'description': 'Set to include mappings in the search result.'}, 'includeComments': {'type': 'bool', 'default': False, 'description': 'Set to include comments in the search result.'}, 'startTimestamp': {'type': 'str', 'description': 'Only include alarms based on the set TimeFieldStrategy and TimeMatchStrategy (start timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Only include alarms based on the set TimeFieldStrategy and TimeMatchStrategy (end timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeFieldStrategy': {'type': 'list', 'default': 'lastUpdatedTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'items': {'type': 'str', 'default': 'lastUpdatedTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastCheckTimestamp', 'nextCheckTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'TimeMatchStrategy to define how to match startTimestamp and endTimestamp with fields.', 'enum': ['all', 'any']}, 'keywords': {'type': 'list', 'description': 'A set of keywords matched against alarms based on the set KeywordFieldStrategy and KeywordMatchStrategy.', 'items': {'type': 'str', 'description': 'A set of keywords matched against alarms based on the set KeywordFieldStrategy and KeywordMatchStrategy.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'items': {'type': 'str', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'enum': ['reference', 'description', 'label', 'signature', 'attackIdentifier', 'id', 'shortName', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'KeywordMatchStrategy to define how to match keywords with fields.', 'enum': ['all', 'any']}, 'signature': {'type': 'list', 'description': 'A set of signatures. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of signatures. It does an exact match.'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'lastUpdatedTimestamp', 'description', 'attackCategory', '-id', '-lastUpdatedTimestamp', '-description', '-attackCategory']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Get all alarms matching a given search criteria', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarm'], 'x-Argus-ApiStatus': 'PUBLIC'}
unmap = {'tags': ['alarms/v1'], 'summary': 'Unmap signatures from an alarm (INTERNAL)', 'description': '', 'operationId': 'unmap', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}, {'name': 'signature', 'in': 'query', 'description': 'Signatures to unmap', 'required': True, 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Unmap signatures from an alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['removeAlarmMapping'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_alarm = {'tags': ['alarms/v1'], 'summary': 'Update an existing alarm (INTERNAL)', 'description': '', 'operationId': 'updateAlarm', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of the alarm', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'shortName': {'type': 'str', 'description': 'If set, update short name of the alarm', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'description': {'type': 'str', 'description': 'If set, update description of alarm', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'attackCategoryID': {'type': 'int', 'default': 0, 'description': 'Update category of alarm (unchanged if set to 0)', 'minimum': 0}, 'info': {'type': 'str', 'description': 'If set, update verbose information of alarm [format:html]', 'x-Argus-Format': 'html'}, 'disabled': {'type': 'bool', 'description': 'If set, disable or enable alarm (unchanged if not set)'}, 'addReferences': {'type': 'list', 'description': 'Vulnerability references to be added to the alarm (CVE-numbers, BID-numbers, URLs etc)', 'items': {'type': 'str', 'description': 'Vulnerability references to be added to the alarm (CVE-numbers, BID-numbers, URLs etc)'}, 'pattern': '^((?!(https?|ftp|gopher|telnet|file|javascript|mailto):))([\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=])*|((https?|ftp|gopher|telnet|file):((/)|(\\\\))+[\\w\\d:\\#@%/;$()~_?\\\\+-=\\\\\\.&]*)', 'uniqueItems': True}, 'deleteReferences': {'type': 'list', 'description': 'Vulnerability references to be removed from the alarm', 'items': {'type': 'str', 'description': 'Vulnerability references to be removed from the alarm'}, 'uniqueItems': True}, 'addLinks': {'type': 'list', 'description': 'External links to be added to the alarm', 'items': {'type': 'str', 'description': 'External links to be added to the alarm'}, 'pattern': '((https?|ftp|gopher|telnet|file):((/)|(\\\\))+[\\w\\d:\\#@%/;$()~_?\\\\+-=\\\\\\.&]*)', 'uniqueItems': True}, 'deleteLinks': {'type': 'list', 'description': 'External links to be removed from the alarm', 'items': {'type': 'str', 'description': 'External links to be removed from the alarm'}, 'uniqueItems': True}, 'addLabels': {'type': 'list', 'description': 'Labels to be added to the alarm', 'items': {'type': 'str', 'description': 'Labels to be added to the alarm'}, 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'uniqueItems': True}, 'deleteLabels': {'type': 'list', 'description': 'Labels to be removed from the alarm', 'items': {'type': 'str', 'description': 'Labels to be removed from the alarm'}, 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'uniqueItems': True}, 'internalReference': {'type': 'str', 'description': 'If set, update link to an internal reference for the alarm', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'internalInformation': {'type': 'str', 'description': 'If set, update internal information about handling the alarm. Describes how the alarm should be handled by SOC. Contents may be HTML, which will be sanitized.'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update an existing alarm', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': [], 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateAlarm'], 'x-Argus-ApiStatus': 'INTERNAL'}