"""Autogenerated API schema"""
from argus_api import session


add_mitre_category = {'tags': ['alarms/v1'], 'summary': 'Adds a new MITRE category (DEV)', 'description': '', 'operationId': 'addMitreCategory', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'externalId': {'type': 'str', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'str', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'str', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'str', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'str', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'str', 'description': 'Version of the MITRE ATT&CK release'}, 'url': {'type': 'str', 'description': 'URL of the external MITRE category page', 'pattern': '((https?|ftp|gopher|telnet|file):((/)|(\\\\))+[\\w\\d:\\#@%/;$()~_?\\\\+-=\\\\\\.&]*)'}}, 'required': ['externalId', 'model', 'name', 'shortName', 'type', 'url', 'version']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Adds a new MITRE category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}, 'url': {'type': 'string', 'description': 'URL of the external MITRE category page'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'relationships': {'type': 'array', 'description': 'Relationships that this MITRE category is participating in', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
add_mitre_category_relationship = {'tags': ['alarms/v1'], 'summary': 'Adds a new MITRE category relationship (DEV)', 'description': '', 'operationId': 'addMitreCategoryRelationship', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the source MITRE category (external ID requires an additional query parameter: sourceCategoryModel; version is already part of the request payload)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'sourceCategoryModel', 'in': 'query', 'description': 'Which threat model to use with external ID of the source MITRE category', 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'externalId': {'type': 'str', 'description': 'External ID of the MITRE category relationship'}, 'targetCategory': {'type': 'str', 'description': 'ID or external ID of target MITRE category (external ID requires setting an additional attribute: targetCategoryModel)'}, 'targetCategoryModel': {'type': 'str', 'description': 'Which threat model to use with target MITRE category external ID', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': {'type': 'str', 'description': 'Enumerated type of the MITRE category relationship', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'str', 'description': 'Version of the MITRE ATT&CK release, has to match the version of the related categories'}}, 'required': ['externalId', 'targetCategory', 'type', 'version']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Adds a new MITRE category relationship', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addMitreCategoryRelationship'], 'x-Argus-ApiStatus': 'DEV'}
add_or_update_mitre_model_version = {'tags': ['alarms/v1'], 'summary': 'Adds or updates MITRE model version info (DEV)', 'description': '', 'operationId': 'addOrUpdateMitreModelVersion', 'parameters': [{'name': 'model', 'in': 'path', 'description': 'Threat model of the MITRE category', 'required': True, 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'version', 'in': 'path', 'description': 'Version of the MITRE ATT&CK release', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'markAsDefault': {'type': 'bool', 'description': 'A boolean flag indicating whether this version should be marked as the default one for this model (default value is null, meaning no change)'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Adds or updates MITRE model version info', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE ATT&CK release'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE model version', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE model version', 'enum': ['default']}, 'uniqueItems': True}}}}}}}}, '220': {'description': 'No update was performed', 'content': {'application/json': {}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateMitreModelVersion'], 'x-Argus-ApiStatus': 'DEV'}
delete_mitre_category = {'tags': ['alarms/v1'], 'summary': 'Deletes an existing MITRE category (DEV)', 'description': '', 'operationId': 'deleteMitreCategory', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category (external ID requires additional query parameters: model, version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'model', 'in': 'query', 'description': 'Which threat model to use with external ID', 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Deletes an existing MITRE category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}, 'url': {'type': 'string', 'description': 'URL of the external MITRE category page'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'relationships': {'type': 'array', 'description': 'Relationships that this MITRE category is participating in', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
delete_mitre_category_relationship = {'tags': ['alarms/v1'], 'summary': 'Deletes an existing MITRE category relationship (DEV)', 'description': '', 'operationId': 'deleteMitreCategoryRelationship', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category relationship (external ID requires an additional query parameter: version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Deletes an existing MITRE category relationship', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteMitreCategoryRelationship'], 'x-Argus-ApiStatus': 'DEV'}
get_mitre_category = {'tags': ['alarms/v1'], 'summary': 'Gets an existing MITRE category by ID or external ID (DEV)', 'description': '', 'operationId': 'getMitreCategory', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category (external ID requires additional query parameters: model, version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'model', 'in': 'query', 'description': 'Which threat model to use with external ID', 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeRelationships', 'in': 'query', 'description': 'Whether to include MITRE category relationships or not (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}], 'responses': {'default': {'description': 'Gets an existing MITRE category by ID or external ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}, 'url': {'type': 'string', 'description': 'URL of the external MITRE category page'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'relationships': {'type': 'array', 'description': 'Relationships that this MITRE category is participating in', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
get_mitre_category_relationship = {'tags': ['alarms/v1'], 'summary': 'Gets an existing MITRE category relationship by ID or external ID (DEV)', 'description': '', 'operationId': 'getMitreCategoryRelationship', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category relationship (external ID requires an additional query parameter: version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Gets an existing MITRE category relationship by ID or external ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
get_mitre_model_version = {'tags': ['alarms/v1'], 'summary': 'Gets MITRE model version info by model and version (DEV)', 'description': '', 'operationId': 'getMitreModelVersion', 'parameters': [{'name': 'model', 'in': 'path', 'description': 'Threat model of the MITRE category', 'required': True, 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'version', 'in': 'path', 'description': 'Version of the MITRE ATT&CK release', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Gets MITRE model version info by model and version', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE ATT&CK release'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE model version', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE model version', 'enum': ['default']}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
list_mitre_categories = {'tags': ['alarms/v1'], 'summary': 'List MITRE categories (DEV)', 'description': '', 'operationId': 'listMitreCategories', 'parameters': [{'name': 'type', 'in': 'query', 'description': 'Type(s) of the included MITRE categories (all by default)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, {'name': 'model', 'in': 'query', 'description': 'Threat model(s) of the included MITRE categories (all by default)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, {'name': 'version', 'in': 'query', 'description': 'Version(s) of the included MITRE categories (all by default)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Whether to include deleted MITRE categories or not (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'includeDeprecated', 'in': 'query', 'description': 'Whether to include deprecated MITRE categories or not (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'includeRelationships', 'in': 'query', 'description': 'Whether to include MITRE category relationships or not (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'sortBy', 'in': 'query', 'description': "Field(s) to sort results by (without sign is ascending, with '-' sign is descending)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'limit', 'in': 'query', 'description': 'The max amount of items to return (25 by default, 0 means no limit)', 'schema': {'type': 'int', 'minimum': 0}, 'type': 'int', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'The amount of items to skip from the beginning (0 by default)', 'schema': {'type': 'int', 'minimum': 0}, 'type': 'int', 'minimum': 0}], 'responses': {'default': {'description': 'List MITRE categories', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}, 'url': {'type': 'string', 'description': 'URL of the external MITRE category page'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'relationships': {'type': 'array', 'description': 'Relationships that this MITRE category is participating in', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
list_mitre_category_relationships = {'tags': ['alarms/v1'], 'summary': 'List MITRE category relationships (DEV)', 'description': '', 'operationId': 'listMitreCategoryRelationships', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the source or target MITRE category (external ID requires additional query parameters: model, version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'model', 'in': 'query', 'description': 'Which threat model to use with external ID of the MITRE category', 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID of the MITRE category', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Whether to include deleted MITRE category relationships or not (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'sortBy', 'in': 'query', 'description': "Field(s) to sort results by (without sign is ascending, with '-' sign is descending)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'limit', 'in': 'query', 'description': 'The max amount of items to return (25 by default, 0 means no limit)', 'schema': {'type': 'int', 'minimum': 0}, 'type': 'int', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'The amount of items to skip from the beginning (0 by default)', 'schema': {'type': 'int', 'minimum': 0}, 'type': 'int', 'minimum': 0}], 'responses': {'default': {'description': 'List MITRE category relationships', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
list_mitre_model_versions = {'tags': ['alarms/v1'], 'summary': "Lists available MITRE model versions' info by model (DEV)", 'description': '', 'operationId': 'listMitreModelVersions', 'parameters': [{'name': 'model', 'in': 'path', 'description': 'Threat model of the MITRE category', 'required': True, 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}], 'responses': {'default': {'description': "Lists available MITRE model versions' info by model", 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE ATT&CK release'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE model version', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE model version', 'enum': ['default']}, 'uniqueItems': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
search_mitre_categories = {'tags': ['alarms/v1'], 'summary': 'Searches for MITRE categories (DEV)', 'description': '', 'operationId': 'searchMitreCategories', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'id': {'type': 'list', 'description': 'A set of IDs of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of IDs of the searched MITRE categories'}, 'uniqueItems': True}, 'externalId': {'type': 'list', 'description': 'A set of external IDs of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of external IDs of the searched MITRE categories'}, 'uniqueItems': True}, 'shortName': {'type': 'list', 'description': 'A set of short names of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of short names of the searched MITRE categories'}, 'uniqueItems': True}, 'type': {'type': 'list', 'description': 'A set of enumerated types of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of enumerated types of the searched MITRE categories', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'uniqueItems': True}, 'model': {'type': 'list', 'description': 'A set of enumerated threat models of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of enumerated threat models of the searched MITRE categories', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, 'version': {'type': 'list', 'description': 'A set of versions of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of versions of the searched MITRE categories'}, 'uniqueItems': True}, 'includeFlags': {'type': 'list', 'description': 'A set of included enumerated flags of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of included enumerated flags of the searched MITRE categories', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'A set of excluded enumerated flags of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of excluded enumerated flags of the searched MITRE categories', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'keywords': {'type': 'list', 'description': 'Keywords that are searched for in the fields of MITRE categories', 'items': {'type': 'str', 'description': 'Keywords that are searched for in the fields of MITRE categories'}}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'A set of fields of the MITRE categories where the keywords are searched', 'items': {'type': 'str', 'default': 'all', 'description': 'A set of fields of the MITRE categories where the keywords are searched', 'enum': ['id', 'externalId', 'shortName', 'name', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'Selected keyword matching strategy for searching in the fields of MITRE categories', 'enum': ['all', 'any']}, 'subCriteria': {'type': 'list', 'description': 'Set additional search criteria with AND, OR or AND NOT', 'items': {'type': 'dict', 'properties': {'id': {'type': 'list', 'description': 'A set of IDs of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of IDs of the searched MITRE categories'}, 'uniqueItems': True}, 'externalId': {'type': 'list', 'description': 'A set of external IDs of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of external IDs of the searched MITRE categories'}, 'uniqueItems': True}, 'shortName': {'type': 'list', 'description': 'A set of short names of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of short names of the searched MITRE categories'}, 'uniqueItems': True}, 'type': 'list', 'model': {'type': 'list', 'description': 'A set of enumerated threat models of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of enumerated threat models of the searched MITRE categories', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'uniqueItems': True}, 'version': {'type': 'list', 'description': 'A set of versions of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of versions of the searched MITRE categories'}, 'uniqueItems': True}, 'includeFlags': {'type': 'list', 'description': 'A set of included enumerated flags of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of included enumerated flags of the searched MITRE categories', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'A set of excluded enumerated flags of the searched MITRE categories', 'items': {'type': 'str', 'description': 'A set of excluded enumerated flags of the searched MITRE categories', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'keywords': {'type': 'list', 'description': 'Keywords that are searched for in the fields of MITRE categories', 'items': {'type': 'str', 'description': 'Keywords that are searched for in the fields of MITRE categories'}}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'A set of fields of the MITRE categories where the keywords are searched', 'items': {'type': 'str', 'default': 'all', 'description': 'A set of fields of the MITRE categories where the keywords are searched', 'enum': ['id', 'externalId', 'shortName', 'name', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'Selected keyword matching strategy for searching in the fields of MITRE categories', 'enum': ['all', 'any']}, 'required': {'type': 'bool', 'default': False, 'description': 'Is this sub-criteria required? If false it is OR-ed, if true it is AND-ed'}, 'exclude': {'type': 'bool', 'default': False, 'description': 'Exclude objects matching sub-criteria? If true, the criteria is NOT-ed.'}}}, 'uniqueItems': True}, 'includeRelationships': {'type': 'bool', 'default': False, 'description': 'Whether to include MITRE category relationships in search results or not'}, 'sortBy': {'type': 'list', 'default': 'shortName, -createdTimestamp', 'description': "Fields to sort results by (without sign is ascending, with '-' sign is descending)", 'items': {'type': 'str', 'default': 'shortName, -createdTimestamp', 'description': "Fields to sort results by (without sign is ascending, with '-' sign is descending)", 'enum': ['id', 'externalId', 'shortName', 'name', 'type', 'model', 'version', 'createdTimestamp', 'lastUpdatedTimestamp', 'deletedTimestamp', '-id', '-externalId', '-shortName', '-name', '-type', '-model', '-version', '-createdTimestamp', '-lastUpdatedTimestamp', '-deletedTimestamp']}}, 'limit': {'type': 'int', 'default': 25, 'description': 'The max amount of items to return', 'minimum': 0}, 'offset': {'type': 'int', 'default': 0, 'description': 'The amount of items to skip from the beginning', 'minimum': 0}}}}}, 'required': True}, 'responses': {'default': {'description': 'Searches for MITRE categories', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}, 'url': {'type': 'string', 'description': 'URL of the external MITRE category page'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'relationships': {'type': 'array', 'description': 'Relationships that this MITRE category is participating in', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
update_mitre_category = {'tags': ['alarms/v1'], 'summary': 'Updates an existing MITRE category (DEV)', 'description': '', 'operationId': 'updateMitreCategory', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category (external ID requires additional query parameters: model, version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'model', 'in': 'query', 'description': 'Which threat model to use with external ID', 'schema': {'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'type': 'str', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID', 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'name': {'type': 'str', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'str', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'url': {'type': 'str', 'description': 'URL of the external MITRE category page', 'pattern': '((https?|ftp|gopher|telnet|file):((/)|(\\\\))+[\\w\\d:\\#@%/;$()~_?\\\\+-=\\\\\\.&]*)'}, 'deprecated': {'type': 'bool', 'description': 'A boolean flag indicating if the MITRE category is deprecated'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Updates an existing MITRE category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}, 'url': {'type': 'string', 'description': 'URL of the external MITRE category page'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the MITRE category', 'enum': ['deprecated', 'deleted']}, 'uniqueItems': True}, 'relationships': {'type': 'array', 'description': 'Relationships that this MITRE category is participating in', 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the MITRE category deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '220': {'description': 'No update was performed', 'content': {'application/json': {}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateMitreCategory'], 'x-Argus-ApiStatus': 'DEV'}
update_mitre_category_relationship = {'tags': ['alarms/v1'], 'summary': 'Updates an existing MITRE category relationship (DEV)', 'description': '', 'operationId': 'updateMitreCategoryRelationship', 'parameters': [{'name': 'idOrExtId', 'in': 'path', 'description': 'ID or external ID of the MITRE category relationship (external ID requires an additional query parameter: version)', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}, {'name': 'version', 'in': 'query', 'description': 'Which version to use with external ID', 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'type': {'type': 'str', 'description': 'Enumerated type of the MITRE category relationship', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}}}}}, 'required': True}, 'responses': {'default': {'description': 'Updates an existing MITRE category relationship', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the relationship between MITRE categories'}, 'sourceCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'targetCategory': {'type': 'object', 'description': 'Info object of the MITRE category that is part of the relationship', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'externalId': {'type': 'string', 'format': 'uuid', 'description': 'External ID of the MITRE category'}, 'shortName': {'type': 'string', 'description': 'Short name of the MITRE category'}, 'name': {'type': 'string', 'description': 'Detailed name of the MITRE category'}, 'type': {'type': 'string', 'description': 'Enumerated type of the MITRE category', 'enum': ['tactic', 'technique', 'subtechnique', 'mitigation', 'threatActor', 'malware', 'tool', 'campaign']}, 'model': {'type': 'string', 'description': 'Enumerated threat model of the MITRE category', 'enum': ['capec', 'enterprise', 'ics', 'mobile', 'preAttack']}, 'version': {'type': 'string', 'description': 'Version of the MITRE category (MITRE ATT&CK release)'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the relationship between MITRE categories', 'enum': ['subtechniqueOf', 'revokedBy', 'mitigates', 'uses']}, 'version': {'type': 'string', 'description': 'Version of the relationship (MITRE ATT&CK release), has to match the version of the related MITRE categories'}, 'flags': {'type': 'array', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'items': {'type': 'string', 'description': 'Enumerated flags reflecting the state of the relationship between MITRE categories', 'enum': ['deleted']}, 'uniqueItems': True}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories created'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories updated'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the relationship between MITRE categories deleted'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}, '220': {'description': 'No update was performed', 'content': {'application/json': {}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateMitreCategoryRelationship'], 'x-Argus-ApiStatus': 'DEV'}