"""Autogenerated API schema"""
from argus_api import session


delete_signatures = {'tags': ['alarms/v1'], 'summary': 'Delete signatures. They must not be mapped to any alarms. (INTERNAL)', 'description': '', 'operationId': 'deleteSignatures', 'parameters': [{'name': 'signature', 'in': 'query', 'description': 'Signatures to delete', 'required': True, 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Delete signatures. They must not be mapped to any alarms.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': [], 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteAlarmMapping'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_signatures = {'tags': ['alarms/v1'], 'summary': 'Get all signatures within your access scope. Alarm data is included if signature is mapped. (PUBLIC)', 'description': '', 'operationId': 'getSignatures', 'parameters': [{'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywordMatch', 'in': 'query', 'description': 'Set match strategy for keyword search', 'schema': {'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, 'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, {'name': 'keywordField', 'in': 'query', 'description': 'Set field strategy for keyword search', 'schema': {'type': 'list', 'default': 'all', 'items': {'type': 'str', 'enum': ['description', 'signature', 'signatureMessage', 'all']}, 'uniqueItems': True}, 'type': 'list', 'default': 'all', 'items': {'type': 'str', 'enum': ['description', 'signature', 'signatureMessage', 'all']}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of signatures', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned signatures', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'Get all signatures within your access scope. Alarm data is included if signature is mapped.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': [], 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarmMapping'], 'x-Argus-ApiStatus': 'PUBLIC'}
search_signatures = {'tags': ['alarms/v1'], 'summary': 'Get all signatures matching a given search criteria within your access scope (PUBLIC)', 'description': '', 'operationId': 'searchSignatures', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'attackCategoryID': {'type': 'list', 'description': 'A set of IDs for attack categories (alarm category).', 'items': {'type': 'int', 'description': 'A set of IDs for attack categories (alarm category).'}, 'uniqueItems': True}, 'alarmID': {'type': 'list', 'description': 'A set of IDs for alarms.', 'items': {'type': 'int', 'description': 'A set of IDs for alarms.'}, 'uniqueItems': True}, 'signature': {'type': 'list', 'description': 'A set of signatures. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of signatures. It does an exact match.'}, 'uniqueItems': True}, 'minTriggerAmount': {'type': 'int', 'description': 'Minimum trigger amount, default 0 means disabled'}, 'maxTriggerAmount': {'type': 'int', 'description': 'Maximum trigger amount, default 0 means disabled'}, 'startTimestamp': {'type': 'str', 'description': 'Only include mappings based on the set TimeFieldStrategy and TimeMatchStrategy (start timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Only include mappings based on the set TimeFieldStrategy and TimeMatchStrategy (end timestamp).\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeFieldStrategy': {'type': 'list', 'default': 'lastTriggeredTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'items': {'type': 'str', 'default': 'lastTriggeredTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'enum': ['firstTriggeredTimestamp', 'lastTriggeredTimestamp', 'mappedTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'TimeMatchStrategy to define how to match startTimestamp and endTimestamp with fields.', 'enum': ['all', 'any']}, 'keywords': {'type': 'list', 'description': 'A set of keywords matched against mappings based on the set KeywordFieldStrategy and KeywordMatchStrategy.', 'items': {'type': 'str', 'description': 'A set of keywords matched against mappings based on the set KeywordFieldStrategy and KeywordMatchStrategy.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'items': {'type': 'str', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'enum': ['description', 'signature', 'signatureMessage', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'KeywordMatchStrategy to define how to match keywords with fields.', 'enum': ['all', 'any']}, 'attackIdentifier': [], 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['signature', 'signatureMessage', 'firstTriggeredTimestamp', 'lastTriggeredTimestamp', 'lastUpdatedTimestamp', 'mappedTimestamp', 'triggerAmount', '-signature', '-signatureMessage', '-firstTriggeredTimestamp', '-lastTriggeredTimestamp', '-lastUpdatedTimestamp', '-mappedTimestamp', '-triggerAmount']}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'attackCategoryID': {'type': 'list', 'description': 'A set of IDs for attack categories (alarm category).', 'items': {'type': 'int', 'description': 'A set of IDs for attack categories (alarm category).'}, 'uniqueItems': True}, 'alarmID': {'type': 'list', 'description': 'A set of IDs for alarms.', 'items': {'type': 'int', 'description': 'A set of IDs for alarms.'}, 'uniqueItems': True}, 'signature': {'type': 'list', 'description': 'A set of signatures. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of signatures. It does an exact match.'}, 'uniqueItems': True}, 'minTriggerAmount': {'type': 'int', 'description': 'Minimum trigger amount, default 0 means disabled'}, 'maxTriggerAmount': {'type': 'int', 'description': 'Maximum trigger amount, default 0 means disabled'}, 'startTimestamp': {'type': 'str', 'description': 'Only include mappings based on the set TimeFieldStrategy and TimeMatchStrategy (start timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Only include mappings based on the set TimeFieldStrategy and TimeMatchStrategy (end timestamp).\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeFieldStrategy': {'type': 'list', 'default': 'lastTriggeredTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'items': {'type': 'str', 'default': 'lastTriggeredTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'enum': ['firstTriggeredTimestamp', 'lastTriggeredTimestamp', 'mappedTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'TimeMatchStrategy to define how to match startTimestamp and endTimestamp with fields.', 'enum': ['all', 'any']}, 'keywords': {'type': 'list', 'description': 'A set of keywords matched against mappings based on the set KeywordFieldStrategy and KeywordMatchStrategy.', 'items': {'type': 'str', 'description': 'A set of keywords matched against mappings based on the set KeywordFieldStrategy and KeywordMatchStrategy.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'items': {'type': 'str', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'enum': ['description', 'signature', 'signatureMessage', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'KeywordMatchStrategy to define how to match keywords with fields.', 'enum': ['all', 'any']}, 'attackIdentifier': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'attackCategoryID': {'type': 'list', 'description': 'A set of IDs for attack categories (alarm category).', 'items': {'type': 'int', 'description': 'A set of IDs for attack categories (alarm category).'}, 'uniqueItems': True}, 'alarmID': {'type': 'list', 'description': 'A set of IDs for alarms.', 'items': {'type': 'int', 'description': 'A set of IDs for alarms.'}, 'uniqueItems': True}, 'signature': {'type': 'list', 'description': 'A set of signatures. It does an exact match.', 'items': {'type': 'str', 'description': 'A set of signatures. It does an exact match.'}, 'uniqueItems': True}, 'minTriggerAmount': {'type': 'int', 'description': 'Minimum trigger amount, default 0 means disabled'}, 'maxTriggerAmount': {'type': 'int', 'description': 'Maximum trigger amount, default 0 means disabled'}, 'startTimestamp': {'type': 'str', 'description': 'Only include mappings based on the set TimeFieldStrategy and TimeMatchStrategy (start timestamp)\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Only include mappings based on the set TimeFieldStrategy and TimeMatchStrategy (end timestamp).\nTimestamps can be milliseconds since epoch, ISO8601 timestamp, or a string with a relative timestamp.\nSee the general integration guide for more details.\n  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeFieldStrategy': {'type': 'list', 'default': 'lastTriggeredTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'items': {'type': 'str', 'default': 'lastTriggeredTimestamp', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match.', 'enum': ['firstTriggeredTimestamp', 'lastTriggeredTimestamp', 'mappedTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'TimeMatchStrategy to define how to match startTimestamp and endTimestamp with fields.', 'enum': ['all', 'any']}, 'keywords': {'type': 'list', 'description': 'A set of keywords matched against mappings based on the set KeywordFieldStrategy and KeywordMatchStrategy.', 'items': {'type': 'str', 'description': 'A set of keywords matched against mappings based on the set KeywordFieldStrategy and KeywordMatchStrategy.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'items': {'type': 'str', 'default': 'all', 'description': 'KeywordFieldStrategy to define which field(s) to match against keywords.', 'enum': ['description', 'signature', 'signatureMessage', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'KeywordMatchStrategy to define how to match keywords with fields.', 'enum': ['all', 'any']}, 'attackIdentifier': [], 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['signature', 'signatureMessage', 'firstTriggeredTimestamp', 'lastTriggeredTimestamp', 'lastUpdatedTimestamp', 'mappedTimestamp', 'triggerAmount', '-signature', '-signatureMessage', '-firstTriggeredTimestamp', '-lastTriggeredTimestamp', '-lastUpdatedTimestamp', '-mappedTimestamp', '-triggerAmount']}}}}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['signature', 'signatureMessage', 'firstTriggeredTimestamp', 'lastTriggeredTimestamp', 'lastUpdatedTimestamp', 'mappedTimestamp', 'triggerAmount', '-signature', '-signatureMessage', '-firstTriggeredTimestamp', '-lastTriggeredTimestamp', '-lastUpdatedTimestamp', '-mappedTimestamp', '-triggerAmount']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Get all signatures matching a given search criteria within your access scope', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': {'type': 'object', 'description': 'Signatures mapped to the alarm.', 'properties': {'alarm': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}, 'attackCategory': {'type': 'object', 'description': 'Category of the alarm.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'shortName': {'type': 'string', 'description': 'Short name of the category.'}, 'info': {'type': 'string', 'description': 'Short information about the category.'}, 'name': {'type': 'string', 'description': 'Name of the category.'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category created.'}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category updated.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When was the category deleted.'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'name': {'type': 'string', 'description': "The subject's name"}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'RECONNAISSANCE', 'DELETED']}, 'uniqueItems': True}}}, 'mappings': {'type': 'array', 'description': 'Signatures mapped to the alarm.', 'items': [], 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'comments': {'type': 'array', 'description': 'Comments added to the alarm.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'references': {'type': 'array', 'description': 'Further references to the alarm.', 'items': {'type': 'string', 'description': 'Further references to the alarm.'}, 'uniqueItems': True}, 'labels': {'type': 'array', 'description': 'Label assigned to the alarm.', 'items': {'type': 'string', 'description': 'Label assigned to the alarm.'}, 'uniqueItems': True}, 'info': {'type': 'string', 'description': 'Verbose information about the alarm.  (@SafeHTML)', 'x-safe-html': True}, 'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'internalReference': {'type': 'string', 'description': 'An internal link with info about the alarm. Will be omitted if user does not have required permissions'}, 'internalInformation': {'type': 'string', 'description': 'Internal information about handling the alarm. Describes how the alarm should be handled by SOC.  (@SafeHTML)', 'x-safe-html': True}, 'links': {'type': 'array', 'description': 'Links added to the alarm.', 'items': {'type': 'string', 'description': 'Links added to the alarm.'}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was created.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last updated.'}, 'lastCheckedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm was last checked.'}, 'nextCheckTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the alarm should be checked next.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DISABLED', 'DELETED']}, 'uniqueItems': True}}}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the mapping was last updated.'}, 'comments': {'type': 'array', 'description': 'Comments added to the mapping.', 'items': {'type': 'object', 'description': 'Comments added to the mapping.', 'properties': {'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'comment': {'type': 'string', 'description': "The comment's text."}}}}, 'mappedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was mapped.'}, 'mappedByUser': {'type': 'object', 'description': 'Who mapped the signature.', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'firstTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was first triggered.'}, 'lastTriggeredTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the signature was last triggered.'}, 'triggerAmount': {'type': 'integer', 'format': 'int64', 'description': 'How often the signature was triggered.'}, 'signature': {'type': 'string', 'description': 'Signature mapped to alarm.'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEFAULT_BLOCK', 'SNORT', 'ISS_SIGNATURE']}, 'uniqueItems': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAlarmMapping'], 'x-Argus-ApiStatus': 'PUBLIC'}