"""Autogenerated API schema"""
from argus_api import session


get_unauthenticated_client_info = {'tags': ['authentication/v1'], 'summary': 'Return information about the client, as seen from the server. (PUBLIC)', 'description': 'This endpoint does not require the client to be authenticated, and will only return open information.', 'operationId': 'getUnauthenticatedClientInfo', 'responses': {'default': {'description': 'Return information about the client, as seen from the server.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Information about the currently connected (unauthenticated) client.', 'properties': {'clientIP': {'type': 'string', 'description': 'The IP of the connected client (as seen from the server)'}}}}}}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}