"""Autogenerated API schema"""
from argus_api import session


get_aws_options = {'tags': ['authentication/v1/apikey'], 'summary': 'Options currently available to create API-keys for AWS (PUBLIC)', 'description': 'Returns a response of available services and regions for the specified cloud provider.If the provider is currently unavailable, a 412 HTTP status code will be returned', 'operationId': 'getAWSOptions', 'responses': {'default': {'description': 'Options currently available to create API-keys for AWS', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Response for request to create API key for AWS', 'properties': {'regions': {'type': 'array', 'description': 'AWS regions the API key should be valid for', 'items': {'type': 'string', 'description': 'AWS regions the API key should be valid for'}, 'uniqueItems': True}, 'services': {'type': 'array', 'description': 'AWS services the API key should be valid for', 'items': {'type': 'string', 'description': 'AWS services the API key should be valid for'}, 'uniqueItems': True}}}}}}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}
get_azure_options = {'tags': ['authentication/v1/apikey'], 'summary': 'Options currently available to create API-keys for Azure (PUBLIC)', 'description': 'Returns a response of available services and regions for the specified cloud provider.If the provider is currently unavailable, a 412 HTTP status code will be returned', 'operationId': 'getAzureOptions', 'responses': {'default': {'description': 'Options currently available to create API-keys for Azure', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Response for request to create API key for Azure instances', 'properties': {'regions': {'type': 'array', 'description': 'Azure regions the API key should be valid for', 'items': {'type': 'string', 'description': 'Azure regions the API key should be valid for'}, 'uniqueItems': True}, 'services': {'type': 'array', 'description': 'Azure services the API key should be valid for', 'items': {'type': 'string', 'description': 'Azure services the API key should be valid for'}, 'uniqueItems': True}}}}}}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}
get_github_options = {'tags': ['authentication/v1/apikey'], 'summary': 'Options currently available to create API-keys for GitHub (PUBLIC)', 'description': 'Returns a response of available services for the specified cloud provider.If the provider is currently unavailable, a 412 HTTP status code will be returned', 'operationId': 'getGithubOptions', 'responses': {'default': {'description': 'Options currently available to create API-keys for GitHub', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Response for creating API key for Github services', 'properties': {'services': {'type': 'array', 'description': 'Github services the API key should be valid for', 'items': {'type': 'string', 'description': 'Github services the API key should be valid for'}, 'uniqueItems': True}}}}}}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}