"""Autogenerated API schema"""
from argus_api import session


get_current_user_authentication_events = {'tags': ['authentication/v1'], 'summary': 'List authentication events for the current user (PUBLIC)', 'description': 'Returns a list of authentication events for the current user', 'operationId': 'getCurrentUserAuthenticationEvents', 'parameters': [{'name': 'startTimestamp', 'in': 'query', 'description': 'Limit search to events after this timestamp (inclusive). May use millis since epoch, ISO-8601, or relative time format.', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'endTimestamp', 'in': 'query', 'description': 'Limit search to events before this timestamp (inclusive). May use millis since epoch, ISO-8601, or relative time format.', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'limit', 'in': 'query', 'description': 'Limit number of results', 'schema': {'type': 'int', 'default': '25'}, 'type': 'int', 'default': '25'}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}], 'responses': {'default': {'description': 'List authentication events for the current user', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'action': {'type': 'string', 'description': 'Action which was recorded.', 'enum': ['login', 'loginChallenge', 'smsDelivery', 'keyEnrolled', 'userBlocked', 'userUnblocked', 'enrollment', 'enrollmentDisabled', 'enrollmentChallenge', 'totpEnrolled']}, 'authenticationMethod': {'type': 'string', 'description': 'Related authentication method for this event. May be null.', 'enum': ['password', 'signature', 'sms', 'totp', 'apikey', 'ldap', 'openid', 'enrollment', 'impersonated']}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of this record'}, 'ip': {'type': 'string', 'description': 'IP of the client associated with this event. May be null for non-client events.'}, 'message': {'type': 'string', 'description': 'Specific message recorded for the action'}, 'result': {'type': 'string', 'description': 'Generic result for the action.', 'enum': ['success', 'failure']}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this event was recorded'}}}}}}}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}