"""Autogenerated API schema"""
from argus_api import session


create_category = {'tags': ['cases/v2/category'], 'summary': 'Add category (INTERNAL)', 'description': '', 'operationId': 'createCategory', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'description': {'type': 'str', 'description': 'Longer description of this category.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to create this category in.'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized descriptions. If not set, localized description will fallback to main description.'}, 'description': 'Localized descriptions. If not set, localized description will fallback to main description.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized names. If not set, locales will fallback to main name.'}, 'description': 'Localized names. If not set, locales will fallback to main name.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'name': {'type': 'str', 'description': 'Descriptive name of category to add.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'shortName': {'type': 'str', 'description': 'Shortname for the category. This value must be unique in domain.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}}, 'required': ['description', 'domain', 'name', 'shortName']}}}, 'required': True}, 'responses': {'default': {'description': 'Add category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addCategory'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_category = {'tags': ['cases/v2/category'], 'summary': 'Delete category (INTERNAL)', 'description': '', 'operationId': 'deleteCategory', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of category to delete', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Delete category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteCategory'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_category = {'tags': ['cases/v2/category'], 'summary': 'Fetch category (INTERNAL)', 'description': '', 'operationId': 'getCategory', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of category to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_categories = {'tags': ['cases/v2/category'], 'summary': 'List categories (INTERNAL)', 'description': '', 'operationId': 'listCategories', 'parameters': [{'name': 'id', 'in': 'query', 'description': 'List of category IDs to match', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'shortName', 'in': 'query', 'description': 'List of category shortnames to match', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort order (see /cases/v2/category/search documentation for details)', 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List categories', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_categories = {'tags': ['cases/v2/category'], 'summary': 'Search categories (INTERNAL)', 'description': '', 'operationId': 'searchCategories', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'id': {'type': 'list', 'description': 'Limit search to categories with the specified numeric ID`s.', 'items': {'type': 'int', 'description': 'Limit search to categories with the specified numeric ID`s.'}, 'uniqueItems': True}, 'shortName': {'type': 'list', 'description': 'Limit search to categories with the specified shortnames', 'items': {'type': 'str', 'description': 'Limit search to categories with the specified shortnames'}, 'uniqueItems': True}, 'service': {'type': 'list', 'description': 'Limit search to categories bound to one of these services (by ID or service shortname)', 'items': {'type': 'str', 'description': 'Limit search to categories bound to one of these services (by ID or service shortname)'}, 'uniqueItems': True}, 'caseType': {'type': 'list', 'description': 'Limit search to categories bound to one of these case types', 'items': {'type': 'str', 'description': 'Limit search to categories bound to one of these case types', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'items': {'type': 'str', 'enum': ['id', 'name', 'localizedName', 'shortName', '-id', '-name', '-localizedName', '-shortName']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'id': {'type': 'list', 'description': 'Limit search to categories with the specified numeric ID`s.', 'items': {'type': 'int', 'description': 'Limit search to categories with the specified numeric ID`s.'}, 'uniqueItems': True}, 'shortName': {'type': 'list', 'description': 'Limit search to categories with the specified shortnames', 'items': {'type': 'str', 'description': 'Limit search to categories with the specified shortnames'}, 'uniqueItems': True}, 'service': {'type': 'list', 'description': 'Limit search to categories bound to one of these services (by ID or service shortname)', 'items': {'type': 'str', 'description': 'Limit search to categories bound to one of these services (by ID or service shortname)'}, 'uniqueItems': True}, 'caseType': {'type': 'list', 'description': 'Limit search to categories bound to one of these case types', 'items': {'type': 'str', 'description': 'Limit search to categories bound to one of these case types', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'items': {'type': 'str', 'enum': ['id', 'name', 'localizedName', 'shortName', '-id', '-name', '-localizedName', '-shortName']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search categories', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_category = {'tags': ['cases/v2/category'], 'summary': 'Update category (INTERNAL)', 'description': '', 'operationId': 'updateCategory', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of category to update', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'deprecated': {'type': 'bool', 'description': 'If set, enable/disable the deprecated flag for this category. Default is no change.'}, 'description': {'type': 'str', 'description': 'If set, change the long description for this category.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Set localized descriptions to override description for specified language. Only specified languages are changed.'}, 'description': 'Set localized descriptions to override description for specified language. Only specified languages are changed.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Set localized names to override name for specified language. Only specified languages are changed.'}, 'description': 'Set localized names to override name for specified language. Only specified languages are changed.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'name': {'type': 'str', 'description': 'If set, change the descriptive name for this category.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'shortName': {'type': 'str', 'description': 'If set, change the shortname name for this category. WARNING: This may affect scripts using the category name.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateCategory'], 'x-Argus-ApiStatus': 'INTERNAL'}