"""Autogenerated API schema"""
from argus_api import session


add_field_policy = {'tags': ['cases/v2/field'], 'summary': 'Define new field policy. (INTERNAL)', 'description': '', 'operationId': 'addFieldPolicy', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'name': {'type': 'str', 'description': 'Name of policy to add.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to create this policy in.'}, 'customer': {'type': 'str', 'description': 'Name or ID of customer to create this policy for (optional).'}, 'customerID': {'type': 'dict', 'properties': {'name': {'type': 'str', 'description': 'Name of policy to add.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to create this policy in.'}, 'customer': {'type': 'str', 'description': 'Name or ID of customer to create this policy for (optional).'}, 'customerID': [], 'domainID': []}, 'required': ['domain', 'name']}, 'domainID': {'type': 'dict', 'properties': {'name': {'type': 'str', 'description': 'Name of policy to add.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to create this policy in.'}, 'customer': {'type': 'str', 'description': 'Name or ID of customer to create this policy for (optional).'}, 'customerID': [], 'domainID': []}, 'required': ['domain', 'name']}}, 'required': ['domain', 'name']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Define new field policy.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
add_field_to_policy = {'tags': ['cases/v2/field'], 'summary': 'Bind a field to a policy (INTERNAL)', 'description': 'Bind a field to a policy. This can be done on active policies, and will make the specified field available on the cases covered by the policy. After adding a field with a required policy, affected cases without this field will start requiring the field on the next update.', 'operationId': 'addFieldToPolicy', 'parameters': [{'name': 'policy', 'in': 'path', 'description': 'ID or name of policy to bind field to', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for policy in (when using policy name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'displayIn': {'type': 'list', 'description': 'The display options for the field. If not set the field will not be required in any context', 'items': {'type': 'str', 'description': 'The display options for the field. If not set the field will not be required in any context', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'str', 'description': 'Display name for field. Default is field name.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'field': {'type': 'str', 'description': 'ID or field name of field to add to policy.'}, 'fieldPolicy': {'type': 'str', 'description': 'DEPRECATED\nFieldPolicy for this field.\n"If the field is requiredOnCreate, a case cannot be created without this field, unless a defaultValue is set in the field fieldPolicy.\n"If the field is requiredOnClose, the case cannot be closed before this field has been set.\n"Default fieldPolicy is optional.\n', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}, 'required': ['field', 'fieldPolicy']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Bind a field to a policy', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
create_field_descriptor = {'tags': ['cases/v2/field'], 'summary': 'Define new field descriptor. (INTERNAL)', 'description': '', 'operationId': 'createFieldDescriptor', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'shortName': {'type': 'str', 'description': 'Shortname of field to add. If not specified, it will be set to a lowercase, concatenated shortname based on the name.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'name': {'type': 'str', 'description': 'Name of field to add.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized names. If not set, locales will fallback to main name.'}, 'description': 'Localized names. If not set, locales will fallback to main name.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized descriptions. If not set, localizedDescription will return null.'}, 'description': 'Localized descriptions. If not set, localizedDescription will return null.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to create this field in.'}, 'customer': {'type': 'str', 'description': 'Name or ID of customer to create this field for (optional).'}, 'valueType': {'type': 'str', 'description': 'Value type for the field.The field will only accept values that can be safely converted to this value type. If the field uses an autocompleter, the autocompleter should convert user input to valid values of this type. Default type is stringType.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'multiValue': {'type': 'bool', 'description': 'If multiValue is enabled, this field will accept multiple values of the specified type (optional).'}, 'defaultValue': {'type': 'str', 'description': 'The default value to populate this field with. (optional, default is not set).'}, 'validator': {'type': 'dict', 'properties': {'assetSettings': {'type': 'dict', 'properties': {'sameCustomer': {'type': 'bool', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'dict', 'properties': {'caseType': {'type': 'str', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'str', 'description': 'If set, only allow cases with this category.'}, 'sameCustomer': {'type': 'bool', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'str', 'description': 'If set, only allow cases for this service.'}}}, 'documentSettings': {'type': 'dict', 'properties': {'sameCustomer': {'type': 'bool', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'dict', 'properties': {'maximum': {'type': 'float', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'float', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'dict', 'properties': {'maximum': {'type': 'int', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'int', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'dict', 'properties': {'ipVersion': {'type': 'str', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'jsonSettings': {'type': 'object'}, 'stringSettings': {'type': 'dict', 'properties': {'maxLength': {'type': 'int', 'description': 'Max length for this field. With no maxLength, the system maximum is 255 characters.'}, 'regex': {'type': 'str', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'dict', 'properties': {'memberOf': {'type': 'int', 'description': 'If set, only allow subjects which are member of this group'}, 'requiredPermission': {'type': 'str', 'description': 'If set, only allow subjects which have this permission granted.'}, 'sameCustomer': {'type': 'bool', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'str', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'dict', 'properties': {'maxLength': {'type': 'int', 'description': 'Max length for this field. With no maxLength, the system maximum is 65k.'}}}}}, 'valueSource': {'type': 'dict', 'properties': {'listType': {'type': 'dict', 'properties': {'entries': {'type': 'list', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label. Use either parameter entries or the parameter values. ', 'items': {'type': 'dict', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}, 'values': {'type': 'list', 'description': 'For valuesource of type list, values specifies a set of available values. This is a shorthand notation for a list of entries with equal key/label.', 'items': {'type': 'str', 'description': 'For valuesource of type list, values specifies a set of available values. This is a shorthand notation for a list of entries with equal key/label.'}}}}, 'urlType': {'type': 'dict', 'properties': {'queryURL': {'type': 'str', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'rendererOptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Renderer options. Only for use by the Argus frontend application (optional).'}, 'description': 'Renderer options. Only for use by the Argus frontend application (optional).'}, 'readRole': {'type': 'str', 'description': "Required service role to read this field. Default is 'user', meaning that any user with read access to the case, can also read this field.", 'enum': ['user', 'tech', 'admin']}, 'writeRole': {'type': 'str', 'description': "Required service role to set/update this field. Default is 'user', meaning that any user with write access to the case, can also write to this field.", 'enum': ['user', 'tech', 'admin']}, 'hidden': {'type': 'bool', 'default': False, 'description': 'Mark this field as hidden. Hidden fields will not be displayed in the UI.'}, 'customerID': {'type': 'dict', 'properties': {'shortName': {'type': 'str', 'description': 'Shortname of field to add. If not specified, it will be set to a lowercase, concatenated shortname based on the name.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'name': {'type': 'str', 'description': 'Name of field to add.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized names. If not set, locales will fallback to main name.'}, 'description': 'Localized names. If not set, locales will fallback to main name.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized descriptions. If not set, localizedDescription will return null.'}, 'description': 'Localized descriptions. If not set, localizedDescription will return null.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to create this field in.'}, 'customer': {'type': 'str', 'description': 'Name or ID of customer to create this field for (optional).'}, 'valueType': {'type': 'str', 'description': 'Value type for the field.The field will only accept values that can be safely converted to this value type. If the field uses an autocompleter, the autocompleter should convert user input to valid values of this type. Default type is stringType.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'multiValue': {'type': 'bool', 'description': 'If multiValue is enabled, this field will accept multiple values of the specified type (optional).'}, 'defaultValue': {'type': 'str', 'description': 'The default value to populate this field with. (optional, default is not set).'}, 'validator': {'type': 'dict', 'properties': {'assetSettings': {'type': 'dict', 'properties': {'sameCustomer': {'type': 'bool', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'dict', 'properties': {'caseType': {'type': 'str', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'str', 'description': 'If set, only allow cases with this category.'}, 'sameCustomer': {'type': 'bool', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'str', 'description': 'If set, only allow cases for this service.'}}}, 'documentSettings': {'type': 'dict', 'properties': {'sameCustomer': {'type': 'bool', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'dict', 'properties': {'maximum': {'type': 'float', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'float', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'dict', 'properties': {'maximum': {'type': 'int', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'int', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'dict', 'properties': {'ipVersion': {'type': 'str', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'jsonSettings': {'type': 'object'}, 'stringSettings': {'type': 'dict', 'properties': {'maxLength': {'type': 'int', 'description': 'Max length for this field. With no maxLength, the system maximum is 255 characters.'}, 'regex': {'type': 'str', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'dict', 'properties': {'memberOf': {'type': 'int', 'description': 'If set, only allow subjects which are member of this group'}, 'requiredPermission': {'type': 'str', 'description': 'If set, only allow subjects which have this permission granted.'}, 'sameCustomer': {'type': 'bool', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'str', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'dict', 'properties': {'maxLength': {'type': 'int', 'description': 'Max length for this field. With no maxLength, the system maximum is 65k.'}}}}}, 'valueSource': {'type': 'dict', 'properties': {'listType': {'type': 'dict', 'properties': {'entries': {'type': 'list', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label. Use either parameter entries or the parameter values. ', 'items': {'type': 'dict', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}, 'values': {'type': 'list', 'description': 'For valuesource of type list, values specifies a set of available values. This is a shorthand notation for a list of entries with equal key/label.', 'items': {'type': 'str', 'description': 'For valuesource of type list, values specifies a set of available values. This is a shorthand notation for a list of entries with equal key/label.'}}}}, 'urlType': {'type': 'dict', 'properties': {'queryURL': {'type': 'str', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'rendererOptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Renderer options. Only for use by the Argus frontend application (optional).'}, 'description': 'Renderer options. Only for use by the Argus frontend application (optional).'}, 'readRole': {'type': 'str', 'description': "Required service role to read this field. Default is 'user', meaning that any user with read access to the case, can also read this field.", 'enum': ['user', 'tech', 'admin']}, 'writeRole': {'type': 'str', 'description': "Required service role to set/update this field. Default is 'user', meaning that any user with write access to the case, can also write to this field.", 'enum': ['user', 'tech', 'admin']}, 'hidden': {'type': 'bool', 'default': False, 'description': 'Mark this field as hidden. Hidden fields will not be displayed in the UI.'}, 'customerID': []}, 'required': ['domain', 'name', 'readRole', 'valueType', 'writeRole']}}, 'required': ['domain', 'name', 'readRole', 'valueType', 'writeRole']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Define new field descriptor.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this descriptor was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this field.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'defaultValue': {'type': 'string', 'description': 'The default value of this field, if the field is not set. If defaultValue is not set, the field will not be regarded as set on the case until a value is provided.'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this descriptor was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this field.'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'readRole': {'type': 'string', 'description': 'The service role required to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'deprecated': True, 'description': 'Options to the GUI renderer.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'validator': {'type': 'object', 'description': 'The validator controlling this field. The value type determines which fields are displayed in validator.', 'properties': {'assetSettings': {'type': 'object', 'description': 'Validator settings for value type asset.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'object', 'description': 'Validator settings for value type case.', 'properties': {'caseType': {'type': 'string', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'documentSettings': {'type': 'object', 'description': 'Validator settings for value type document.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'object', 'description': 'Validator settings for value type float.', 'properties': {'maximum': {'type': 'number', 'format': 'double', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'number', 'format': 'double', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'object', 'description': 'Validator settings for value type integer.', 'properties': {'maximum': {'type': 'integer', 'format': 'int32', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'integer', 'format': 'int32', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'object', 'description': 'Validator settings for value type ip.', 'properties': {'ipVersion': {'type': 'string', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'stringSettings': {'type': 'object', 'description': 'Validator settings for value type string.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}, 'regex': {'type': 'string', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'object', 'description': 'Validator settings for value type subject.', 'properties': {'memberOf': {'allOf': [{'type': 'object', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'properties': {'description': {'type': 'object'}, 'type': {'type': 'string', 'enum': ['group']}}}], 'required': ['type']}, 'requiredPermission': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'string', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'object', 'description': 'Validator settings for value type text.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}}}}}, 'valueSource': {'type': 'object', 'description': 'The value source for this field. Used by GUI/client to lookup input values. If not set, no value completion is configured.', 'properties': {'listType': {'type': 'object', 'properties': {'entries': {'type': 'array', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'items': {'type': 'object', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}}}, 'type': {'type': 'string', 'description': 'A valuesource may be of type list or url. A url valuesource searches/fetches values from an external endpoint, while a list valuesource provides a static list of values (for lookup and search).', 'enum': ['url', 'list']}, 'urlType': {'type': 'object', 'properties': {'queryURL': {'type': 'string', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'string', 'description': 'The service role required to set/update this field.', 'enum': ['user', 'tech', 'admin']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_field_descriptor = {'tags': ['cases/v2/field'], 'summary': 'Delete a field descriptor. (INTERNAL)', 'description': 'Delete a field descriptor. This will mark the field as deleted, and will deny using the field in policies. Deleting the field will be rejected if the field is still in use in any field policy.', 'operationId': 'deleteFieldDescriptor', 'parameters': [{'name': 'field', 'in': 'path', 'description': 'ID or name of descriptor to delete', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for field in (when using field name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Delete a field descriptor.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this descriptor was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this field.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'defaultValue': {'type': 'string', 'description': 'The default value of this field, if the field is not set. If defaultValue is not set, the field will not be regarded as set on the case until a value is provided.'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this descriptor was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this field.'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'readRole': {'type': 'string', 'description': 'The service role required to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'deprecated': True, 'description': 'Options to the GUI renderer.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'validator': {'type': 'object', 'description': 'The validator controlling this field. The value type determines which fields are displayed in validator.', 'properties': {'assetSettings': {'type': 'object', 'description': 'Validator settings for value type asset.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'object', 'description': 'Validator settings for value type case.', 'properties': {'caseType': {'type': 'string', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'documentSettings': {'type': 'object', 'description': 'Validator settings for value type document.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'object', 'description': 'Validator settings for value type float.', 'properties': {'maximum': {'type': 'number', 'format': 'double', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'number', 'format': 'double', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'object', 'description': 'Validator settings for value type integer.', 'properties': {'maximum': {'type': 'integer', 'format': 'int32', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'integer', 'format': 'int32', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'object', 'description': 'Validator settings for value type ip.', 'properties': {'ipVersion': {'type': 'string', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'stringSettings': {'type': 'object', 'description': 'Validator settings for value type string.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}, 'regex': {'type': 'string', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'object', 'description': 'Validator settings for value type subject.', 'properties': {'memberOf': {'allOf': [{'type': 'object', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'properties': {'description': {'type': 'object'}, 'type': {'type': 'string', 'enum': ['group']}}}], 'required': ['type']}, 'requiredPermission': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'string', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'object', 'description': 'Validator settings for value type text.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}}}}}, 'valueSource': {'type': 'object', 'description': 'The value source for this field. Used by GUI/client to lookup input values. If not set, no value completion is configured.', 'properties': {'listType': {'type': 'object', 'properties': {'entries': {'type': 'array', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'items': {'type': 'object', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}}}, 'type': {'type': 'string', 'description': 'A valuesource may be of type list or url. A url valuesource searches/fetches values from an external endpoint, while a list valuesource provides a static list of values (for lookup and search).', 'enum': ['url', 'list']}, 'urlType': {'type': 'object', 'properties': {'queryURL': {'type': 'string', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'string', 'description': 'The service role required to set/update this field.', 'enum': ['user', 'tech', 'admin']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_field_policy = {'tags': ['cases/v2/field'], 'summary': 'Delete a field policy (INTERNAL)', 'description': 'Delete a field policy. A deleted policy cannot be assigned to a service, and deleting a policy will be denied if the policy is still in use in any service.', 'operationId': 'deleteFieldPolicy', 'parameters': [{'name': 'policy', 'in': 'path', 'description': 'ID or name of policy to delete', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for policy in (when using policy name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Delete a field policy', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_field_descriptor = {'tags': ['cases/v2/field'], 'summary': 'Fetch field descriptor (INTERNAL)', 'description': '', 'operationId': 'getFieldDescriptor', 'parameters': [{'name': 'field', 'in': 'path', 'description': 'ID or name of descriptor to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for field in (when using field name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch field descriptor', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this descriptor was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this field.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'defaultValue': {'type': 'string', 'description': 'The default value of this field, if the field is not set. If defaultValue is not set, the field will not be regarded as set on the case until a value is provided.'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this descriptor was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this field.'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'readRole': {'type': 'string', 'description': 'The service role required to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'deprecated': True, 'description': 'Options to the GUI renderer.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'validator': {'type': 'object', 'description': 'The validator controlling this field. The value type determines which fields are displayed in validator.', 'properties': {'assetSettings': {'type': 'object', 'description': 'Validator settings for value type asset.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'object', 'description': 'Validator settings for value type case.', 'properties': {'caseType': {'type': 'string', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'documentSettings': {'type': 'object', 'description': 'Validator settings for value type document.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'object', 'description': 'Validator settings for value type float.', 'properties': {'maximum': {'type': 'number', 'format': 'double', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'number', 'format': 'double', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'object', 'description': 'Validator settings for value type integer.', 'properties': {'maximum': {'type': 'integer', 'format': 'int32', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'integer', 'format': 'int32', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'object', 'description': 'Validator settings for value type ip.', 'properties': {'ipVersion': {'type': 'string', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'stringSettings': {'type': 'object', 'description': 'Validator settings for value type string.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}, 'regex': {'type': 'string', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'object', 'description': 'Validator settings for value type subject.', 'properties': {'memberOf': {'allOf': [{'type': 'object', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'properties': {'description': {'type': 'object'}, 'type': {'type': 'string', 'enum': ['group']}}}], 'required': ['type']}, 'requiredPermission': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'string', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'object', 'description': 'Validator settings for value type text.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}}}}}, 'valueSource': {'type': 'object', 'description': 'The value source for this field. Used by GUI/client to lookup input values. If not set, no value completion is configured.', 'properties': {'listType': {'type': 'object', 'properties': {'entries': {'type': 'array', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'items': {'type': 'object', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}}}, 'type': {'type': 'string', 'description': 'A valuesource may be of type list or url. A url valuesource searches/fetches values from an external endpoint, while a list valuesource provides a static list of values (for lookup and search).', 'enum': ['url', 'list']}, 'urlType': {'type': 'object', 'properties': {'queryURL': {'type': 'string', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'string', 'description': 'The service role required to set/update this field.', 'enum': ['user', 'tech', 'admin']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_field_policy_by_id = {'tags': ['cases/v2/field'], 'summary': 'Fetch policy descriptor by ID. (INTERNAL)', 'description': '', 'operationId': 'getFieldPolicyByID', 'parameters': [{'name': 'policy', 'in': 'path', 'description': 'ID or name of policy to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for policy in (when using policy name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch policy descriptor by ID.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_field_descriptors = {'tags': ['cases/v2/field'], 'summary': 'List field descriptors. (INTERNAL)', 'description': 'This endpoint will return all fields the user has access to, limited by specified filters.', 'operationId': 'listFieldDescriptors', 'parameters': [{'name': 'customerID', 'in': 'query', 'description': 'Limit result to fields bound to one of these customer IDs', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'domain', 'in': 'query', 'description': 'Limit result to fields bound to one of these domains (by ID or name)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'valueType', 'in': 'query', 'description': 'Limit result to fields with one of these valueTypes', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'uniqueItems': True}, {'name': 'field', 'in': 'query', 'description': 'Limit result to one of these fields (by ID or name)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'policy', 'in': 'query', 'description': 'Limit result to fields bound to one of these field policies (by ID or name)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywords', 'in': 'query', 'description': 'Limit result to fields matching one of these keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort order (see /cases/v2/field/descriptor/search documentation for details)', 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List field descriptors.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this descriptor was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this field.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'defaultValue': {'type': 'string', 'description': 'The default value of this field, if the field is not set. If defaultValue is not set, the field will not be regarded as set on the case until a value is provided.'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this descriptor was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this field.'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'readRole': {'type': 'string', 'description': 'The service role required to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'deprecated': True, 'description': 'Options to the GUI renderer.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'validator': {'type': 'object', 'description': 'The validator controlling this field. The value type determines which fields are displayed in validator.', 'properties': {'assetSettings': {'type': 'object', 'description': 'Validator settings for value type asset.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'object', 'description': 'Validator settings for value type case.', 'properties': {'caseType': {'type': 'string', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'documentSettings': {'type': 'object', 'description': 'Validator settings for value type document.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'object', 'description': 'Validator settings for value type float.', 'properties': {'maximum': {'type': 'number', 'format': 'double', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'number', 'format': 'double', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'object', 'description': 'Validator settings for value type integer.', 'properties': {'maximum': {'type': 'integer', 'format': 'int32', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'integer', 'format': 'int32', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'object', 'description': 'Validator settings for value type ip.', 'properties': {'ipVersion': {'type': 'string', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'stringSettings': {'type': 'object', 'description': 'Validator settings for value type string.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}, 'regex': {'type': 'string', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'object', 'description': 'Validator settings for value type subject.', 'properties': {'memberOf': {'allOf': [{'type': 'object', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'properties': {'description': {'type': 'object'}, 'type': {'type': 'string', 'enum': ['group']}}}], 'required': ['type']}, 'requiredPermission': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'string', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'object', 'description': 'Validator settings for value type text.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}}}}}, 'valueSource': {'type': 'object', 'description': 'The value source for this field. Used by GUI/client to lookup input values. If not set, no value completion is configured.', 'properties': {'listType': {'type': 'object', 'properties': {'entries': {'type': 'array', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'items': {'type': 'object', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}}}, 'type': {'type': 'string', 'description': 'A valuesource may be of type list or url. A url valuesource searches/fetches values from an external endpoint, while a list valuesource provides a static list of values (for lookup and search).', 'enum': ['url', 'list']}, 'urlType': {'type': 'object', 'properties': {'queryURL': {'type': 'string', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'string', 'description': 'The service role required to set/update this field.', 'enum': ['user', 'tech', 'admin']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_field_policies = {'tags': ['cases/v2/field'], 'summary': 'List field policies (INTERNAL)', 'description': 'This endpoint will return all policies which the user has role based permissions for, filtered by specified parameters.', 'operationId': 'listFieldPolicies', 'parameters': [{'name': 'customerID', 'in': 'query', 'description': 'Limit result to fields bound to one of these customer IDs', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'domain', 'in': 'query', 'description': 'Limit result to fields bound to one of these domains (ID or name)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywords', 'in': 'query', 'description': 'Limit result to fields matching one of these keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort order (see /cases/v2/field/policy/search documentation for details)', 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List field policies', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_field_source_values = {'tags': ['cases/v2/field'], 'summary': 'List define source values for a field. Fields may have a defined value source for available values, which can be used to select valid values to set on the field. This endpoint returns and filters the values from the defined data source. (INTERNAL)', 'description': '', 'operationId': 'listFieldSourceValues', 'parameters': [{'name': 'field', 'in': 'path', 'description': 'ID or name of field to fetch values for', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'caseID', 'in': 'query', 'description': 'ID for case to list field values for', 'schema': {'type': 'int'}, 'type': 'int'}, {'name': 'service', 'in': 'query', 'description': 'ID or shortname of service to list field values for', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'customer', 'in': 'query', 'description': 'ID or shortname of customer to list field values for', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'ID or name of domain for looking up service and customer. Defaults to the current users domain', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'keywords', 'in': 'query', 'description': 'Keyword to filter returned values by', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List define source values for a field. Fields may have a defined value source for available values, which can be used to select valid values to set on the field. This endpoint returns and filters the values from the defined data source.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'info': {'type': 'object', 'description': 'Info object. This is an optional complex object depending on the value type of the field.'}, 'key': {'type': 'string', 'description': 'Value key. May be a string, number or boolean value.'}, 'label': {'type': 'string', 'description': 'Value label. String representation of the value. If not a mapped value, this is a string version of the key.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
remove_field_from_policy = {'tags': ['cases/v2/field'], 'summary': 'Unbind a field from a policy. (INTERNAL)', 'description': 'Unbind a field from a policy. This will not remove the field from affected cases where this field is set, but will stop accepting the field on new cases or future updates of existing cases.', 'operationId': 'removeFieldFromPolicy', 'parameters': [{'name': 'policy', 'in': 'path', 'description': 'ID or name of policy to bind field to', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'field', 'in': 'path', 'description': 'ID or name of field to unbind', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for policy in (when using policy name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Unbind a field from a policy.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_field_descriptors = {'tags': ['cases/v2/field'], 'summary': 'Search field descriptors. (INTERNAL)', 'description': 'This endpoint will search all fields the user has access to, and apply the search criteria specified in the request.', 'operationId': 'searchFieldDescriptors', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'description': 'Restrict search to data belonging to specified customers.', 'items': {'type': 'int', 'description': 'Restrict search to data belonging to specified customers.'}, 'uniqueItems': True}, 'field': {'type': 'list', 'description': 'Restrict search to specific fields (by name or ID).', 'items': {'type': 'str', 'description': 'Restrict search to specific fields (by name or ID).'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Restrict search to fields bound to one of these domains.', 'items': {'type': 'str', 'description': 'Restrict search to fields bound to one of these domains.'}, 'uniqueItems': True}, 'service': {'type': 'list', 'description': 'Restrict search to fields which are in use in one of the specified services (service ID or shortname).', 'items': {'type': 'str', 'description': 'Restrict search to fields which are in use in one of the specified services (service ID or shortname).'}, 'uniqueItems': True}, 'policy': {'type': 'list', 'description': 'Restrict search to fields which are in use in one of the specified policies (by policy ID or name)', 'items': {'type': 'str', 'description': 'Restrict search to fields which are in use in one of the specified policies (by policy ID or name)'}, 'uniqueItems': True}, 'availableForCaseID': {'type': 'int', 'description': 'Restrict search to fields which are available for specified case (by ID)'}, 'valueType': {'type': 'list', 'description': 'Restrict search to entries of one of these value types.', 'items': {'type': 'str', 'description': 'Restrict search to entries of one of these value types.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'items': {'type': 'str', 'description': 'Search for keywords.'}, 'uniqueItems': True}, 'timeFieldStrategy': {'type': 'list', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'items': {'type': 'str', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'items': {'type': 'str', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'enum': ['name', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'user': {'type': 'list', 'description': 'Restrict search to fields created or updated by specified users (by id or shortname, selected by userFieldStrategy).', 'items': {'type': 'str', 'description': 'Restrict search to fields created or updated by specified users (by id or shortname, selected by userFieldStrategy).'}, 'uniqueItems': True}, 'userID': {'type': 'list', 'description': "This field is deprecated. Use field 'user' instead.", 'items': {'type': 'int', 'description': "This field is deprecated. Use field 'user' instead."}, 'uniqueItems': True}, 'userFieldStrategy': {'type': 'list', 'description': 'Defines which user fields will be searched (default match all user fields).', 'items': {'type': 'str', 'description': 'Defines which user fields will be searched (default match all user fields).', 'enum': ['createdByUser', 'lastUpdatedByUser', 'all']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['createdByUser', 'createdTimestamp', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'customer', 'domain', '-createdByUser', '-createdTimestamp', '-lastUpdatedByUser', '-lastUpdatedTimestamp', '-name', '-customer', '-domain']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'description': 'Restrict search to data belonging to specified customers.', 'items': {'type': 'int', 'description': 'Restrict search to data belonging to specified customers.'}, 'uniqueItems': True}, 'field': {'type': 'list', 'description': 'Restrict search to specific fields (by name or ID).', 'items': {'type': 'str', 'description': 'Restrict search to specific fields (by name or ID).'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Restrict search to fields bound to one of these domains.', 'items': {'type': 'str', 'description': 'Restrict search to fields bound to one of these domains.'}, 'uniqueItems': True}, 'service': {'type': 'list', 'description': 'Restrict search to fields which are in use in one of the specified services (service ID or shortname).', 'items': {'type': 'str', 'description': 'Restrict search to fields which are in use in one of the specified services (service ID or shortname).'}, 'uniqueItems': True}, 'policy': {'type': 'list', 'description': 'Restrict search to fields which are in use in one of the specified policies (by policy ID or name)', 'items': {'type': 'str', 'description': 'Restrict search to fields which are in use in one of the specified policies (by policy ID or name)'}, 'uniqueItems': True}, 'availableForCaseID': {'type': 'int', 'description': 'Restrict search to fields which are available for specified case (by ID)'}, 'valueType': {'type': 'list', 'description': 'Restrict search to entries of one of these value types.', 'items': {'type': 'str', 'description': 'Restrict search to entries of one of these value types.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'items': {'type': 'str', 'description': 'Search for keywords.'}, 'uniqueItems': True}, 'timeFieldStrategy': {'type': 'list', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'items': {'type': 'str', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'items': {'type': 'str', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'enum': ['name', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'user': {'type': 'list', 'description': 'Restrict search to fields created or updated by specified users (by id or shortname, selected by userFieldStrategy).', 'items': {'type': 'str', 'description': 'Restrict search to fields created or updated by specified users (by id or shortname, selected by userFieldStrategy).'}, 'uniqueItems': True}, 'userID': {'type': 'list', 'description': "This field is deprecated. Use field 'user' instead.", 'items': {'type': 'int', 'description': "This field is deprecated. Use field 'user' instead."}, 'uniqueItems': True}, 'userFieldStrategy': {'type': 'list', 'description': 'Defines which user fields will be searched (default match all user fields).', 'items': {'type': 'str', 'description': 'Defines which user fields will be searched (default match all user fields).', 'enum': ['createdByUser', 'lastUpdatedByUser', 'all']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['createdByUser', 'createdTimestamp', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'customer', 'domain', '-createdByUser', '-createdTimestamp', '-lastUpdatedByUser', '-lastUpdatedTimestamp', '-name', '-customer', '-domain']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search field descriptors.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this descriptor was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this field.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'defaultValue': {'type': 'string', 'description': 'The default value of this field, if the field is not set. If defaultValue is not set, the field will not be regarded as set on the case until a value is provided.'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this descriptor was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this field.'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'readRole': {'type': 'string', 'description': 'The service role required to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'deprecated': True, 'description': 'Options to the GUI renderer.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'validator': {'type': 'object', 'description': 'The validator controlling this field. The value type determines which fields are displayed in validator.', 'properties': {'assetSettings': {'type': 'object', 'description': 'Validator settings for value type asset.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'object', 'description': 'Validator settings for value type case.', 'properties': {'caseType': {'type': 'string', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'documentSettings': {'type': 'object', 'description': 'Validator settings for value type document.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'object', 'description': 'Validator settings for value type float.', 'properties': {'maximum': {'type': 'number', 'format': 'double', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'number', 'format': 'double', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'object', 'description': 'Validator settings for value type integer.', 'properties': {'maximum': {'type': 'integer', 'format': 'int32', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'integer', 'format': 'int32', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'object', 'description': 'Validator settings for value type ip.', 'properties': {'ipVersion': {'type': 'string', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'stringSettings': {'type': 'object', 'description': 'Validator settings for value type string.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}, 'regex': {'type': 'string', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'object', 'description': 'Validator settings for value type subject.', 'properties': {'memberOf': {'allOf': [{'type': 'object', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'properties': {'description': {'type': 'object'}, 'type': {'type': 'string', 'enum': ['group']}}}], 'required': ['type']}, 'requiredPermission': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'string', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'object', 'description': 'Validator settings for value type text.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}}}}}, 'valueSource': {'type': 'object', 'description': 'The value source for this field. Used by GUI/client to lookup input values. If not set, no value completion is configured.', 'properties': {'listType': {'type': 'object', 'properties': {'entries': {'type': 'array', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'items': {'type': 'object', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}}}, 'type': {'type': 'string', 'description': 'A valuesource may be of type list or url. A url valuesource searches/fetches values from an external endpoint, while a list valuesource provides a static list of values (for lookup and search).', 'enum': ['url', 'list']}, 'urlType': {'type': 'object', 'properties': {'queryURL': {'type': 'string', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'string', 'description': 'The service role required to set/update this field.', 'enum': ['user', 'tech', 'admin']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_field_policies = {'tags': ['cases/v2/field'], 'summary': 'Search field policies (INTERNAL)', 'description': 'This endpoint will search all policies which the user has role based permission for, limited by provided search criteria.', 'operationId': 'searchFieldPolicies', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'description': 'Restrict search to data belonging to specified customers.', 'items': {'type': 'int', 'description': 'Restrict search to data belonging to specified customers.'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Search by domain (ID or name).', 'items': {'type': 'str', 'description': 'Search by domain (ID or name).'}, 'uniqueItems': True}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'items': {'type': 'str', 'description': 'Search for keywords.'}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'items': {'type': 'str', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'enum': ['name', 'all']}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'timeFieldStrategy': {'type': 'list', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'items': {'type': 'str', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'user': {'type': 'list', 'description': 'Restrict search to policies created or updated by specified users (by id or shortname, selected by userFieldStrategy).', 'items': {'type': 'str', 'description': 'Restrict search to policies created or updated by specified users (by id or shortname, selected by userFieldStrategy).'}, 'uniqueItems': True}, 'userID': {'type': 'list', 'description': "This field is deprecated. Use field 'user' instead.", 'items': {'type': 'int', 'description': "This field is deprecated. Use field 'user' instead."}, 'uniqueItems': True}, 'userFieldStrategy': {'type': 'list', 'description': 'Defines which user fields will be searched (default match all user fields).', 'items': {'type': 'str', 'description': 'Defines which user fields will be searched (default match all user fields).', 'enum': ['createdByUser', 'lastUpdatedByUser', 'all']}, 'uniqueItems': True}, 'field': {'type': 'list', 'description': 'Search for policies bound to specific fields (by field UUID or name).', 'items': {'type': 'str', 'description': 'Search for policies bound to specific fields (by field UUID or name).'}, 'uniqueItems': True}, 'policy': {'type': 'list', 'description': 'Search for policies with specified id (UUID or name).', 'items': {'type': 'str', 'description': 'Search for policies with specified id (UUID or name).'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['createdByUser', 'createdTimestamp', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'customer', 'domain', '-createdByUser', '-createdTimestamp', '-lastUpdatedByUser', '-lastUpdatedTimestamp', '-name', '-customer', '-domain']}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'description': 'Restrict search to data belonging to specified customers.', 'items': {'type': 'int', 'description': 'Restrict search to data belonging to specified customers.'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Search by domain (ID or name).', 'items': {'type': 'str', 'description': 'Search by domain (ID or name).'}, 'uniqueItems': True}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'items': {'type': 'str', 'description': 'Search for keywords.'}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'items': {'type': 'str', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'enum': ['name', 'all']}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'timeFieldStrategy': {'type': 'list', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'items': {'type': 'str', 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'user': {'type': 'list', 'description': 'Restrict search to policies created or updated by specified users (by id or shortname, selected by userFieldStrategy).', 'items': {'type': 'str', 'description': 'Restrict search to policies created or updated by specified users (by id or shortname, selected by userFieldStrategy).'}, 'uniqueItems': True}, 'userID': {'type': 'list', 'description': "This field is deprecated. Use field 'user' instead.", 'items': {'type': 'int', 'description': "This field is deprecated. Use field 'user' instead."}, 'uniqueItems': True}, 'userFieldStrategy': {'type': 'list', 'description': 'Defines which user fields will be searched (default match all user fields).', 'items': {'type': 'str', 'description': 'Defines which user fields will be searched (default match all user fields).', 'enum': ['createdByUser', 'lastUpdatedByUser', 'all']}, 'uniqueItems': True}, 'field': {'type': 'list', 'description': 'Search for policies bound to specific fields (by field UUID or name).', 'items': {'type': 'str', 'description': 'Search for policies bound to specific fields (by field UUID or name).'}, 'uniqueItems': True}, 'policy': {'type': 'list', 'description': 'Search for policies with specified id (UUID or name).', 'items': {'type': 'str', 'description': 'Search for policies with specified id (UUID or name).'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['createdByUser', 'createdTimestamp', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'customer', 'domain', '-createdByUser', '-createdTimestamp', '-lastUpdatedByUser', '-lastUpdatedTimestamp', '-name', '-customer', '-domain']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search field policies', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_field_descriptor = {'tags': ['cases/v2/field'], 'summary': 'Update a field descriptor. (INTERNAL)', 'description': '', 'operationId': 'updateFieldDescriptor', 'parameters': [{'name': 'field', 'in': 'path', 'description': 'ID or name of descriptor to update', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for field in (when using field name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'defaultValue': {'type': 'str', 'description': 'If set, change the default value to populate this field with.'}, 'hidden': {'type': 'bool', 'description': 'If set, change the hidden parameter of this field.'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'If set, update the localized descriptions.'}, 'description': 'If set, update the localized descriptions.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'If set, update the localized names.'}, 'description': 'If set, update the localized names.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'multiValue': {'type': 'bool', 'description': 'If set, change the multivalue parameter of this field. This will not affect existing cases with this field set.'}, 'name': {'type': 'str', 'description': 'If set, change the name of the field.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'readRole': {'type': 'str', 'description': 'If set, update the required service role to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Renderer options. Only for use by the Argus frontend application.'}, 'description': 'Renderer options. Only for use by the Argus frontend application.'}, 'shortName': {'type': 'str', 'description': 'If set, change the shortname of the field.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'validator': {'type': 'dict', 'properties': {'assetSettings': {'type': 'dict', 'properties': {'sameCustomer': {'type': 'bool', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'dict', 'properties': {'caseType': {'type': 'str', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'str', 'description': 'If set, only allow cases with this category.'}, 'sameCustomer': {'type': 'bool', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'str', 'description': 'If set, only allow cases for this service.'}}}, 'documentSettings': {'type': 'dict', 'properties': {'sameCustomer': {'type': 'bool', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'dict', 'properties': {'maximum': {'type': 'float', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'float', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'dict', 'properties': {'maximum': {'type': 'int', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'int', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'dict', 'properties': {'ipVersion': {'type': 'str', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'jsonSettings': {'type': 'object'}, 'stringSettings': {'type': 'dict', 'properties': {'maxLength': {'type': 'int', 'description': 'Max length for this field. With no maxLength, the system maximum is 255 characters.'}, 'regex': {'type': 'str', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'dict', 'properties': {'memberOf': {'type': 'int', 'description': 'If set, only allow subjects which are member of this group'}, 'requiredPermission': {'type': 'str', 'description': 'If set, only allow subjects which have this permission granted.'}, 'sameCustomer': {'type': 'bool', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'str', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'dict', 'properties': {'maxLength': {'type': 'int', 'description': 'Max length for this field. With no maxLength, the system maximum is 65k.'}}}}}, 'valueSource': {'type': 'dict', 'properties': {'listType': {'type': 'dict', 'properties': {'entries': {'type': 'list', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label. Use either parameter entries or the parameter values. ', 'items': {'type': 'dict', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}, 'values': {'type': 'list', 'description': 'For valuesource of type list, values specifies a set of available values. This is a shorthand notation for a list of entries with equal key/label.', 'items': {'type': 'str', 'description': 'For valuesource of type list, values specifies a set of available values. This is a shorthand notation for a list of entries with equal key/label.'}}}}, 'urlType': {'type': 'dict', 'properties': {'queryURL': {'type': 'str', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'str', 'description': 'If set, change the value type for the field.The field will only accept values that can be safely converted to this value type. If the field uses an autocompleter, the autocompleter should convert user input to valid values of this type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'str', 'description': 'If set, update the required service role to write this field.', 'enum': ['user', 'tech', 'admin']}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update a field descriptor.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this descriptor was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this field.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'defaultValue': {'type': 'string', 'description': 'The default value of this field, if the field is not set. If defaultValue is not set, the field will not be regarded as set on the case until a value is provided.'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this descriptor was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this field.'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'readRole': {'type': 'string', 'description': 'The service role required to read this field.', 'enum': ['user', 'tech', 'admin']}, 'rendererOptions': {'deprecated': True, 'description': 'Options to the GUI renderer.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'validator': {'type': 'object', 'description': 'The validator controlling this field. The value type determines which fields are displayed in validator.', 'properties': {'assetSettings': {'type': 'object', 'description': 'Validator settings for value type asset.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow assets from same customer as the current case.'}}}, 'caseSettings': {'type': 'object', 'description': 'Validator settings for value type case.', 'properties': {'caseType': {'type': 'string', 'description': 'If set, only allow cases of this type.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow cases from same customer as the current case.'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'documentSettings': {'type': 'object', 'description': 'Validator settings for value type document.', 'properties': {'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow documents from same customer as the current case.'}}}, 'floatSettings': {'type': 'object', 'description': 'Validator settings for value type float.', 'properties': {'maximum': {'type': 'number', 'format': 'double', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'number', 'format': 'double', 'description': 'Minimum value for this field.'}}}, 'integerSettings': {'type': 'object', 'description': 'Validator settings for value type integer.', 'properties': {'maximum': {'type': 'integer', 'format': 'int32', 'description': 'Maximum value for this field.'}, 'minimum': {'type': 'integer', 'format': 'int32', 'description': 'Minimum value for this field.'}}}, 'ipSettings': {'type': 'object', 'description': 'Validator settings for value type ip.', 'properties': {'ipVersion': {'type': 'string', 'description': 'If set, limit values to specified IP family.', 'enum': ['IPv4', 'IPv6']}}}, 'stringSettings': {'type': 'object', 'description': 'Validator settings for value type string.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}, 'regex': {'type': 'string', 'description': 'Regular expression which values must match.'}}}, 'subjectSettings': {'type': 'object', 'description': 'Validator settings for value type subject.', 'properties': {'memberOf': {'allOf': [{'type': 'object', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'properties': {'description': {'type': 'object'}, 'type': {'type': 'string', 'enum': ['group']}}}], 'required': ['type']}, 'requiredPermission': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'sameCustomer': {'type': 'boolean', 'description': 'If true, only allow subjects from same customer as the case.'}, 'subjectType': {'type': 'string', 'description': 'If set, limit values to specified subject type.', 'enum': ['user', 'group']}}}, 'textSettings': {'type': 'object', 'description': 'Validator settings for value type text.', 'properties': {'maxLength': {'type': 'integer', 'format': 'int32', 'description': 'Max length for this field.'}}}}}, 'valueSource': {'type': 'object', 'description': 'The value source for this field. Used by GUI/client to lookup input values. If not set, no value completion is configured.', 'properties': {'listType': {'type': 'object', 'properties': {'entries': {'type': 'array', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'items': {'type': 'object', 'description': 'For valuesource of type list, entries specifies a set of available field values, each having a key and a label.', 'properties': {'key': {'type': 'string'}, 'label': {'type': 'string'}}}}}}, 'type': {'type': 'string', 'description': 'A valuesource may be of type list or url. A url valuesource searches/fetches values from an external endpoint, while a list valuesource provides a static list of values (for lookup and search).', 'enum': ['url', 'list']}, 'urlType': {'type': 'object', 'properties': {'queryURL': {'type': 'string', 'description': 'For valuesource of type url, queryURL specifies the endpoint to search for values. Any string %s in the URL will be replaced with the search string if set. This endpoint will also be invoked to lookup single values when resolving existing field values, so it should return the exact match of the value key.'}}}}}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}, 'writeRole': {'type': 'string', 'description': 'The service role required to set/update this field.', 'enum': ['user', 'tech', 'admin']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_field_policy = {'tags': ['cases/v2/field'], 'summary': 'Update a field policy. (INTERNAL)', 'description': '', 'operationId': 'updateFieldPolicy', 'parameters': [{'name': 'policy', 'in': 'path', 'description': 'ID or name of policy to update', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to look for policy in (when using policy name for ID). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'name': {'type': 'str', 'description': 'If set, change the name of this policy.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update a field policy.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}