"""Autogenerated API schema"""
from argus_api import session


bind_category = {'tags': ['cases/v2/service'], 'summary': 'Bind category to service (PUBLIC)', 'description': '', 'operationId': 'bindCategory', 'parameters': [{'name': 'serviceID', 'in': 'path', 'description': 'ID or shortname of service to bind category to', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'caseTypes': {'type': 'list', 'description': 'Case types to bind category for', 'items': {'type': 'str', 'description': 'Case types to bind category for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}, 'category': {'type': 'str', 'description': 'Shortname or ID of category to bind'}}, 'required': ['caseTypes', 'category']}}}, 'required': True}, 'responses': {'default': {'description': 'Bind category to service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['bindCategoryToService'], 'x-Argus-ApiStatus': 'PUBLIC'}
create_service = {'tags': ['cases/v2/service'], 'summary': 'Define a new service (INTERNAL)', 'description': '', 'operationId': 'createService', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to create service', 'properties': {'adminFunction': {'type': 'str', 'description': 'The name or ID of the function to set as ADMIN function for this service.'}, 'assignDefaultTech': {'type': 'bool', 'description': 'If true, cases created for this service will be automatically assign tech to the executing user (if tech).'}, 'assignDefaultUser': {'type': 'bool', 'description': 'If true, cases created for this service will be automatically assign user to the executing user (if not tech).'}, 'caseTypes': {'type': 'list', 'description': 'The case types to enable for this service.', 'items': {'type': 'str', 'description': 'The case types to enable for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}, 'createFunction': {'type': 'str', 'description': 'The name or ID of the function to set as CREATE function for this service.'}, 'defineFunction': {'type': 'str', 'description': 'The name or ID of the function to set as DEFINE function for this service.'}, 'description': {'type': 'str', 'description': 'Longer description of service.'}, 'domain': {'type': 'str', 'description': 'Name or ID of domain to bind service to.'}, 'eventEnabled': {'type': 'bool', 'description': 'If true, this service is integrated with events.'}, 'fieldPolicy': {'type': 'str', 'description': 'The ID of a field policy to set for this service. Default is no policy.'}, 'handledBySoc': {'type': 'bool', 'description': 'If true, this service is handled by SOC 24/7. Default is false.'}, 'iconURL': {'type': 'str', 'description': 'An image data-URL on the form data:image/png;base64,BASE64IMAGEDATA', 'pattern': 'data:image/.+'}, 'listFunction': {'type': 'str', 'description': "The name or ID of the function to set as LIST function for this service. Default is the same as 'readFunction'."}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized descriptions. If not set, locales will fallback to main description.'}, 'description': 'Localized descriptions. If not set, locales will fallback to main description.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Localized names. If not set, locales will fallback to main name.'}, 'description': 'Localized names. If not set, locales will fallback to main name.'}, 'monitoredBySocOutsideOfficeHours': {'type': 'bool', 'description': 'If true, this service is monitored by SOC outside office hours. Default is false.'}, 'name': {'type': 'str', 'description': 'Descriptive name of service.'}, 'notificationEmail': {'type': 'str', 'description': 'The service notification email address. [format:email]', 'x-Argus-Format': 'email'}, 'notifyFullFormat': {'type': 'bool', 'description': 'If true, use the full format when notifying to the service notification email. Default is false.'}, 'notifyOnClose': {'type': 'bool', 'description': 'If true, notify the service notification email address on closed cases. Default is false.'}, 'notifyOnCreate': {'type': 'bool', 'description': 'If true, notify the service notification email address on created cases. Default is false.'}, 'notifyOnUpdate': {'type': 'bool', 'description': 'If true, notify the service notification email address on updated cases. Default is false.'}, 'readFunction': {'type': 'str', 'description': 'The name or ID of the function to set as READ function for this service.'}, 'shortName': {'type': 'str', 'description': 'Shortname of service. This must be unique within a domain.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'techFunction': {'type': 'str', 'description': 'The name or ID of the function to set as TECH function for this service.'}, 'workflows': {'type': 'dict', 'additionalProperties': {'type': 'bool', 'description': 'If set, define workflows to enable for this service.'}, 'description': 'If set, define workflows to enable for this service.'}, 'writeFunction': {'type': 'str', 'description': 'The name or ID of the function to set as WRITE function for this service.'}}, 'required': ['adminFunction', 'caseTypes', 'createFunction', 'defineFunction', 'description', 'domain', 'iconURL', 'name', 'notificationEmail', 'readFunction', 'shortName', 'techFunction', 'writeFunction']}}}, 'required': True}, 'responses': {'default': {'description': 'Define a new service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'adminFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'caseTypes': {'type': 'array', 'description': 'The case types which are enabled for this service.', 'items': {'type': 'string', 'description': 'The case types which are enabled for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this service was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was created'}, 'defineFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'description': {'type': 'string', 'description': 'Service description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'NOTIFICATION_ON_CREATE', 'NOTIFICATION_ON_UPDATE', 'NOTIFICATION_ON_CLOSE', 'NOTIFICATION_FORMAT_FULL', 'DEPRECATED', 'ASSIGN_DEFAULT_TECH', 'ASSIGN_DEFAULT_USER', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'The ID of this service'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this service was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was last updated'}, 'listFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'logoURL': {'type': 'string', 'description': 'The logo data-URL used for this service'}, 'name': {'type': 'string', 'description': 'Service name'}, 'notificationEmail': {'type': 'string', 'description': 'The notification email configured for this service'}, 'readDetailedFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'readFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'shortName': {'type': 'string', 'description': 'Service shortname'}, 'techFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'workflows': {'type': 'array', 'description': 'The workflows which are enabled for this service', 'items': {'type': 'string', 'description': 'The workflows which are enabled for this service', 'enum': ['validation', 'nocValidation', 'tuning', 'escalation', 'customerUpdate', 'escalateTI', 'escalateNSA', 'escalateLog', 'escalateInfra', 'escalateMSI', 'severityAlert', 'slaViolation', 'internalSlaViolation', 'delegateToSOC', 'escalateDEV', 'escalateTRS', 'escalateMSSAnalyst', 'escalateTAM', 'qaValidation', 'socAnalysis']}, 'uniqueItems': True}, 'writeFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['createService'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_service = {'tags': ['cases/v2/service'], 'summary': 'Delete service (INTERNAL)', 'description': '', 'operationId': 'deleteService', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of service to delete', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Delete service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'adminFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'caseTypes': {'type': 'array', 'description': 'The case types which are enabled for this service.', 'items': {'type': 'string', 'description': 'The case types which are enabled for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this service was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was created'}, 'defineFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'description': {'type': 'string', 'description': 'Service description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'NOTIFICATION_ON_CREATE', 'NOTIFICATION_ON_UPDATE', 'NOTIFICATION_ON_CLOSE', 'NOTIFICATION_FORMAT_FULL', 'DEPRECATED', 'ASSIGN_DEFAULT_TECH', 'ASSIGN_DEFAULT_USER', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'The ID of this service'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this service was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was last updated'}, 'listFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'logoURL': {'type': 'string', 'description': 'The logo data-URL used for this service'}, 'name': {'type': 'string', 'description': 'Service name'}, 'notificationEmail': {'type': 'string', 'description': 'The notification email configured for this service'}, 'readDetailedFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'readFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'shortName': {'type': 'string', 'description': 'Service shortname'}, 'techFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'workflows': {'type': 'array', 'description': 'The workflows which are enabled for this service', 'items': {'type': 'string', 'description': 'The workflows which are enabled for this service', 'enum': ['validation', 'nocValidation', 'tuning', 'escalation', 'customerUpdate', 'escalateTI', 'escalateNSA', 'escalateLog', 'escalateInfra', 'escalateMSI', 'severityAlert', 'slaViolation', 'internalSlaViolation', 'delegateToSOC', 'escalateDEV', 'escalateTRS', 'escalateMSSAnalyst', 'escalateTAM', 'qaValidation', 'socAnalysis']}, 'uniqueItems': True}, 'writeFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteService'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_field_policy_by_service = {'tags': ['cases/v2/field'], 'summary': 'Fetch policy descriptor by service and customer (INTERNAL)', 'description': 'Fetch the field policy that applies to the specified service and customer. This endpoint is useful to fetch the field policy that applies to a new case (before creation). The policy will specify available fields for the service of the case, and if any of the fields are required on create.', 'operationId': 'getFieldPolicyByService', 'parameters': [{'name': 'service', 'in': 'path', 'description': 'ID or shortname of service to fetch policy for', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'customer', 'in': 'query', 'description': 'ID or shortname of customer to fetch policy for', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Domain to lookup service and customer in (when using shortnames). Defaults to the current users domain.', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch policy descriptor by service and customer', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'bindings': {'type': 'array', 'description': 'The fields bound to this policy.', 'items': {'type': 'object', 'description': 'The fields bound to this policy.', 'properties': {'displayIn': {'type': 'array', 'description': 'The display options for this field', 'items': {'type': 'string', 'description': 'The display options for this field', 'enum': ['create', 'viewMain', 'closeDialog']}, 'uniqueItems': True}, 'displayName': {'type': 'string', 'description': 'The display name of the field. Default is the field name.'}, 'field': {'type': 'object', 'description': 'Field descriptor', 'properties': {'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'MULTIVALUE', 'HAS_VALUE_SOURCE', 'HIDDEN']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The name of this field. May be overridden by displayName in field policies.'}, 'shortName': {'type': 'string', 'description': 'The shortname of this field.'}, 'valueType': {'type': 'string', 'description': 'The value type of this field. Field values will be validated to ensure that the type is valid. If the field is a multivalue field, each value must be of the correct type.', 'enum': ['booleanType', 'integerType', 'floatType', 'stringType', 'textType', 'timestampType', 'ipType', 'subjectType', 'caseType', 'documentType', 'assetType', 'jsonType']}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'requirementPolicy': {'type': 'string', 'description': 'The requirement policy for this field in this field policy.', 'enum': ['optional', 'requiredOnCreate', 'requiredOnClose']}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this policy was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the creation of this policy.'}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this policy was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp for the last update of this policy.'}, 'name': {'type': 'string', 'description': 'The policy name'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_service = {'tags': ['cases/v2/service'], 'summary': 'Fetch service (INTERNAL)', 'description': '', 'operationId': 'getService', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of service', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'adminFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'caseTypes': {'type': 'array', 'description': 'The case types which are enabled for this service.', 'items': {'type': 'string', 'description': 'The case types which are enabled for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this service was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was created'}, 'defineFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'description': {'type': 'string', 'description': 'Service description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'NOTIFICATION_ON_CREATE', 'NOTIFICATION_ON_UPDATE', 'NOTIFICATION_ON_CLOSE', 'NOTIFICATION_FORMAT_FULL', 'DEPRECATED', 'ASSIGN_DEFAULT_TECH', 'ASSIGN_DEFAULT_USER', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'The ID of this service'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this service was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was last updated'}, 'listFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'logoURL': {'type': 'string', 'description': 'The logo data-URL used for this service'}, 'name': {'type': 'string', 'description': 'Service name'}, 'notificationEmail': {'type': 'string', 'description': 'The notification email configured for this service'}, 'readDetailedFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'readFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'shortName': {'type': 'string', 'description': 'Service shortname'}, 'techFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'workflows': {'type': 'array', 'description': 'The workflows which are enabled for this service', 'items': {'type': 'string', 'description': 'The workflows which are enabled for this service', 'enum': ['validation', 'nocValidation', 'tuning', 'escalation', 'customerUpdate', 'escalateTI', 'escalateNSA', 'escalateLog', 'escalateInfra', 'escalateMSI', 'severityAlert', 'slaViolation', 'internalSlaViolation', 'delegateToSOC', 'escalateDEV', 'escalateTRS', 'escalateMSSAnalyst', 'escalateTAM', 'qaValidation', 'socAnalysis']}, 'uniqueItems': True}, 'writeFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_service_logo = {'tags': ['cases/v2/service'], 'summary': 'Fetch service logo (INTERNAL)', 'description': '', 'operationId': 'getServiceLogo', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of service', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch service logo', 'content': {'image/*': {}}}, '401': {'description': 'Authentication failed', 'content': {'image/*': {}}}, '403': {'description': 'Access denied', 'content': {'image/*': {}}}, '404': {'description': 'Object not found', 'content': {'image/*': {}}}, '412': {'description': 'Validation error', 'content': {'image/*': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_categories_by_service = {'tags': ['cases/v2/service'], 'summary': 'List categories bound to service (PUBLIC)', 'description': '', 'operationId': 'listCategoriesByService', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID or shortname of service', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List categories bound to service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Categories are used to categorize cases into specific subcategories. Each case may be associated with one category (or none).The category must be associated with the service that the case is bound to, and to the case type of the case.', 'properties': {'bindings': {'type': 'array', 'description': 'Bindings from this category to services', 'items': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}, 'uniqueItems': True}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this category was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was created'}, 'description': {'type': 'string', 'description': 'Category description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'DEPRECATED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this category was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this category was last updated'}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_services = {'tags': ['cases/v2/service'], 'summary': 'List services (INTERNAL)', 'description': '', 'operationId': 'listServices', 'parameters': [{'name': 'id', 'in': 'query', 'description': 'List of IDs to match', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'shortName', 'in': 'query', 'description': 'List of shortnames to match', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywords', 'in': 'query', 'description': 'Limit by matching keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort order (see /cases/v2/service/search documentation for details)', 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List services', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'adminFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'caseTypes': {'type': 'array', 'description': 'The case types which are enabled for this service.', 'items': {'type': 'string', 'description': 'The case types which are enabled for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this service was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was created'}, 'defineFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'description': {'type': 'string', 'description': 'Service description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'NOTIFICATION_ON_CREATE', 'NOTIFICATION_ON_UPDATE', 'NOTIFICATION_ON_CLOSE', 'NOTIFICATION_FORMAT_FULL', 'DEPRECATED', 'ASSIGN_DEFAULT_TECH', 'ASSIGN_DEFAULT_USER', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'The ID of this service'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this service was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was last updated'}, 'listFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'logoURL': {'type': 'string', 'description': 'The logo data-URL used for this service'}, 'name': {'type': 'string', 'description': 'Service name'}, 'notificationEmail': {'type': 'string', 'description': 'The notification email configured for this service'}, 'readDetailedFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'readFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'shortName': {'type': 'string', 'description': 'Service shortname'}, 'techFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'workflows': {'type': 'array', 'description': 'The workflows which are enabled for this service', 'items': {'type': 'string', 'description': 'The workflows which are enabled for this service', 'enum': ['validation', 'nocValidation', 'tuning', 'escalation', 'customerUpdate', 'escalateTI', 'escalateNSA', 'escalateLog', 'escalateInfra', 'escalateMSI', 'severityAlert', 'slaViolation', 'internalSlaViolation', 'delegateToSOC', 'escalateDEV', 'escalateTRS', 'escalateMSSAnalyst', 'escalateTAM', 'qaValidation', 'socAnalysis']}, 'uniqueItems': True}, 'writeFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_services = {'tags': ['cases/v2/service'], 'summary': 'Search services (INTERNAL)', 'description': '', 'operationId': 'searchServices', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'id': {'type': 'list', 'description': 'Limit search to services with the specified numeric ID`s.', 'items': {'type': 'int', 'description': 'Limit search to services with the specified numeric ID`s.'}, 'uniqueItems': True}, 'shortName': {'type': 'list', 'description': 'Limit search to services with the specified shortnames', 'items': {'type': 'str', 'description': 'Limit search to services with the specified shortnames'}, 'uniqueItems': True}, 'fieldPolicy': {'type': 'list', 'description': 'Limit search to services bound to specified field policies (by UUID or name)', 'items': {'type': 'str', 'description': 'Limit search to services bound to specified field policies (by UUID or name)'}, 'uniqueItems': True}, 'keywords': {'type': 'list', 'description': 'Limit search to services matching the given keywords (by name or shortname)', 'items': {'type': 'str', 'description': 'Limit search to services matching the given keywords (by name or shortname)'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'shortName', 'name', '-id', '-shortName', '-name']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'DEPRECATED', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'DEPRECATED', 'EVENT_ENABLED']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'id': {'type': 'list', 'description': 'Limit search to services with the specified numeric ID`s.', 'items': {'type': 'int', 'description': 'Limit search to services with the specified numeric ID`s.'}, 'uniqueItems': True}, 'shortName': {'type': 'list', 'description': 'Limit search to services with the specified shortnames', 'items': {'type': 'str', 'description': 'Limit search to services with the specified shortnames'}, 'uniqueItems': True}, 'fieldPolicy': {'type': 'list', 'description': 'Limit search to services bound to specified field policies (by UUID or name)', 'items': {'type': 'str', 'description': 'Limit search to services bound to specified field policies (by UUID or name)'}, 'uniqueItems': True}, 'keywords': {'type': 'list', 'description': 'Limit search to services matching the given keywords (by name or shortname)', 'items': {'type': 'str', 'description': 'Limit search to services matching the given keywords (by name or shortname)'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'shortName', 'name', '-id', '-shortName', '-name']}}, 'includeFlags': {'type': 'list', 'description': 'Only include objects which have includeFlags set.', 'items': {'type': 'str', 'description': 'Only include objects which have includeFlags set.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'DEPRECATED', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude objects which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude objects which have excludeFlags set.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'DEPRECATED', 'EVENT_ENABLED']}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search services', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'adminFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'caseTypes': {'type': 'array', 'description': 'The case types which are enabled for this service.', 'items': {'type': 'string', 'description': 'The case types which are enabled for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this service was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was created'}, 'defineFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'description': {'type': 'string', 'description': 'Service description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'NOTIFICATION_ON_CREATE', 'NOTIFICATION_ON_UPDATE', 'NOTIFICATION_ON_CLOSE', 'NOTIFICATION_FORMAT_FULL', 'DEPRECATED', 'ASSIGN_DEFAULT_TECH', 'ASSIGN_DEFAULT_USER', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'The ID of this service'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this service was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was last updated'}, 'listFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'logoURL': {'type': 'string', 'description': 'The logo data-URL used for this service'}, 'name': {'type': 'string', 'description': 'Service name'}, 'notificationEmail': {'type': 'string', 'description': 'The notification email configured for this service'}, 'readDetailedFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'readFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'shortName': {'type': 'string', 'description': 'Service shortname'}, 'techFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'workflows': {'type': 'array', 'description': 'The workflows which are enabled for this service', 'items': {'type': 'string', 'description': 'The workflows which are enabled for this service', 'enum': ['validation', 'nocValidation', 'tuning', 'escalation', 'customerUpdate', 'escalateTI', 'escalateNSA', 'escalateLog', 'escalateInfra', 'escalateMSI', 'severityAlert', 'slaViolation', 'internalSlaViolation', 'delegateToSOC', 'escalateDEV', 'escalateTRS', 'escalateMSSAnalyst', 'escalateTAM', 'qaValidation', 'socAnalysis']}, 'uniqueItems': True}, 'writeFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
unbind_category = {'tags': ['cases/v2/service'], 'summary': 'Unbind category from service. If caseType is specified, only unbind specific casetype. Default is to unbind all casetypes, disallowing the category for use on this service. (PUBLIC)', 'description': '', 'operationId': 'unbindCategory', 'parameters': [{'name': 'serviceID', 'in': 'path', 'description': 'ID or shortname of service to unbind category from', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'categoryID', 'in': 'path', 'description': 'ID or shortname of category to unbind', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'caseType', 'in': 'query', 'description': 'Casetypes to unbind (default is all)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Unbind category from service. If caseType is specified, only unbind specific casetype. Default is to unbind all casetypes, disallowing the category for use on this service.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'caseTypes': {'type': 'array', 'description': 'Case types the category is bound to this service for', 'items': {'type': 'string', 'description': 'Case types the category is bound to this service for', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'category': {'type': 'object', 'description': 'Bound category', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'localizedName': {'type': 'string', 'description': 'Category name localized to current users language'}, 'name': {'type': 'string', 'description': 'Category name'}, 'shortName': {'type': 'string', 'description': 'Category shortname'}}}, 'id': {'type': 'string', 'format': 'uuid'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['unbindCategoryFromService'], 'x-Argus-ApiStatus': 'PUBLIC'}
update_service = {'tags': ['cases/v2/service'], 'summary': 'Update an existing service (INTERNAL)', 'description': '', 'operationId': 'updateService', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Service id or shortname', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to update service', 'properties': {'adminFunction': {'type': 'str', 'description': 'If set, change the ADMIN function for this service, identified by function ID or shortname.'}, 'assignDefaultTech': {'type': 'bool', 'description': 'If set, change whether cases created for this service will be automatically assign tech to the executing user (if tech).'}, 'assignDefaultUser': {'type': 'bool', 'description': 'If set, change whether cases created for this service will be automatically assign user to the executing user (if not tech).'}, 'caseTypesToAdd': {'type': 'list', 'description': 'If set, enable the requested case type for this service.', 'items': {'type': 'str', 'description': 'If set, enable the requested case type for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'caseTypesToRemove': {'type': 'list', 'description': 'If set, disable the requested case type for this service. This will be rejected if any non-deleted cases exist which are bound to this service and casetype.', 'items': {'type': 'str', 'description': 'If set, disable the requested case type for this service. This will be rejected if any non-deleted cases exist which are bound to this service and casetype.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'caseTypesToSet': {'type': 'list', 'description': 'If set, override existing case types for this service. If this causes the service to remove a case type which has non-deleted cases bound to it, this will be rejected.', 'items': {'type': 'str', 'description': 'If set, override existing case types for this service. If this causes the service to remove a case type which has non-deleted cases bound to it, this will be rejected.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'str', 'description': 'If set, change the CREATE function for this service, identified by function ID or shortname.'}, 'defineFunction': {'type': 'str', 'description': 'If set, change the DEFINE function for this service, identified by function ID or shortname.'}, 'deprecated': {'type': 'bool', 'description': 'If set, enable/disable the deprecated flag for this service. Default is no change.'}, 'description': {'type': 'str', 'description': 'If set, change the longer description of the service.'}, 'eventEnabled': {'type': 'bool', 'description': 'If set, set whether service is integrated with events.'}, 'fieldPolicy': {'type': 'str', 'description': 'If set, change the field policy for this service. Changing the field policy will affect new cases and future updates to existing cases, but will not change fields set on existing cases.'}, 'handledBySoc': {'type': 'bool', 'description': 'If set, set whether this service is handled by SOC 24/7.'}, 'iconURL': {'type': 'str', 'description': 'If set, replace the icon for the service. An image data-URL on the form data:image/png;base64,BASE64IMAGEDATA', 'pattern': 'data:image/.+'}, 'listFunction': {'type': 'str', 'description': 'If set, change the LIST function for this service, identified by function ID or shortname.'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Set localized descriptions to override description for specified language. Only specified languages are changed.'}, 'description': 'Set localized descriptions to override description for specified language. Only specified languages are changed.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Set localized names to override name for specified language. Only specified languages are changed.'}, 'description': 'Set localized names to override name for specified language. Only specified languages are changed.'}, 'monitoredBySocOutsideOfficeHours': {'type': 'bool', 'description': 'If set, set whether this service is monitored by SOC outside office hours.'}, 'name': {'type': 'str', 'description': 'If set, change the descriptive name of the service.'}, 'notificationEmail': {'type': 'str', 'description': 'If set, change the service notification email address. [format:email]', 'x-Argus-Format': 'email'}, 'notifyFullFormat': {'type': 'bool', 'description': 'If set, change the format settings for notifying to the service notification email.'}, 'notifyOnClose': {'type': 'bool', 'description': 'If set, change settings for notifying the service notification email address on closed cases.'}, 'notifyOnCreate': {'type': 'bool', 'description': 'If set, change settings for notifying the service notification email address on created cases.'}, 'notifyOnUpdate': {'type': 'bool', 'description': 'If set, change settings for notifying the service notification email address on updated cases.'}, 'readFunction': {'type': 'str', 'description': 'If set, change the READ function for this service, identified by function ID or shortname.'}, 'shortName': {'type': 'str', 'description': 'If set, change the shortname of this service. This must be unique within a domain. WARNING: This may affect scripts using shortname as service identifier.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'techFunction': {'type': 'str', 'description': 'If set, change the TECH function for this service, identified by function ID or shortname.'}, 'workflows': {'type': 'dict', 'additionalProperties': {'type': 'bool', 'description': 'If set, modify workflows enabled for this service.'}, 'description': 'If set, modify workflows enabled for this service.'}, 'writeFunction': {'type': 'str', 'description': 'If set, change the WRITE function for this service, identified by function ID or shortname.'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update an existing service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'adminFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'caseTypes': {'type': 'array', 'description': 'The case types which are enabled for this service.', 'items': {'type': 'string', 'description': 'The case types which are enabled for this service.', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'uniqueItems': True}, 'createFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this service was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was created'}, 'defineFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'description': {'type': 'string', 'description': 'Service description'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'HANDLED_BY_SOC', 'MONITORED_BY_SOC_OUTSIDE_OFFICEHOURS', 'NOTIFICATION_ON_CREATE', 'NOTIFICATION_ON_UPDATE', 'NOTIFICATION_ON_CLOSE', 'NOTIFICATION_FORMAT_FULL', 'DEPRECATED', 'ASSIGN_DEFAULT_TECH', 'ASSIGN_DEFAULT_USER', 'EVENT_ENABLED']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'The ID of this service'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this service was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this service was last updated'}, 'listFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'localizedDescription': {'type': 'string', 'description': 'Localized description (current users language)'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized descriptions'}, 'description': 'Localized descriptions'}, 'localizedName': {'type': 'string', 'description': 'Localized name (current users language)'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Localized names'}, 'description': 'Localized names'}, 'logoURL': {'type': 'string', 'description': 'The logo data-URL used for this service'}, 'name': {'type': 'string', 'description': 'Service name'}, 'notificationEmail': {'type': 'string', 'description': 'The notification email configured for this service'}, 'readDetailedFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'readFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'shortName': {'type': 'string', 'description': 'Service shortname'}, 'techFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}, 'workflows': {'type': 'array', 'description': 'The workflows which are enabled for this service', 'items': {'type': 'string', 'description': 'The workflows which are enabled for this service', 'enum': ['validation', 'nocValidation', 'tuning', 'escalation', 'customerUpdate', 'escalateTI', 'escalateNSA', 'escalateLog', 'escalateInfra', 'escalateMSI', 'severityAlert', 'slaViolation', 'internalSlaViolation', 'delegateToSOC', 'escalateDEV', 'escalateTRS', 'escalateMSSAnalyst', 'escalateTAM', 'qaValidation', 'socAnalysis']}, 'uniqueItems': True}, 'writeFunction': {'type': 'object', 'description': 'The function required to show the service metadata (without access to any cases)', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateService'], 'x-Argus-ApiStatus': 'INTERNAL'}