"""Autogenerated API schema"""
from argus_api import session


add_customer_service_subscription = {'tags': ['cases/v2/servicesubscription'], 'summary': 'Subscribe a customer to a service (INTERNAL)', 'description': '', 'operationId': 'addCustomerServiceSubscription', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'customer': {'type': 'str', 'description': 'Shortname or ID of customer to subscribe for'}, 'fieldPolicy': {'type': 'str', 'description': 'If set, set the field policy to use for this subscription. This will override the field policy set for the service.'}, 'service': {'type': 'str', 'description': 'Shortname or ID of service to subscribe to'}}, 'required': ['customer', 'service']}}}, 'required': True}, 'responses': {'default': {'description': 'Subscribe a customer to a service', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this subscription was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was created'}, 'currentUserAccess': {'type': 'object', 'description': 'The current users access level for this subscription.', 'properties': {'access': {'type': 'array', 'description': 'The current users access levels on this case.', 'items': {'type': 'string', 'description': 'The current users access levels on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'uniqueItems': True}, 'level': {'type': 'string', 'description': 'The current users access level on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'role': {'type': 'string', 'description': 'The current users access role on this case.', 'enum': ['user', 'tech', 'admin']}}}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this subscription was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was last updated'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_customer_service_subscription = {'tags': ['cases/v2/servicesubscription'], 'summary': 'Remove service subscription (INTERNAL)', 'description': '', 'operationId': 'deleteCustomerServiceSubscription', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Subscription ID', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}], 'responses': {'default': {'description': 'Remove service subscription', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this subscription was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was created'}, 'currentUserAccess': {'type': 'object', 'description': 'The current users access level for this subscription.', 'properties': {'access': {'type': 'array', 'description': 'The current users access levels on this case.', 'items': {'type': 'string', 'description': 'The current users access levels on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'uniqueItems': True}, 'level': {'type': 'string', 'description': 'The current users access level on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'role': {'type': 'string', 'description': 'The current users access role on this case.', 'enum': ['user', 'tech', 'admin']}}}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this subscription was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was last updated'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_subscriptions = {'tags': ['cases/v2/servicesubscription'], 'summary': 'List service subscriptions. This endpoint will list all service subscriptions for customers and services the user has read access for. For customers which the user has permission viewAllCustomerServices, all services will be listed, regardless of service read access. (INTERNAL)', 'description': '', 'operationId': 'listSubscriptions', 'parameters': [{'name': 'customerID', 'in': 'query', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'customer', 'in': 'query', 'description': 'Limit result to specified list of customers (by shortname or id)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'service', 'in': 'query', 'description': 'Limit result to specified list of services (by id or shortname)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List service subscriptions. This endpoint will list all service subscriptions for customers and services the user has read access for. For customers which the user has permission viewAllCustomerServices, all services will be listed, regardless of service read access.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this subscription was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was created'}, 'currentUserAccess': {'type': 'object', 'description': 'The current users access level for this subscription.', 'properties': {'access': {'type': 'array', 'description': 'The current users access levels on this case.', 'items': {'type': 'string', 'description': 'The current users access levels on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'uniqueItems': True}, 'level': {'type': 'string', 'description': 'The current users access level on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'role': {'type': 'string', 'description': 'The current users access role on this case.', 'enum': ['user', 'tech', 'admin']}}}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this subscription was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was last updated'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewServiceSubscriptions'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_customer_service_subscription = {'tags': ['cases/v2/servicesubscription'], 'summary': 'Update service subscription (INTERNAL)', 'description': '', 'operationId': 'updateCustomerServiceSubscription', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Subscription ID', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'fieldPolicy': {'type': 'str', 'description': 'If set, change the field policy to use for this subscription. This will override the field policy set for the service.'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update service subscription', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'createdByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTime': {'type': 'string', 'description': 'Time when this subscription was created (in ISO-8601 time format)'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was created'}, 'currentUserAccess': {'type': 'object', 'description': 'The current users access level for this subscription.', 'properties': {'access': {'type': 'array', 'description': 'The current users access levels on this case.', 'items': {'type': 'string', 'description': 'The current users access levels on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'uniqueItems': True}, 'level': {'type': 'string', 'description': 'The current users access level on this case.', 'enum': ['none', 'read', 'write', 'create']}, 'role': {'type': 'string', 'description': 'The current users access role on this case.', 'enum': ['user', 'tech', 'admin']}}}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'fieldPolicy': {'type': 'object', 'description': 'The current field policy for this service, or null if no field policy is set.', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'description': 'The policy name'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'User which last updated this service', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'description': 'The domain this service is bound to', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTime': {'type': 'string', 'description': 'Time when this subscription was last updated (in ISO-8601 time format)'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when this subscription was last updated'}, 'service': {'type': 'object', 'description': 'Service which is subscribed to', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'Service ID'}, 'localizedName': {'type': 'string', 'description': 'Service name localized to the current users language'}, 'name': {'type': 'string', 'description': 'Service name'}, 'shortName': {'type': 'string', 'description': 'Service shortname'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCases'], 'x-Argus-ApiStatus': 'INTERNAL'}