"""Autogenerated API schema"""
from argus_api import session


get_case_template = {'tags': ['cases/v2/templates'], 'summary': 'Fetch template details (PUBLIC)', 'description': '', 'operationId': 'getCaseTemplate', 'parameters': [{'name': 'customer', 'in': 'query', 'description': 'If set, populate template with sections for this customer', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'id', 'in': 'path', 'description': 'The ID of the template to fetch', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Fetch template details', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'variables': {'type': 'array', 'items': {'type': 'object', 'properties': {'argusVariable': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int32'}, 'label': {'type': 'string'}, 'name': {'type': 'string'}}}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMSSTemplates'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_case_templates = {'tags': ['cases/v2/templates'], 'summary': 'List available templates (PUBLIC)', 'description': '', 'operationId': 'listCaseTemplates', 'parameters': [{'name': 'customer', 'in': 'query', 'description': 'If set, select templates for this customer', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'language', 'in': 'query', 'description': 'If set, select templates for this language', 'schema': {'type': 'str', 'default': 'english', 'enum': ['english', 'norwegian']}, 'type': 'str', 'default': 'english', 'enum': ['english', 'norwegian']}, {'name': 'keywords', 'in': 'query', 'description': 'If set, filter templates by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'List available templates', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'category': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int32'}, 'language': {'type': 'string', 'enum': ['english', 'norwegian']}, 'title': {'type': 'string'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMSSTemplates'], 'x-Argus-ApiStatus': 'PUBLIC'}
render_case_template = {'tags': ['cases/v2/templates'], 'summary': 'Fetch completed template using requested variables (PUBLIC)', 'description': '', 'operationId': 'fetchCompletedCaseTemplate', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'The ID of the template to fetch', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'customer': {'type': 'str', 'description': 'If set, return template with sections for this customer (by id or shortname).'}, 'variables': {'type': 'list', 'description': 'The variables to use when filling out the template', 'items': {'type': 'dict', 'properties': {'name': {'type': 'string'}, 'value': {'type': 'string'}}}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Fetch completed template using requested variables', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'A completed case template', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the filled out template'}, 'sections': {'type': 'array', 'description': 'The completed sections for this template', 'items': {'type': 'object', 'description': 'The completed sections for this template', 'properties': {'content': {'type': 'string'}, 'title': {'type': 'string'}}}}, 'subject': {'type': 'string', 'description': 'The completed subject template'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewMSSTemplates'], 'x-Argus-ApiStatus': 'PUBLIC'}