"""Autogenerated API schema"""
from argus_api import session


create_artifact = {'tags': ['configurationadmin/v1/code'], 'summary': 'Add new code artifact as JSON object (INTERNAL)', 'description': '', 'operationId': 'createArtifact', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to add a new artifact', 'properties': {'artifactID': {'type': 'str', 'description': 'The Maven artifactID of this artifact', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'data': {'type': 'str', 'maxLength': 2147483647, 'minLength': 10}, 'groupID': {'type': 'str', 'description': 'The Maven groupID of this artifact', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'version': {'type': 'str', 'description': 'The Maven version of this artifact', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}}, 'required': ['artifactID', 'data', 'groupID', 'version']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Add new code artifact as JSON object', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['codeProfileAdministration'], 'x-Argus-ApiStatus': 'INTERNAL'}
create_artifact_from_octet_stream = {'tags': ['configurationadmin/v1/code'], 'summary': 'Upload new code artifact as binary file upload (INTERNAL)', 'description': '', 'operationId': 'createArtifactFromOctetStream', 'parameters': [{'name': 'groupID', 'in': 'path', 'description': 'Group ID', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'artifactID', 'in': 'path', 'description': 'Artifact ID', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'version', 'in': 'path', 'description': 'Version', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/octet-stream': {'schema': {'type': 'string'}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Upload new code artifact as binary file upload', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['codeProfileAdministration'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_unused_artifacts = {'tags': ['configurationadmin/v1/code'], 'summary': 'Mark unused artifacts as deleted (INTERNAL)', 'description': '', 'operationId': 'deleteUnusedArtifacts', 'responses': {'default': {'description': 'Mark unused artifacts as deleted', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['codeProfileAdministration'], 'x-Argus-ApiStatus': 'INTERNAL'}
download_code_artifact_by_gav = {'tags': ['configurationadmin/v1/code'], 'summary': 'Download raw artifact by groupID, artifactID and version (GAV) (INTERNAL)', 'description': '', 'operationId': 'downloadCodeArtifactByGAV', 'parameters': [{'name': 'groupID', 'in': 'path', 'description': 'GroupID of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'artifactID', 'in': 'path', 'description': 'ArtifactID of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'version', 'in': 'path', 'description': 'Version of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Download raw artifact by groupID, artifactID and version (GAV)', 'content': {'application/octet-stream': {'schema': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/octet-stream': {}}}, '403': {'description': 'Access denied', 'content': {'application/octet-stream': {}}}, '404': {'description': 'Object not found', 'content': {'application/octet-stream': {}}}, '412': {'description': 'Validation error', 'content': {'application/octet-stream': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}
download_code_artifact_by_id = {'tags': ['configurationadmin/v1/code'], 'summary': 'Download artifact by ID (INTERNAL)', 'description': '', 'operationId': 'downloadCodeArtifactByID', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Download artifact by ID', 'content': {'application/octet-stream': {}}}, '401': {'description': 'Authentication failed', 'content': {'application/octet-stream': {}}}, '403': {'description': 'Access denied', 'content': {'application/octet-stream': {}}}, '404': {'description': 'Object not found', 'content': {'application/octet-stream': {}}}, '412': {'description': 'Validation error', 'content': {'application/octet-stream': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_code_artifact_by_gav = {'tags': ['configurationadmin/v1/code'], 'summary': 'Fetch code artifact metadata by groupID, artifactID and version (GAV) (INTERNAL)', 'description': '', 'operationId': 'getCodeArtifactByGAV', 'parameters': [{'name': 'groupID', 'in': 'path', 'description': 'GroupID of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'artifactID', 'in': 'path', 'description': 'ArtifactID of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'version', 'in': 'path', 'description': 'Version of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeData', 'in': 'query', 'description': 'If true, include encoded artifact binary data', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}], 'responses': {'default': {'description': 'Fetch code artifact metadata by groupID, artifactID and version (GAV)', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_code_artifcat_by_id = {'tags': ['configurationadmin/v1/code'], 'summary': 'Fetch code artifact metadata by hash ID (INTERNAL)', 'description': '', 'operationId': 'getCodeArtifcatByID', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of artifact to fetch', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeData', 'in': 'query', 'description': 'If true, include encoded artifact binary data', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}], 'responses': {'default': {'description': 'Fetch code artifact metadata by hash ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_code_artifacts = {'tags': ['configurationadmin/v1/code'], 'summary': 'List code artifacts (INTERNAL)', 'description': '', 'operationId': 'listCodeArtifacts', 'parameters': [{'name': 'search', 'in': 'query', 'description': 'Limit result to artifacts matching this search string', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'limit', 'in': 'query', 'description': 'Limit result', 'schema': {'type': 'int', 'default': '25'}, 'type': 'int', 'default': '25'}, {'name': 'offset', 'in': 'query', 'description': 'Offset result', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}, {'name': 'orderBy', 'in': 'query', 'description': 'Order result', 'schema': {'type': 'str', 'default': 'groupID', 'enum': ['id', 'groupID', 'artifactID', 'version', 'created', 'lastUpdated', 'status', 'length']}, 'type': 'str', 'default': 'groupID', 'enum': ['id', 'groupID', 'artifactID', 'version', 'created', 'lastUpdated', 'status', 'length']}, {'name': 'orderDesc', 'in': 'query', 'description': 'Sort results descending', 'schema': {'type': 'boolean'}, 'type': 'bool'}], 'responses': {'default': {'description': 'List code artifacts', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_unused_code_artifacts = {'tags': ['configurationadmin/v1/code'], 'summary': 'List unused artifact (INTERNAL)', 'description': '', 'operationId': 'listUnusedCodeArtifacts', 'responses': {'default': {'description': 'List unused artifact', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_code_artifacts = {'tags': ['configurationadmin/v1/code'], 'summary': 'Search code artifacts (INTERNAL)', 'description': '', 'operationId': 'searchCodeArtifacts', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Search criteria to search for code artifact', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'description': 'Search criteria to search for code artifact', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'searchString': {'type': 'str', 'description': 'Keyword search string'}, 'id': {'type': 'list', 'description': 'Only return artifacts with these specific ids', 'items': {'type': 'str', 'description': 'Only return artifacts with these specific ids'}, 'uniqueItems': True}, 'groupID': {'type': 'list', 'description': 'Only return artifacts with these groupIDs', 'items': {'type': 'str', 'description': 'Only return artifacts with these groupIDs'}, 'uniqueItems': True}, 'artifactID': {'type': 'list', 'description': 'Only return artifacts with these artifactIDs', 'items': {'type': 'str', 'description': 'Only return artifacts with these artifactIDs'}, 'uniqueItems': True}, 'version': {'type': 'list', 'description': 'Only return artifacts with these versions', 'items': {'type': 'str', 'description': 'Only return artifacts with these versions'}, 'uniqueItems': True}, 'status': {'type': 'list', 'description': 'Only return artifacts with these statuses', 'items': {'type': 'str', 'description': 'Only return artifacts with these statuses', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'uniqueItems': True}, 'gav': {'type': 'list', 'description': 'Only return artifacts which matches any of these GAVs', 'items': {'type': 'dict', 'description': 'Represents a specific artifact by groupID, artifactID AND version (all three must match)', 'properties': {'artifactID': {'type': 'str', 'description': 'artifactID of artifact to match'}, 'groupID': {'type': 'str', 'description': 'groupID of artifact to match'}, 'version': {'type': 'str', 'description': 'version of artifact to match'}}, 'required': ['artifactID', 'groupID', 'version']}, 'uniqueItems': True}, 'includeData': {'type': 'bool', 'deprecated': True, 'description': 'Also include artifact data in response. This option should not be used.'}, 'startTimestamp': {'type': 'int', 'description': 'Search artifacts created or updated after this timestamp'}, 'endTimestamp': {'type': 'int', 'description': 'Search artifacts created or updated before this timestamp'}, 'includeCreatedTimestamp': {'type': 'bool', 'default': True, 'description': 'Consider creation time in time filtering. Defaults to true.'}, 'includeLastUpdatedTimestamp': {'type': 'bool', 'default': False, 'description': 'Consider creation time in time filtering. Defaults to false.'}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'groupID', 'artifactID', 'version', 'created', 'lastUpdated', 'status', 'length', '-id', '-groupID', '-artifactID', '-version', '-created', '-lastUpdated', '-status', '-length']}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'searchString': {'type': 'str', 'description': 'Keyword search string'}, 'id': {'type': 'list', 'description': 'Only return artifacts with these specific ids', 'items': {'type': 'str', 'description': 'Only return artifacts with these specific ids'}, 'uniqueItems': True}, 'groupID': {'type': 'list', 'description': 'Only return artifacts with these groupIDs', 'items': {'type': 'str', 'description': 'Only return artifacts with these groupIDs'}, 'uniqueItems': True}, 'artifactID': {'type': 'list', 'description': 'Only return artifacts with these artifactIDs', 'items': {'type': 'str', 'description': 'Only return artifacts with these artifactIDs'}, 'uniqueItems': True}, 'version': {'type': 'list', 'description': 'Only return artifacts with these versions', 'items': {'type': 'str', 'description': 'Only return artifacts with these versions'}, 'uniqueItems': True}, 'status': {'type': 'list', 'description': 'Only return artifacts with these statuses', 'items': {'type': 'str', 'description': 'Only return artifacts with these statuses', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'uniqueItems': True}, 'gav': {'type': 'list', 'description': 'Only return artifacts which matches any of these GAVs', 'items': {'type': 'dict', 'description': 'Represents a specific artifact by groupID, artifactID AND version (all three must match)', 'properties': {'artifactID': {'type': 'str', 'description': 'artifactID of artifact to match'}, 'groupID': {'type': 'str', 'description': 'groupID of artifact to match'}, 'version': {'type': 'str', 'description': 'version of artifact to match'}}, 'required': ['artifactID', 'groupID', 'version']}, 'uniqueItems': True}, 'includeData': {'type': 'bool', 'deprecated': True, 'description': 'Also include artifact data in response. This option should not be used.'}, 'startTimestamp': {'type': 'int', 'description': 'Search artifacts created or updated after this timestamp'}, 'endTimestamp': {'type': 'int', 'description': 'Search artifacts created or updated before this timestamp'}, 'includeCreatedTimestamp': {'type': 'bool', 'default': True, 'description': 'Consider creation time in time filtering. Defaults to true.'}, 'includeLastUpdatedTimestamp': {'type': 'bool', 'default': False, 'description': 'Consider creation time in time filtering. Defaults to false.'}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'groupID', 'artifactID', 'version', 'created', 'lastUpdated', 'status', 'length', '-id', '-groupID', '-artifactID', '-version', '-created', '-lastUpdated', '-status', '-length']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search code artifacts', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.', 'properties': {'artifactID': {'type': 'string', 'description': 'The MVN artifactID'}, 'createdByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was created.'}, 'data': {'type': 'string'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'groupID': {'type': 'string', 'description': 'The MVN groupID'}, 'id': {'type': 'string'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when the artifact was last updated.'}, 'length': {'type': 'integer', 'format': 'int32', 'description': 'The size of this artifact (in bytes).'}, 'status': {'type': 'string', 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'version': {'type': 'string', 'description': 'The MVN version'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCodeProfiles'], 'x-Argus-ApiStatus': 'INTERNAL'}