"""Autogenerated API schema"""
from argus_api import session


get_functions = {'tags': ['currentuser/v1'], 'summary': "List the current user's permission functions regardless of customer (PUBLIC)", 'description': '', 'operationId': 'getCurrentUserFunctions', 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of functions', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned functions', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'onlyRoles', 'in': 'query', 'description': 'Only return functions marked as roles', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'requirePermission', 'in': 'query', 'description': 'Only return functions which current user has access to', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'maxSecurityLevel', 'in': 'query', 'description': 'Only return functions which are available with this security level', 'schema': {'type': 'str', 'default': 'current', 'enum': ['current', 'external', 'standard', 'administrative']}, 'type': 'str', 'default': 'current', 'enum': ['current', 'external', 'standard', 'administrative']}, {'name': 'keywords', 'in': 'query', 'description': 'Filter functions by keywords on name and description', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}], 'responses': {'default': {'description': "List the current user's permission functions regardless of customer", 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'description': {'type': 'string', 'description': 'Function description'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ROLE', 'SYSADM']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string', 'description': 'Function name'}, 'securityLevel': {'type': 'string', 'description': 'Function security level', 'enum': ['DEFAULT', 'ADMINISTRATIVE', 'EXTERNAL']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Forbidden permission', 'content': {'application/json': {}}}, '412': {'description': 'Invalid request', 'content': {'application/json': {}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}