"""Autogenerated API schema"""
from argus_api import session


get_customer = {'tags': ['customers/v2/customer'], 'summary': 'Returns a Customer identified by its ID or short name. (PUBLIC)', 'description': '', 'operationId': 'getBasicCustomer', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'Customer ID or short name', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Customer domain to lookup short name (defaults to current users domain)', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeProperties', 'in': 'query', 'description': 'Return with properties', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includePropertiesWithPrefix', 'in': 'query', 'description': 'Return with properties fetched by prefix', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Returns a Customer identified by its ID or short name.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Customer response object. Provides basic information about customer', 'properties': {'ancestorIDs': {'type': 'array', 'description': 'List with ID of all ancestors (including itself), self-first', 'items': {'type': 'integer', 'format': 'int64', 'description': 'List with ID of all ancestors (including itself), self-first'}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Set of flags that are on/true for this customer.', 'items': {'type': 'string', 'description': 'Set of flags that are on/true for this customer.', 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'language': {'type': 'string', 'description': 'The users chosen language', 'enum': ['norwegian', 'english']}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'parentID': {'type': 'integer', 'format': 'int64', 'description': 'Parent id, can be null, if the customer has no parent.'}, 'properties': {'type': 'array', 'description': 'List of properties, that the request specified are to be fetched with the customer object. If no properties were requested, null is returned', 'items': {'type': 'object', 'description': 'Property Descriptor with key, default value, type, and other data.', 'properties': {'defaultJsonValue': {'type': 'object'}, 'defaultValue': {'type': 'string', 'description': 'Default value from the descriptor'}, 'jsonValue': {'type': 'object'}, 'key': {'type': 'string', 'description': 'Key of the property'}, 'source': {'type': 'string', 'description': 'Source of the property', 'enum': ['descriptor', 'customer', 'inherited']}, 'value': {'type': 'string', 'description': 'Value of the property (in string format)'}}}, 'uniqueItems': True}, 'shortName': {'type': 'string', 'description': 'Short name of the customer.'}, 'timeZone': {'type': 'string', 'description': "Informs about the customer's time zone"}, 'type': {'type': 'string', 'description': 'Gives info if a customer is a group or a leaf type customer', 'enum': ['group', 'leaf']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewBasicCustomer'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_customer_logo = {'tags': ['customers/v2/customer'], 'summary': 'Returns a Customer logo by customer shortName or id. (PUBLIC)', 'description': '', 'operationId': 'getBasicCustomerLogo', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'Customer ID or shortName', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeDefault', 'in': 'query', 'description': 'Include default logo', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'domain', 'in': 'query', 'description': 'Customer domain to lookup shortName (defaults to current users domain)', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'size', 'in': 'query', 'description': 'The preferred size of the logo (small, medium, large, xlarge). Will resize the logo within the selected size, retaining aspect ratio.', 'schema': {'type': 'str', 'enum': ['small', 'medium', 'large', 'xlarge']}, 'type': 'str', 'enum': ['small', 'medium', 'large', 'xlarge']}], 'responses': {'default': {'description': 'Returns a Customer logo by customer shortName or id.', 'content': {'image/*': {}}}, '401': {'description': 'Authentication failed', 'content': {'image/*': {}}}, '403': {'description': 'Access denied', 'content': {'image/*': {}}}, '404': {'description': 'Object not found', 'content': {'image/*': {}}}, '412': {'description': 'Validation error', 'content': {'image/*': {}}}}, 'x-Argus-Required-Permissions': ['viewBasicCustomer'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_customer_properties = {'tags': ['customers/v2/customer'], 'summary': 'Returns a set of properties for the customer id or shortName by property name. (PUBLIC)', 'description': '', 'operationId': 'getBasicCustomerProperties', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'Customer ID or shortName', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Customer domain to lookup shortname (defaults to current users domain)', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'key', 'in': 'query', 'description': 'Filter for specific properties.', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'section', 'in': 'query', 'description': 'Filter for properties in specific sections.', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['general', 'sla', 'analysis', 'aer', 'ama', 'amq', 'ala', 'alc', 'irt', 'securedns', 'policy', 'integrations', 'notification', 'reporting', 'services', 'products', 'authentication', 'other', 'hidden']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['general', 'sla', 'analysis', 'aer', 'ama', 'amq', 'ala', 'alc', 'irt', 'securedns', 'policy', 'integrations', 'notification', 'reporting', 'services', 'products', 'authentication', 'other', 'hidden']}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'By how many records to offset results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'Returns a set of properties for the customer id or shortName by property name.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Property Descriptor with key, default value, type, and other data.', 'properties': {'defaultJsonValue': {'type': 'object'}, 'defaultValue': {'type': 'string', 'description': 'Default value from the descriptor'}, 'jsonValue': {'type': 'object'}, 'key': {'type': 'string', 'description': 'Key of the property'}, 'source': {'type': 'string', 'description': 'Source of the property', 'enum': ['descriptor', 'customer', 'inherited']}, 'value': {'type': 'string', 'description': 'Value of the property (in string format)'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewBasicCustomer'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_customer_user_roles = {'tags': ['customers/v2/customer'], 'summary': 'Returns a set of User roles for the customer id or shortName. (PUBLIC)', 'description': '', 'operationId': 'getBasicCustomerUserRoles', 'parameters': [{'name': 'idOrShortName', 'in': 'path', 'description': 'Customer ID or shortName', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'domain', 'in': 'query', 'description': 'Customer domain to lookup user (defaults to current users domain)', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Returns a set of User roles for the customer id or shortName.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'UserRole response object. Provides basic information about which users have important roles assigned.', 'properties': {'role': {'type': 'string', 'description': 'The role for this user.', 'enum': ['technicalAccountManager', 'logManager', 'networkManager', 'tiManager', 'keyAccountManager', 'trsAccountManager', 'cvmAccountManager', 'msiAccountManager']}, 'user': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewBasicCustomer'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_customers = {'tags': ['customers/v2/customer'], 'summary': 'Returns customers defined by query parameters (PUBLIC)', 'description': '', 'operationId': 'listBasicCustomers', 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'By how many records to offset results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'parent', 'in': 'query', 'description': 'Search by parent id or shortName', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includeProperties', 'in': 'query', 'description': 'Return with properties', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includePropertiesWithPrefix', 'in': 'query', 'description': 'Return with properties fetched by prefix', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort search result', 'schema': {'type': 'list', 'enum': ['id', 'name', 'shortName', 'relevance -id', '-name', '-shortName', '-relevance'], 'items': {'type': 'string'}}, 'type': 'list', 'enum': ['id', 'name', 'shortName', 'relevance -id', '-name', '-shortName', '-relevance'], 'items': {'type': 'string'}}], 'responses': {'default': {'description': 'Returns customers defined by query parameters', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Customer response object. Provides basic information about customer', 'properties': {'ancestorIDs': {'type': 'array', 'description': 'List with ID of all ancestors (including itself), self-first', 'items': {'type': 'integer', 'format': 'int64', 'description': 'List with ID of all ancestors (including itself), self-first'}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Set of flags that are on/true for this customer.', 'items': {'type': 'string', 'description': 'Set of flags that are on/true for this customer.', 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'language': {'type': 'string', 'description': 'The users chosen language', 'enum': ['norwegian', 'english']}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'parentID': {'type': 'integer', 'format': 'int64', 'description': 'Parent id, can be null, if the customer has no parent.'}, 'properties': {'type': 'array', 'description': 'List of properties, that the request specified are to be fetched with the customer object. If no properties were requested, null is returned', 'items': {'type': 'object', 'description': 'Property Descriptor with key, default value, type, and other data.', 'properties': {'defaultJsonValue': {'type': 'object'}, 'defaultValue': {'type': 'string', 'description': 'Default value from the descriptor'}, 'jsonValue': {'type': 'object'}, 'key': {'type': 'string', 'description': 'Key of the property'}, 'source': {'type': 'string', 'description': 'Source of the property', 'enum': ['descriptor', 'customer', 'inherited']}, 'value': {'type': 'string', 'description': 'Value of the property (in string format)'}}}, 'uniqueItems': True}, 'shortName': {'type': 'string', 'description': 'Short name of the customer.'}, 'timeZone': {'type': 'string', 'description': "Informs about the customer's time zone"}, 'type': {'type': 'string', 'description': 'Gives info if a customer is a group or a leaf type customer', 'enum': ['group', 'leaf']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewBasicCustomer'], 'x-Argus-ApiStatus': 'PUBLIC'}
search_customers = {'tags': ['customers/v2/customer'], 'summary': 'Returns customers defined by SearchBasicCustomerRequest (PUBLIC)', 'description': '', 'operationId': 'searchBasicCustomers', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Main search request object defining limit and offset and sort options.', 'properties': {'ancestor': {'type': 'list', 'description': 'Search for customers by ancestor customer id or shortname. Will return customers that descend from any of these parents.', 'items': {'type': 'str', 'description': 'Search for customers by ancestor customer id or shortname. Will return customers that descend from any of these parents.'}, 'uniqueItems': True}, 'customer': {'type': 'list', 'description': 'Restrict search to specified customers.', 'items': {'type': 'str', 'description': 'Restrict search to specified customers.'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Search for customers in one of these domains (by domain id or name).', 'items': {'type': 'str', 'description': 'Search for customers in one of these domains (by domain id or name).'}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': "Exclude objects which have excludeFlags set. For 'deleted' use the dedicated field", 'items': {'type': 'str', 'description': "Exclude objects which have excludeFlags set. For 'deleted' use the dedicated field", 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'list', 'description': "Only include objects which have includeFlags set. For 'deleted' use the dedicated field", 'items': {'type': 'str', 'description': "Only include objects which have includeFlags set. For 'deleted' use the dedicated field", 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'includeProperties': {'type': 'list', 'default': 'null', 'description': 'Include properties matching one of the specified keys. Only properties specified here, or by "includePropertiesWithPrefix" will be returned.', 'items': {'type': 'str', 'default': 'null', 'description': 'Include properties matching one of the specified keys. Only properties specified here, or by "includePropertiesWithPrefix" will be returned.'}, 'uniqueItems': True}, 'includePropertiesWithPrefix': {'type': 'list', 'default': 'null', 'description': 'Include properties matching one of the prefixes specified. Only properties specified by prefix, or by "includeProperties" will be returned.', 'items': {'type': 'str', 'default': 'null', 'description': 'Include properties matching one of the prefixes specified. Only properties specified by prefix, or by "includeProperties" will be returned.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'items': {'type': 'str', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'enum': ['id', 'name', 'shortName', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Search for customers by keywords.', 'items': {'type': 'str', 'description': 'Search for customers by keywords.'}, 'uniqueItems': True}, 'limit': {'type': 'int', 'description': 'Max number of results.', 'minimum': 0}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.', 'minimum': 0}, 'parent': {'type': 'list', 'description': 'Search for customers by parent customer id or shortname. Will return customers that are direct children of any of these parents.', 'items': {'type': 'str', 'description': 'Search for customers by parent customer id or shortname. Will return customers that are direct children of any of these parents.'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'default': 'id', 'description': 'Field to sort result by, use - to sort in desc order.', 'items': {'type': 'str', 'default': 'id', 'description': 'Field to sort result by, use - to sort in desc order.', 'enum': ['id', 'name', 'shortName', 'relevance', '-id', '-name', '-shortName', '-relevance']}}, 'subCriteria': {'type': 'list', 'description': 'Set additional criteria', 'items': {'type': 'dict', 'description': 'Request defining if sub-criteria should be included or excluded', 'properties': {'ancestor': {'type': 'list', 'description': 'Search for customers by ancestor customer id or shortname. Will return customers that descend from any of these parents.', 'items': {'type': 'str', 'description': 'Search for customers by ancestor customer id or shortname. Will return customers that descend from any of these parents.'}, 'uniqueItems': True}, 'customer': {'type': 'list', 'description': 'Restrict search to specified customers.', 'items': {'type': 'str', 'description': 'Restrict search to specified customers.'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Search for customers in one of these domains (by domain id or name).', 'items': {'type': 'str', 'description': 'Search for customers in one of these domains (by domain id or name).'}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Is this subcriteria required? If true the search is NOT-ed'}, 'excludeFlags': {'type': 'list', 'description': "Exclude objects which have excludeFlags set. For 'deleted' use the dedicated field", 'items': {'type': 'str', 'description': "Exclude objects which have excludeFlags set. For 'deleted' use the dedicated field", 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'includeFlags': {'type': 'list', 'description': "Only include objects which have includeFlags set. For 'deleted' use the dedicated field", 'items': {'type': 'str', 'description': "Only include objects which have includeFlags set. For 'deleted' use the dedicated field", 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'includeProperties': {'type': 'list', 'default': 'null', 'description': 'Include properties matching one of the specified keys. Only properties specified here, or by "includePropertiesWithPrefix" will be returned.', 'items': {'type': 'str', 'default': 'null', 'description': 'Include properties matching one of the specified keys. Only properties specified here, or by "includePropertiesWithPrefix" will be returned.'}, 'uniqueItems': True}, 'includePropertiesWithPrefix': {'type': 'list', 'default': 'null', 'description': 'Include properties matching one of the prefixes specified. Only properties specified by prefix, or by "includeProperties" will be returned.', 'items': {'type': 'str', 'default': 'null', 'description': 'Include properties matching one of the prefixes specified. Only properties specified by prefix, or by "includeProperties" will be returned.'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'items': {'type': 'str', 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'enum': ['id', 'name', 'shortName', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Search for customers by keywords.', 'items': {'type': 'str', 'description': 'Search for customers by keywords.'}, 'uniqueItems': True}, 'parent': {'type': 'list', 'description': 'Search for customers by parent customer id or shortname. Will return customers that are direct children of any of these parents.', 'items': {'type': 'str', 'description': 'Search for customers by parent customer id or shortname. Will return customers that are direct children of any of these parents.'}, 'uniqueItems': True}, 'required': {'type': 'bool', 'description': 'Is this subcriteria required? If true the search is AND-ed'}, 'type': 'list'}}, 'uniqueItems': True}, 'type': {'type': 'list', 'description': 'Search for customers by type.', 'items': {'type': 'str', 'description': 'Search for customers by type.', 'enum': ['group', 'leaf']}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Returns customers defined by SearchBasicCustomerRequest', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Customer response object. Provides basic information about customer', 'properties': {'ancestorIDs': {'type': 'array', 'description': 'List with ID of all ancestors (including itself), self-first', 'items': {'type': 'integer', 'format': 'int64', 'description': 'List with ID of all ancestors (including itself), self-first'}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Set of flags that are on/true for this customer.', 'items': {'type': 'string', 'description': 'Set of flags that are on/true for this customer.', 'enum': ['disabled', 'denySubmitForAnonymousUser', 'allowGlobalData', 'excludeFromProduction', 'networkBaseCustomer', 'singleNetworkDomain', 'customerDataDeleted', 'rootCustomerGroup']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'language': {'type': 'string', 'description': 'The users chosen language', 'enum': ['norwegian', 'english']}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'parentID': {'type': 'integer', 'format': 'int64', 'description': 'Parent id, can be null, if the customer has no parent.'}, 'properties': {'type': 'array', 'description': 'List of properties, that the request specified are to be fetched with the customer object. If no properties were requested, null is returned', 'items': {'type': 'object', 'description': 'Property Descriptor with key, default value, type, and other data.', 'properties': {'defaultJsonValue': {'type': 'object'}, 'defaultValue': {'type': 'string', 'description': 'Default value from the descriptor'}, 'jsonValue': {'type': 'object'}, 'key': {'type': 'string', 'description': 'Key of the property'}, 'source': {'type': 'string', 'description': 'Source of the property', 'enum': ['descriptor', 'customer', 'inherited']}, 'value': {'type': 'string', 'description': 'Value of the property (in string format)'}}}, 'uniqueItems': True}, 'shortName': {'type': 'string', 'description': 'Short name of the customer.'}, 'timeZone': {'type': 'string', 'description': "Informs about the customer's time zone"}, 'type': {'type': 'string', 'description': 'Gives info if a customer is a group or a leaf type customer', 'enum': ['group', 'leaf']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewBasicCustomer'], 'x-Argus-ApiStatus': 'PUBLIC'}