"""Autogenerated API schema"""
from argus_api import session


ingest_bulk_data = {'tags': ['datacollector/v1'], 'summary': 'Submit JSON data in bulk that will be forwarded to a Kafka topic based on its category (PUBLIC)', 'description': '', 'operationId': 'ingestBulkData', 'parameters': [{'name': 'category', 'in': 'path', 'description': 'What category the records belong to', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'ignoreOnFailed': {'type': 'bool', 'default': False, 'description': 'Whether or not to ignore any errors in the records'}, 'records': {'type': 'list', 'description': 'The records containing the JSON data', 'items': {'type': 'dict', 'properties': {'customer': {'type': 'str', 'description': 'The customer ID or shortname that this data belongs to. Defaults to the current users customer'}, 'data': {'type': 'string'}}}, 'maxItems': 1000, 'minItems': 1}}, 'required': ['records']}}}, 'required': True}, 'responses': {'default': {'description': 'Submit JSON data in bulk that will be forwarded to a Kafka topic based on its category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accepted': {'type': 'integer', 'format': 'int32', 'description': 'The number of accepted data submissions'}, 'errorInformationList': {'type': 'array', 'description': 'A list of information on errors in the data submissions', 'items': {'type': 'object', 'description': 'A list of information on errors in the data submissions', 'properties': {'errorMessages': {'type': 'array', 'description': 'The list of errors detected about the data', 'items': {'type': 'string', 'description': 'The list of errors detected about the data'}}, 'submissionIndex': {'type': 'integer', 'format': 'int32', 'description': 'The index into the data submission list this error is about'}}}}, 'rejected': {'type': 'integer', 'format': 'int32', 'description': 'The number of rejected data submissions'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['submitDataIngest'], 'x-Argus-ApiStatus': 'PUBLIC'}
ingest_data = {'tags': ['datacollector/v1'], 'summary': 'Submit JSON data that will be forwarded to a Kafka topic based on its category (PUBLIC)', 'description': '', 'operationId': 'ingestData', 'parameters': [{'name': 'category', 'in': 'path', 'description': 'What category the records belong to', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'customer', 'in': 'query', 'description': 'The customer ID or shortname that this data belongs to. Defaults to the current users customer', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'ignoreOnFailed', 'in': 'query', 'description': 'Whether or not to ignore any errors in the record', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object'}}}, 'required': True}, 'responses': {'default': {'description': 'Submit JSON data that will be forwarded to a Kafka topic based on its category', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accepted': {'type': 'integer', 'format': 'int32', 'description': 'The number of accepted data submissions'}, 'errorInformationList': {'type': 'array', 'description': 'A list of information on errors in the data submissions', 'items': {'type': 'object', 'description': 'A list of information on errors in the data submissions', 'properties': {'errorMessages': {'type': 'array', 'description': 'The list of errors detected about the data', 'items': {'type': 'string', 'description': 'The list of errors detected about the data'}}, 'submissionIndex': {'type': 'integer', 'format': 'int32', 'description': 'The index into the data submission list this error is about'}}}}, 'rejected': {'type': 'integer', 'format': 'int32', 'description': 'The number of rejected data submissions'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['submitDataIngest'], 'x-Argus-ApiStatus': 'PUBLIC'}