"""Autogenerated API schema"""
from argus_api import session


add_document_fragment = {'tags': ['documents/v1'], 'summary': 'Upload next fragment of data to a prepared document.Fragments MUST be uploaded in order, first fragment with index 0. (PUBLIC)', 'description': 'Submit document fragment as raw data to this request.', 'operationId': 'addDocumentFragment', 'parameters': [{'name': 'documentID', 'in': 'path', 'description': 'Document ID (as returned from the prepare endpoint)', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}, {'name': 'idx', 'in': 'path', 'description': 'Fragment index', 'required': True, 'schema': {'type': 'int'}, 'type': 'int'}], 'requestBody': {'content': {'*': {'schema': {'type': 'object'}}}}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Upload next fragment of data to a prepared document.Fragments MUST be uploaded in order, first fragment with index 0.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accessMode': {'type': 'string', 'description': 'General access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'createdByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was created'}, 'currentUserAccessLevel': {'type': 'string', 'description': 'Access level granted to the user viewing the folder/document', 'enum': ['none', 'folder', 'read', 'write']}, 'currentUserLockStatus': {'type': 'string', 'description': 'The lock status of this document, for the current user.', 'enum': ['unlocked', 'lockedOtherUser', 'lockedCurrentUser', 'lockedOtherUserCanOverride']}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'dataSize': {'type': 'integer', 'format': 'int64', 'description': 'Size of the document content in bytes'}, 'documentType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document']}, 'effectiveAccessMode': {'type': 'string', 'description': 'Effective access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'elementType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document', 'folder']}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ATTACHMENT', 'CONTROLLED_VERSION', 'UNCOMMITTED', 'LOCKED_BY_CURRENTUSER']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder/document'}, 'labels': {'type': 'array', 'description': 'Free-text labels assigned to the document', 'items': {'type': 'string', 'description': 'Free-text labels assigned to the document'}, 'uniqueItems': True}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was last updated'}, 'lockedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lockedUntilTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Until when the document is locked'}, 'masterID': {'type': 'integer', 'format': 'int64', 'description': 'Points to the master document of this revision'}, 'mimeType': {'type': 'string', 'description': 'MIME type of the document content'}, 'name': {'type': 'string', 'description': 'Name of the folder/document'}, 'ownedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'parentElements': {'type': 'array', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'items': {'type': 'object', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'properties': {'accessMode': {'type': 'string', 'description': 'The configured access mode set on this folder', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder'}, 'name': {'type': 'string', 'description': 'Name of the folder'}}}}, 'publishDueTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document must be published (due date)'}, 'publishedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'publishedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document was published'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'Revision count'}, 'sha256': {'type': 'string', 'description': 'SHA256 digest of this document'}, 'state': {'type': 'string', 'description': 'Current state of the document', 'enum': ['draft', 'published', 'discarded', 'incomplete']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Specified document ID does not exist', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewDocuments'], 'x-Argus-ApiStatus': 'PUBLIC'}
complete_document_upload = {'tags': ['documents/v1'], 'summary': 'Finalize upload of document.Completion request must specify correct checksum and document size. (PUBLIC)', 'description': 'Finalize upload of document', 'operationId': 'completeDocumentUpload', 'parameters': [{'name': 'documentID', 'in': 'path', 'description': 'Document ID (as returned from the prepare endpoint)', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'documentID': {'type': 'int', 'description': 'ID of the document to complete.'}, 'notificationOptions': {'type': 'dict', 'properties': {'skip': {'type': 'bool', 'description': 'If true, skip notification for current operation.'}}}, 'sha256': {'type': 'str', 'description': 'The sha256 of the entire document.'}}, 'required': ['sha256']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Finalize upload of document.Completion request must specify correct checksum and document size.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accessMode': {'type': 'string', 'description': 'General access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'createdByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was created'}, 'currentUserAccessLevel': {'type': 'string', 'description': 'Access level granted to the user viewing the folder/document', 'enum': ['none', 'folder', 'read', 'write']}, 'currentUserLockStatus': {'type': 'string', 'description': 'The lock status of this document, for the current user.', 'enum': ['unlocked', 'lockedOtherUser', 'lockedCurrentUser', 'lockedOtherUserCanOverride']}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'dataSize': {'type': 'integer', 'format': 'int64', 'description': 'Size of the document content in bytes'}, 'documentType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document']}, 'effectiveAccessMode': {'type': 'string', 'description': 'Effective access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'elementType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document', 'folder']}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ATTACHMENT', 'CONTROLLED_VERSION', 'UNCOMMITTED', 'LOCKED_BY_CURRENTUSER']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder/document'}, 'labels': {'type': 'array', 'description': 'Free-text labels assigned to the document', 'items': {'type': 'string', 'description': 'Free-text labels assigned to the document'}, 'uniqueItems': True}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was last updated'}, 'lockedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lockedUntilTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Until when the document is locked'}, 'masterID': {'type': 'integer', 'format': 'int64', 'description': 'Points to the master document of this revision'}, 'mimeType': {'type': 'string', 'description': 'MIME type of the document content'}, 'name': {'type': 'string', 'description': 'Name of the folder/document'}, 'ownedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'parentElements': {'type': 'array', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'items': {'type': 'object', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'properties': {'accessMode': {'type': 'string', 'description': 'The configured access mode set on this folder', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder'}, 'name': {'type': 'string', 'description': 'Name of the folder'}}}}, 'publishDueTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document must be published (due date)'}, 'publishedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'publishedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document was published'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'Revision count'}, 'sha256': {'type': 'string', 'description': 'SHA256 digest of this document'}, 'state': {'type': 'string', 'description': 'Current state of the document', 'enum': ['draft', 'published', 'discarded', 'incomplete']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Specified document ID does not exist', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewDocuments'], 'x-Argus-ApiStatus': 'PUBLIC'}
discard_document_upload = {'tags': ['documents/v1'], 'summary': 'Abort and discard fragmented upload. (PUBLIC)', 'description': '', 'operationId': 'disardDocumentUpload', 'parameters': [{'name': 'documentID', 'in': 'path', 'description': 'Document ID (as returned from the prepare endpoint)', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Abort and discard fragmented upload.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accessMode': {'type': 'string', 'description': 'General access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'createdByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was created'}, 'currentUserAccessLevel': {'type': 'string', 'description': 'Access level granted to the user viewing the folder/document', 'enum': ['none', 'folder', 'read', 'write']}, 'currentUserLockStatus': {'type': 'string', 'description': 'The lock status of this document, for the current user.', 'enum': ['unlocked', 'lockedOtherUser', 'lockedCurrentUser', 'lockedOtherUserCanOverride']}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'dataSize': {'type': 'integer', 'format': 'int64', 'description': 'Size of the document content in bytes'}, 'documentType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document']}, 'effectiveAccessMode': {'type': 'string', 'description': 'Effective access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'elementType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document', 'folder']}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ATTACHMENT', 'CONTROLLED_VERSION', 'UNCOMMITTED', 'LOCKED_BY_CURRENTUSER']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder/document'}, 'labels': {'type': 'array', 'description': 'Free-text labels assigned to the document', 'items': {'type': 'string', 'description': 'Free-text labels assigned to the document'}, 'uniqueItems': True}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was last updated'}, 'lockedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lockedUntilTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Until when the document is locked'}, 'masterID': {'type': 'integer', 'format': 'int64', 'description': 'Points to the master document of this revision'}, 'mimeType': {'type': 'string', 'description': 'MIME type of the document content'}, 'name': {'type': 'string', 'description': 'Name of the folder/document'}, 'ownedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'parentElements': {'type': 'array', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'items': {'type': 'object', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'properties': {'accessMode': {'type': 'string', 'description': 'The configured access mode set on this folder', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder'}, 'name': {'type': 'string', 'description': 'Name of the folder'}}}}, 'publishDueTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document must be published (due date)'}, 'publishedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'publishedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document was published'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'Revision count'}, 'sha256': {'type': 'string', 'description': 'SHA256 digest of this document'}, 'state': {'type': 'string', 'description': 'Current state of the document', 'enum': ['draft', 'published', 'discarded', 'incomplete']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Specified document ID does not exist', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewDocuments'], 'x-Argus-ApiStatus': 'PUBLIC'}
prepare_upload = {'tags': ['documents/v1'], 'summary': 'Prepare upload of a new document (PUBLIC)', 'description': 'Invoke this endpoint to prepare for fragmented document upload.Use the returned document ID to upload and complete fragments.', 'operationId': 'prepareUpload', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'accessMode': {'type': 'str', 'default': 'roleBased', 'description': 'General access mode of new document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'inheritExplicitPermissions': {'type': 'bool', 'default': False, 'description': 'Inherit explicit permissions from parent folder'}, 'lockRequestTime': {'type': 'int', 'default': 0, 'description': 'Specify how long the document should be locked'}, 'mimeType': {'type': 'str', 'description': 'MIME type of document content'}, 'name': {'type': 'str', 'description': 'Name of new document', 'pattern': '\\A[^\\\\\\/:*"\'?<>|]{1,254}\\z'}, 'overwriteExisting': {'type': 'bool', 'description': 'If true, overwrite existing document with same name in parent folder, as a new revision.'}, 'parentFolderID': {'type': 'int', 'description': 'The ID of the parent folder to upload into'}}, 'required': ['accessMode', 'mimeType', 'name']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Prepare upload of a new document', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accessMode': {'type': 'string', 'description': 'General access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'createdByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was created'}, 'currentUserAccessLevel': {'type': 'string', 'description': 'Access level granted to the user viewing the folder/document', 'enum': ['none', 'folder', 'read', 'write']}, 'currentUserLockStatus': {'type': 'string', 'description': 'The lock status of this document, for the current user.', 'enum': ['unlocked', 'lockedOtherUser', 'lockedCurrentUser', 'lockedOtherUserCanOverride']}, 'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'dataSize': {'type': 'integer', 'format': 'int64', 'description': 'Size of the document content in bytes'}, 'documentType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document']}, 'effectiveAccessMode': {'type': 'string', 'description': 'Effective access mode of the folder/document', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'elementType': {'type': 'string', 'description': "Will be 'document'", 'enum': ['document', 'folder']}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['ATTACHMENT', 'CONTROLLED_VERSION', 'UNCOMMITTED', 'LOCKED_BY_CURRENTUSER']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder/document'}, 'labels': {'type': 'array', 'description': 'Free-text labels assigned to the document', 'items': {'type': 'string', 'description': 'Free-text labels assigned to the document'}, 'uniqueItems': True}, 'lastUpdatedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the folder/document was last updated'}, 'lockedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'lockedUntilTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Until when the document is locked'}, 'masterID': {'type': 'integer', 'format': 'int64', 'description': 'Points to the master document of this revision'}, 'mimeType': {'type': 'string', 'description': 'MIME type of the document content'}, 'name': {'type': 'string', 'description': 'Name of the folder/document'}, 'ownedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'parentElements': {'type': 'array', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'items': {'type': 'object', 'description': "Full path of the folder's/document's parent folders (ordered from root to parent folder; empty if root folder)", 'properties': {'accessMode': {'type': 'string', 'description': 'The configured access mode set on this folder', 'enum': ['roleBased', 'writeRestricted', 'readRestricted', 'explicit']}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'Unique identifier of the folder'}, 'name': {'type': 'string', 'description': 'Name of the folder'}}}}, 'publishDueTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document must be published (due date)'}, 'publishedByUser': {'type': 'object', 'description': 'Who updated the folder/document last', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'publishedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the document was published'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'Revision count'}, 'sha256': {'type': 'string', 'description': 'SHA256 digest of this document'}, 'state': {'type': 'string', 'description': 'Current state of the document', 'enum': ['draft', 'published', 'discarded', 'incomplete']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Parent folder not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewDocuments'], 'x-Argus-ApiStatus': 'PUBLIC'}