"""Autogenerated API schema"""
from argus_api import session


get_events_for_case = {'tags': ['events/v1'], 'summary': 'Fetch events associated with specified case (PUBLIC)', 'description': 'Fetch events associated with case that has ID specified in the url, it will also figure out which cases have been merged into the specified case,and fetch events for those merged cases as well.\nResult of events will be sorted by event start timestamp in descending order.', 'operationId': 'getEventsForCase', 'parameters': [{'name': 'Accept', 'in': 'header', 'schema': {'type': 'string'}}, {'name': 'caseID', 'in': 'path', 'description': 'Case ID', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results, 0 is everything', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'sortBy', 'in': 'query', 'description': 'List of properties to sort by (prefix with "-" to sort descending).Only accepts timestamp and -timestamp.If no value is given, it defaults to sorting by descending timestamp.', 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'includeRawEvents', 'in': 'query', 'description': 'If the result should include raw events. Defaults to false.', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}], 'responses': {'default': {'description': 'Fetch events associated with specified case', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'associatedCase': {'type': 'object', 'description': 'Case information for the cases associated to the event.', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64'}, 'categoryName': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int64'}, 'priority': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'service': {'type': 'string'}, 'status': {'type': 'string', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'subject': {'type': 'string'}}}, 'associatedCases': {'type': 'array', 'description': 'Case information for the cases associated to the event.', 'items': {'type': 'object', 'description': 'Case information for the cases associated to the event.', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64'}, 'categoryName': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int64'}, 'priority': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'service': {'type': 'string'}, 'status': {'type': 'string', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'subject': {'type': 'string'}}}, 'uniqueItems': True}, 'attackInfo': {'type': 'object', 'description': 'Information on the attack type for the event', 'properties': {'alarmDescription': {'type': 'string'}, 'alarmID': {'type': 'integer', 'format': 'int64'}, 'attackCategoryID': {'type': 'integer', 'format': 'int64'}, 'attackCategoryName': {'type': 'string'}, 'signature': {'type': 'string'}}}, 'comments': {'type': 'array', 'description': 'User, or agent, generated comments for the event', 'items': {'type': 'object', 'description': 'User, or agent, generated comments for the event', 'properties': {'comment': {'type': 'string', 'description': "The comment's text."}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Number of observations for this aggregate'}, 'customerInfo': {'type': 'object', 'description': 'The customer information related to the event', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'destination': {'type': 'object', 'description': 'Information regarding the destination endpoint', 'properties': {'geoLocation': {'type': 'object', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'latitude': {'type': 'number', 'format': 'double'}, 'locationName': {'type': 'string'}, 'longitude': {'type': 'number', 'format': 'double'}}}, 'networkAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'port': {'type': 'integer', 'format': 'int32'}}}, 'destinationAddress': {'type': 'string', 'writeOnly': True}, 'destinationAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'destinationPort': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'detailedEventIDS': {'type': 'array', 'items': {'type': 'string'}, 'uniqueItems': True}, 'domain': {'type': 'object', 'description': 'The Fully Qualified Domain Name', 'properties': {'fqdn': {'type': 'string'}}}, 'endTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Last observed event for this aggregate'}, 'flags': {'type': 'array', 'items': {'type': 'string', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD', 'REASSESSED', 'NOTIFIED_UNPUBLISHED', 'NOTIFIED_DELETED', 'EVENT_FROM_OT_ENVIRONMENT', 'EVENT_FROM_RESTRICTED_IT_ENVIRONMENT']}, 'uniqueItems': True}, 'id': {'type': 'string', 'xml': {'attribute': True}}, 'intruderAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Last update for the aggregated event'}, 'location': {'type': 'object', 'description': 'Information on the location of the event', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'timeZone': {'type': 'string'}}}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Dynamic list of properties related to the event'}, 'description': 'Dynamic list of properties related to the event'}, 'protocol': {'type': 'string'}, 'severity': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'source': {'type': 'object', 'description': 'Information regarding the destination endpoint', 'properties': {'geoLocation': {'type': 'object', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'latitude': {'type': 'number', 'format': 'double'}, 'locationName': {'type': 'string'}, 'longitude': {'type': 'number', 'format': 'double'}}}, 'networkAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'port': {'type': 'integer', 'format': 'int32'}}}, 'sourceAddress': {'type': 'string', 'writeOnly': True}, 'sourceAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'sourcePort': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'startTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'First observed event for this aggregate'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the event happened.'}, 'uri': {'type': 'string', 'description': 'URI of the event'}, 'victimAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}}}}}}}, 'text/csv': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'associatedCase': {'type': 'object', 'description': 'Case information for the cases associated to the event.', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64'}, 'categoryName': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int64'}, 'priority': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'service': {'type': 'string'}, 'status': {'type': 'string', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'subject': {'type': 'string'}}}, 'associatedCases': {'type': 'array', 'description': 'Case information for the cases associated to the event.', 'items': {'type': 'object', 'description': 'Case information for the cases associated to the event.', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64'}, 'categoryName': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int64'}, 'priority': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'service': {'type': 'string'}, 'status': {'type': 'string', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'subject': {'type': 'string'}}}, 'uniqueItems': True}, 'attackInfo': {'type': 'object', 'description': 'Information on the attack type for the event', 'properties': {'alarmDescription': {'type': 'string'}, 'alarmID': {'type': 'integer', 'format': 'int64'}, 'attackCategoryID': {'type': 'integer', 'format': 'int64'}, 'attackCategoryName': {'type': 'string'}, 'signature': {'type': 'string'}}}, 'comments': {'type': 'array', 'description': 'User, or agent, generated comments for the event', 'items': {'type': 'object', 'description': 'User, or agent, generated comments for the event', 'properties': {'comment': {'type': 'string', 'description': "The comment's text."}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Number of observations for this aggregate'}, 'customerInfo': {'type': 'object', 'description': 'The customer information related to the event', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'destination': {'type': 'object', 'description': 'Information regarding the destination endpoint', 'properties': {'geoLocation': {'type': 'object', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'latitude': {'type': 'number', 'format': 'double'}, 'locationName': {'type': 'string'}, 'longitude': {'type': 'number', 'format': 'double'}}}, 'networkAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'port': {'type': 'integer', 'format': 'int32'}}}, 'destinationAddress': {'type': 'string', 'writeOnly': True}, 'destinationAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'destinationPort': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'detailedEventIDS': {'type': 'array', 'items': {'type': 'string'}, 'uniqueItems': True}, 'domain': {'type': 'object', 'description': 'The Fully Qualified Domain Name', 'properties': {'fqdn': {'type': 'string'}}}, 'endTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Last observed event for this aggregate'}, 'flags': {'type': 'array', 'items': {'type': 'string', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD', 'REASSESSED', 'NOTIFIED_UNPUBLISHED', 'NOTIFIED_DELETED', 'EVENT_FROM_OT_ENVIRONMENT', 'EVENT_FROM_RESTRICTED_IT_ENVIRONMENT']}, 'uniqueItems': True}, 'id': {'type': 'string', 'xml': {'attribute': True}}, 'intruderAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Last update for the aggregated event'}, 'location': {'type': 'object', 'description': 'Information on the location of the event', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'timeZone': {'type': 'string'}}}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Dynamic list of properties related to the event'}, 'description': 'Dynamic list of properties related to the event'}, 'protocol': {'type': 'string'}, 'severity': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'source': {'type': 'object', 'description': 'Information regarding the destination endpoint', 'properties': {'geoLocation': {'type': 'object', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'latitude': {'type': 'number', 'format': 'double'}, 'locationName': {'type': 'string'}, 'longitude': {'type': 'number', 'format': 'double'}}}, 'networkAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'port': {'type': 'integer', 'format': 'int32'}}}, 'sourceAddress': {'type': 'string', 'writeOnly': True}, 'sourceAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'sourcePort': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'startTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'First observed event for this aggregate'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the event happened.'}, 'uri': {'type': 'string', 'description': 'URI of the event'}, 'victimAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}}}}}}}, 'application/jsonl': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'associatedCase': {'type': 'object', 'description': 'Case information for the cases associated to the event.', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64'}, 'categoryName': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int64'}, 'priority': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'service': {'type': 'string'}, 'status': {'type': 'string', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'subject': {'type': 'string'}}}, 'associatedCases': {'type': 'array', 'description': 'Case information for the cases associated to the event.', 'items': {'type': 'object', 'description': 'Case information for the cases associated to the event.', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64'}, 'categoryName': {'type': 'string'}, 'id': {'type': 'integer', 'format': 'int64'}, 'priority': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'service': {'type': 'string'}, 'status': {'type': 'string', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'subject': {'type': 'string'}}}, 'uniqueItems': True}, 'attackInfo': {'type': 'object', 'description': 'Information on the attack type for the event', 'properties': {'alarmDescription': {'type': 'string'}, 'alarmID': {'type': 'integer', 'format': 'int64'}, 'attackCategoryID': {'type': 'integer', 'format': 'int64'}, 'attackCategoryName': {'type': 'string'}, 'signature': {'type': 'string'}}}, 'comments': {'type': 'array', 'description': 'User, or agent, generated comments for the event', 'items': {'type': 'object', 'description': 'User, or agent, generated comments for the event', 'properties': {'comment': {'type': 'string', 'description': "The comment's text."}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the comment was added.'}, 'user': {'type': 'object', 'description': 'Who added the comment.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Number of observations for this aggregate'}, 'customerInfo': {'type': 'object', 'description': 'The customer information related to the event', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'destination': {'type': 'object', 'description': 'Information regarding the destination endpoint', 'properties': {'geoLocation': {'type': 'object', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'latitude': {'type': 'number', 'format': 'double'}, 'locationName': {'type': 'string'}, 'longitude': {'type': 'number', 'format': 'double'}}}, 'networkAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'port': {'type': 'integer', 'format': 'int32'}}}, 'destinationAddress': {'type': 'string', 'writeOnly': True}, 'destinationAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'destinationPort': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'detailedEventIDS': {'type': 'array', 'items': {'type': 'string'}, 'uniqueItems': True}, 'domain': {'type': 'object', 'description': 'The Fully Qualified Domain Name', 'properties': {'fqdn': {'type': 'string'}}}, 'endTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Last observed event for this aggregate'}, 'flags': {'type': 'array', 'items': {'type': 'string', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD', 'REASSESSED', 'NOTIFIED_UNPUBLISHED', 'NOTIFIED_DELETED', 'EVENT_FROM_OT_ENVIRONMENT', 'EVENT_FROM_RESTRICTED_IT_ENVIRONMENT']}, 'uniqueItems': True}, 'id': {'type': 'string', 'xml': {'attribute': True}}, 'intruderAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Last update for the aggregated event'}, 'location': {'type': 'object', 'description': 'Information on the location of the event', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'timeZone': {'type': 'string'}}}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'Dynamic list of properties related to the event'}, 'description': 'Dynamic list of properties related to the event'}, 'protocol': {'type': 'string'}, 'severity': {'type': 'string', 'enum': ['low', 'medium', 'high', 'critical']}, 'source': {'type': 'object', 'description': 'Information regarding the destination endpoint', 'properties': {'geoLocation': {'type': 'object', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'latitude': {'type': 'number', 'format': 'double'}, 'locationName': {'type': 'string'}, 'longitude': {'type': 'number', 'format': 'double'}}}, 'networkAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'port': {'type': 'integer', 'format': 'int32'}}}, 'sourceAddress': {'type': 'string', 'writeOnly': True}, 'sourceAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'sourcePort': {'type': 'integer', 'format': 'int32', 'writeOnly': True}, 'startTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'First observed event for this aggregate'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the event happened.'}, 'uri': {'type': 'string', 'description': 'URI of the event'}, 'victimAggregationBits': {'type': 'integer', 'format': 'int32', 'writeOnly': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}, 'text/csv': {}, 'application/jsonl': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}, 'text/csv': {}, 'application/jsonl': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}, 'text/csv': {}, 'application/jsonl': {}}}}, 'x-Argus-Required-Permissions': ['viewEventsByCase'], 'x-Argus-ApiStatus': 'PUBLIC'}