"""Autogenerated API schema"""
from argus_api import session


list_events_by_case = {'tags': ['events/v2'], 'summary': 'Lists events associated with the case (DEV)', 'description': '', 'operationId': 'listEventsByCaseV2', 'parameters': [{'name': 'Accept', 'in': 'header', 'schema': {'type': 'string'}}, {'name': 'caseID', 'in': 'path', 'description': 'Case ID', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}, {'name': 'includeAllProperties', 'in': 'query', 'description': "Whether to include all properties of events (overrides the selection of 'includeProperties' if set to true).", 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'includeComments', 'in': 'query', 'description': 'Whether to include comments of events.', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'includeSubEvents', 'in': 'query', 'description': "Whether to include sub-events' IDs.", 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'includeProperties', 'in': 'query', 'description': 'Which event properties to include (if includeAllProperties=false).', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'sortBy', 'in': 'query', 'description': "Fields to sort events by (without sign is ascending, with '-' sign is descending).", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'limit', 'in': 'query', 'description': 'The max amount of events to return (0 means no limit)', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'The amount of events to skip from the beginning', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}], 'responses': {'default': {'description': 'Lists events associated with the case', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'alarm': {'type': 'object', 'description': 'Alarm associated with the event.', 'properties': {'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the alarm.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}}}, 'associatedCases': {'type': 'array', 'description': 'Cases associated with the event (only available for aggregate events).', 'items': {'type': 'object', 'description': 'Cases associated with the event (only available for aggregate events).', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64', 'description': 'Category ID of the case.'}, 'categoryName': {'type': 'string', 'description': 'Category name of the case.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the associated case.'}, 'priority': {'type': 'string', 'description': 'Priority of the case.', 'enum': ['low', 'medium', 'high', 'critical']}, 'serviceID': {'type': 'integer', 'format': 'int64', 'description': 'Service ID of the case.'}, 'serviceName': {'type': 'string', 'description': 'Service name of the case.'}, 'status': {'type': 'string', 'description': 'Status of the case.', 'enum': ['closed', 'pendingClose', 'pendingCustomer', 'pendingSoc', 'pendingVendor', 'workingCustomer', 'workingSoc']}, 'subject': {'type': 'string', 'description': 'Subject of the case.'}}}}, 'attackCategory': {'type': 'object', 'description': 'Attack category associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the attack category.'}, 'name': {'type': 'string', 'description': 'Name of the attack category.'}, 'shortName': {'type': 'string', 'description': 'Short name of the attack category.'}}}, 'comments': {'type': 'array', 'description': 'If requested, contains the comments added to the event.', 'items': {'type': 'object', 'description': 'If requested, contains the comments added to the event.', 'properties': {'comment': {'type': 'string', 'description': 'Contents of the comment.'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the comment was created.'}, 'user': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Count of aggregate events, always 1 for raw events'}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'destination': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'domain': {'type': 'string', 'description': 'Fully qualified domain name associated with the event.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the event.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the event.', 'enum': ['established', 'blocked', 'partiallyBlocked', 'snapshot', 'finalized', 'falsePositive', 'notAThreat', 'tuningCandidate', 'notified', 'notifiedUnpublished', 'notifiedDeleted', 'followup', 'partiallyNotified', 'identifiedThreat', 'threatCandidate', 'acknowledged', 'partiallyAcknowledged', 'severityAdjusted', 'commented', 'filtered', 'checked', 'incompleteDetails', 'aggregatedBaseEvent', 'remoteStorage', 'hasDetails', 'hasPayload', 'hasPcap', 'associatedToCaseByFilter', 'severityIncreasedByFilter', 'severityReducedByFilter', 'createdByAnalysisFilter', 'extendEventTtl', 'initialTuning', 'postAnalysis', 'partialSslTerminated', 'sslTerminated', 'autoReport', 'missingTimestamp', 'clockOutOfSync', 'dropAnalysis', 'escalatedByReputation', 'hasSample', 'storeEvent', 'storeAggregated', 'handledByAnalyst', 'slaViolation', 'payloadTruncated', 'hasStringPayload', 'reassessed', 'eventFromOtEnvironment', 'eventFromRestrictedItEnvironment']}, 'uniqueItems': True}, 'id': {'type': 'string', 'description': 'Compatibility ID of the event (<type>/<timestamp>/<customerID>/<uuid>).'}, 'location': {'type': 'object', 'description': 'Location associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the location.'}, 'name': {'type': 'string', 'description': 'Name of the location.'}, 'shortName': {'type': 'string', 'description': 'Short name of the location.'}}}, 'properties': {'type': 'array', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'items': {'type': 'object', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'properties': {'key': {'type': 'string', 'description': 'Key of the property.'}, 'type': {'type': 'string', 'description': 'Enumerated type of the property.', 'enum': ['boolean', 'long', 'string', 'double']}, 'values': {'type': 'array', 'description': 'Value(s) of the property.', 'items': {'type': 'string', 'description': 'Value(s) of the property.'}}}}, 'uniqueItems': True}, 'protocol': {'type': 'string', 'description': 'Enumerated Internet protocol of the event.', 'enum': ['tcp', 'udp', 'icmp', 'ip', 'esp', 'unknown']}, 'sensor': {'type': 'object', 'description': 'Sensor that registered the event.', 'properties': {'hostName': {'type': 'string', 'description': 'Host name of the device.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the device.'}, 'ip': {'type': 'string', 'description': 'IP address of the device.'}}}, 'severity': {'type': 'string', 'description': 'Enumerated severity of the event.', 'enum': ['low', 'medium', 'high', 'critical']}, 'signature': {'type': 'object', 'description': 'Signature associated with the event.', 'properties': {'name': {'type': 'string', 'description': 'Name/ID of the signature.'}}}, 'source': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'subEvents': {'type': 'array', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).', 'items': {'type': 'string', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).'}, 'uniqueItems': True}, 'timestamps': {'type': 'object', 'description': 'Various timestamps associated with the event', 'properties': {'created': {'type': 'integer', 'format': 'int64', 'description': 'Creation timestamp of the event.'}, 'enginePersisted': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the engine persisted the event.'}, 'firstAssessed': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the event was first assessed.'}, 'firstEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the first observed event (only for aggregated events).'}, 'firstNotified': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the case association with the event.'}, 'lastEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the last observed event (only for aggregated events).'}, 'lastUpdated': {'type': 'integer', 'format': 'int64', 'description': 'Last update timestamp of the event (only for aggregated events).'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the event.', 'enum': ['aggregated', 'raw']}, 'uri': {'type': 'string', 'description': 'URI associated with the event.'}, 'uuid': {'type': 'string', 'format': 'uuid', 'description': 'UUID of the event.'}}}}}}}, 'text/csv': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'alarm': {'type': 'object', 'description': 'Alarm associated with the event.', 'properties': {'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the alarm.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}}}, 'associatedCases': {'type': 'array', 'description': 'Cases associated with the event (only available for aggregate events).', 'items': {'type': 'object', 'description': 'Cases associated with the event (only available for aggregate events).', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64', 'description': 'Category ID of the case.'}, 'categoryName': {'type': 'string', 'description': 'Category name of the case.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the associated case.'}, 'priority': {'type': 'string', 'description': 'Priority of the case.', 'enum': ['low', 'medium', 'high', 'critical']}, 'serviceID': {'type': 'integer', 'format': 'int64', 'description': 'Service ID of the case.'}, 'serviceName': {'type': 'string', 'description': 'Service name of the case.'}, 'status': {'type': 'string', 'description': 'Status of the case.', 'enum': ['closed', 'pendingClose', 'pendingCustomer', 'pendingSoc', 'pendingVendor', 'workingCustomer', 'workingSoc']}, 'subject': {'type': 'string', 'description': 'Subject of the case.'}}}}, 'attackCategory': {'type': 'object', 'description': 'Attack category associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the attack category.'}, 'name': {'type': 'string', 'description': 'Name of the attack category.'}, 'shortName': {'type': 'string', 'description': 'Short name of the attack category.'}}}, 'comments': {'type': 'array', 'description': 'If requested, contains the comments added to the event.', 'items': {'type': 'object', 'description': 'If requested, contains the comments added to the event.', 'properties': {'comment': {'type': 'string', 'description': 'Contents of the comment.'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the comment was created.'}, 'user': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Count of aggregate events, always 1 for raw events'}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'destination': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'domain': {'type': 'string', 'description': 'Fully qualified domain name associated with the event.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the event.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the event.', 'enum': ['established', 'blocked', 'partiallyBlocked', 'snapshot', 'finalized', 'falsePositive', 'notAThreat', 'tuningCandidate', 'notified', 'notifiedUnpublished', 'notifiedDeleted', 'followup', 'partiallyNotified', 'identifiedThreat', 'threatCandidate', 'acknowledged', 'partiallyAcknowledged', 'severityAdjusted', 'commented', 'filtered', 'checked', 'incompleteDetails', 'aggregatedBaseEvent', 'remoteStorage', 'hasDetails', 'hasPayload', 'hasPcap', 'associatedToCaseByFilter', 'severityIncreasedByFilter', 'severityReducedByFilter', 'createdByAnalysisFilter', 'extendEventTtl', 'initialTuning', 'postAnalysis', 'partialSslTerminated', 'sslTerminated', 'autoReport', 'missingTimestamp', 'clockOutOfSync', 'dropAnalysis', 'escalatedByReputation', 'hasSample', 'storeEvent', 'storeAggregated', 'handledByAnalyst', 'slaViolation', 'payloadTruncated', 'hasStringPayload', 'reassessed', 'eventFromOtEnvironment', 'eventFromRestrictedItEnvironment']}, 'uniqueItems': True}, 'id': {'type': 'string', 'description': 'Compatibility ID of the event (<type>/<timestamp>/<customerID>/<uuid>).'}, 'location': {'type': 'object', 'description': 'Location associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the location.'}, 'name': {'type': 'string', 'description': 'Name of the location.'}, 'shortName': {'type': 'string', 'description': 'Short name of the location.'}}}, 'properties': {'type': 'array', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'items': {'type': 'object', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'properties': {'key': {'type': 'string', 'description': 'Key of the property.'}, 'type': {'type': 'string', 'description': 'Enumerated type of the property.', 'enum': ['boolean', 'long', 'string', 'double']}, 'values': {'type': 'array', 'description': 'Value(s) of the property.', 'items': {'type': 'string', 'description': 'Value(s) of the property.'}}}}, 'uniqueItems': True}, 'protocol': {'type': 'string', 'description': 'Enumerated Internet protocol of the event.', 'enum': ['tcp', 'udp', 'icmp', 'ip', 'esp', 'unknown']}, 'sensor': {'type': 'object', 'description': 'Sensor that registered the event.', 'properties': {'hostName': {'type': 'string', 'description': 'Host name of the device.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the device.'}, 'ip': {'type': 'string', 'description': 'IP address of the device.'}}}, 'severity': {'type': 'string', 'description': 'Enumerated severity of the event.', 'enum': ['low', 'medium', 'high', 'critical']}, 'signature': {'type': 'object', 'description': 'Signature associated with the event.', 'properties': {'name': {'type': 'string', 'description': 'Name/ID of the signature.'}}}, 'source': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'subEvents': {'type': 'array', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).', 'items': {'type': 'string', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).'}, 'uniqueItems': True}, 'timestamps': {'type': 'object', 'description': 'Various timestamps associated with the event', 'properties': {'created': {'type': 'integer', 'format': 'int64', 'description': 'Creation timestamp of the event.'}, 'enginePersisted': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the engine persisted the event.'}, 'firstAssessed': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the event was first assessed.'}, 'firstEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the first observed event (only for aggregated events).'}, 'firstNotified': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the case association with the event.'}, 'lastEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the last observed event (only for aggregated events).'}, 'lastUpdated': {'type': 'integer', 'format': 'int64', 'description': 'Last update timestamp of the event (only for aggregated events).'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the event.', 'enum': ['aggregated', 'raw']}, 'uri': {'type': 'string', 'description': 'URI associated with the event.'}, 'uuid': {'type': 'string', 'format': 'uuid', 'description': 'UUID of the event.'}}}}}}}, 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'alarm': {'type': 'object', 'description': 'Alarm associated with the event.', 'properties': {'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the alarm.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}}}, 'associatedCases': {'type': 'array', 'description': 'Cases associated with the event (only available for aggregate events).', 'items': {'type': 'object', 'description': 'Cases associated with the event (only available for aggregate events).', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64', 'description': 'Category ID of the case.'}, 'categoryName': {'type': 'string', 'description': 'Category name of the case.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the associated case.'}, 'priority': {'type': 'string', 'description': 'Priority of the case.', 'enum': ['low', 'medium', 'high', 'critical']}, 'serviceID': {'type': 'integer', 'format': 'int64', 'description': 'Service ID of the case.'}, 'serviceName': {'type': 'string', 'description': 'Service name of the case.'}, 'status': {'type': 'string', 'description': 'Status of the case.', 'enum': ['closed', 'pendingClose', 'pendingCustomer', 'pendingSoc', 'pendingVendor', 'workingCustomer', 'workingSoc']}, 'subject': {'type': 'string', 'description': 'Subject of the case.'}}}}, 'attackCategory': {'type': 'object', 'description': 'Attack category associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the attack category.'}, 'name': {'type': 'string', 'description': 'Name of the attack category.'}, 'shortName': {'type': 'string', 'description': 'Short name of the attack category.'}}}, 'comments': {'type': 'array', 'description': 'If requested, contains the comments added to the event.', 'items': {'type': 'object', 'description': 'If requested, contains the comments added to the event.', 'properties': {'comment': {'type': 'string', 'description': 'Contents of the comment.'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the comment was created.'}, 'user': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Count of aggregate events, always 1 for raw events'}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'destination': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'domain': {'type': 'string', 'description': 'Fully qualified domain name associated with the event.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the event.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the event.', 'enum': ['established', 'blocked', 'partiallyBlocked', 'snapshot', 'finalized', 'falsePositive', 'notAThreat', 'tuningCandidate', 'notified', 'notifiedUnpublished', 'notifiedDeleted', 'followup', 'partiallyNotified', 'identifiedThreat', 'threatCandidate', 'acknowledged', 'partiallyAcknowledged', 'severityAdjusted', 'commented', 'filtered', 'checked', 'incompleteDetails', 'aggregatedBaseEvent', 'remoteStorage', 'hasDetails', 'hasPayload', 'hasPcap', 'associatedToCaseByFilter', 'severityIncreasedByFilter', 'severityReducedByFilter', 'createdByAnalysisFilter', 'extendEventTtl', 'initialTuning', 'postAnalysis', 'partialSslTerminated', 'sslTerminated', 'autoReport', 'missingTimestamp', 'clockOutOfSync', 'dropAnalysis', 'escalatedByReputation', 'hasSample', 'storeEvent', 'storeAggregated', 'handledByAnalyst', 'slaViolation', 'payloadTruncated', 'hasStringPayload', 'reassessed', 'eventFromOtEnvironment', 'eventFromRestrictedItEnvironment']}, 'uniqueItems': True}, 'id': {'type': 'string', 'description': 'Compatibility ID of the event (<type>/<timestamp>/<customerID>/<uuid>).'}, 'location': {'type': 'object', 'description': 'Location associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the location.'}, 'name': {'type': 'string', 'description': 'Name of the location.'}, 'shortName': {'type': 'string', 'description': 'Short name of the location.'}}}, 'properties': {'type': 'array', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'items': {'type': 'object', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'properties': {'key': {'type': 'string', 'description': 'Key of the property.'}, 'type': {'type': 'string', 'description': 'Enumerated type of the property.', 'enum': ['boolean', 'long', 'string', 'double']}, 'values': {'type': 'array', 'description': 'Value(s) of the property.', 'items': {'type': 'string', 'description': 'Value(s) of the property.'}}}}, 'uniqueItems': True}, 'protocol': {'type': 'string', 'description': 'Enumerated Internet protocol of the event.', 'enum': ['tcp', 'udp', 'icmp', 'ip', 'esp', 'unknown']}, 'sensor': {'type': 'object', 'description': 'Sensor that registered the event.', 'properties': {'hostName': {'type': 'string', 'description': 'Host name of the device.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the device.'}, 'ip': {'type': 'string', 'description': 'IP address of the device.'}}}, 'severity': {'type': 'string', 'description': 'Enumerated severity of the event.', 'enum': ['low', 'medium', 'high', 'critical']}, 'signature': {'type': 'object', 'description': 'Signature associated with the event.', 'properties': {'name': {'type': 'string', 'description': 'Name/ID of the signature.'}}}, 'source': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'subEvents': {'type': 'array', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).', 'items': {'type': 'string', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).'}, 'uniqueItems': True}, 'timestamps': {'type': 'object', 'description': 'Various timestamps associated with the event', 'properties': {'created': {'type': 'integer', 'format': 'int64', 'description': 'Creation timestamp of the event.'}, 'enginePersisted': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the engine persisted the event.'}, 'firstAssessed': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the event was first assessed.'}, 'firstEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the first observed event (only for aggregated events).'}, 'firstNotified': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the case association with the event.'}, 'lastEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the last observed event (only for aggregated events).'}, 'lastUpdated': {'type': 'integer', 'format': 'int64', 'description': 'Last update timestamp of the event (only for aggregated events).'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the event.', 'enum': ['aggregated', 'raw']}, 'uri': {'type': 'string', 'description': 'URI associated with the event.'}, 'uuid': {'type': 'string', 'format': 'uuid', 'description': 'UUID of the event.'}}}}}}}, 'application/jsonl': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'alarm': {'type': 'object', 'description': 'Alarm associated with the event.', 'properties': {'description': {'type': 'string', 'description': 'Short description about the alarm.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the alarm.'}, 'shortName': {'type': 'string', 'description': 'Short name of the alarm.'}}}, 'associatedCases': {'type': 'array', 'description': 'Cases associated with the event (only available for aggregate events).', 'items': {'type': 'object', 'description': 'Cases associated with the event (only available for aggregate events).', 'properties': {'categoryID': {'type': 'integer', 'format': 'int64', 'description': 'Category ID of the case.'}, 'categoryName': {'type': 'string', 'description': 'Category name of the case.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the associated case.'}, 'priority': {'type': 'string', 'description': 'Priority of the case.', 'enum': ['low', 'medium', 'high', 'critical']}, 'serviceID': {'type': 'integer', 'format': 'int64', 'description': 'Service ID of the case.'}, 'serviceName': {'type': 'string', 'description': 'Service name of the case.'}, 'status': {'type': 'string', 'description': 'Status of the case.', 'enum': ['closed', 'pendingClose', 'pendingCustomer', 'pendingSoc', 'pendingVendor', 'workingCustomer', 'workingSoc']}, 'subject': {'type': 'string', 'description': 'Subject of the case.'}}}}, 'attackCategory': {'type': 'object', 'description': 'Attack category associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the attack category.'}, 'name': {'type': 'string', 'description': 'Name of the attack category.'}, 'shortName': {'type': 'string', 'description': 'Short name of the attack category.'}}}, 'comments': {'type': 'array', 'description': 'If requested, contains the comments added to the event.', 'items': {'type': 'object', 'description': 'If requested, contains the comments added to the event.', 'properties': {'comment': {'type': 'string', 'description': 'Contents of the comment.'}, 'timestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the comment was created.'}, 'user': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}}}}, 'count': {'type': 'integer', 'format': 'int32', 'description': 'Count of aggregate events, always 1 for raw events'}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'destination': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'domain': {'type': 'string', 'description': 'Fully qualified domain name associated with the event.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the event.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the event.', 'enum': ['established', 'blocked', 'partiallyBlocked', 'snapshot', 'finalized', 'falsePositive', 'notAThreat', 'tuningCandidate', 'notified', 'notifiedUnpublished', 'notifiedDeleted', 'followup', 'partiallyNotified', 'identifiedThreat', 'threatCandidate', 'acknowledged', 'partiallyAcknowledged', 'severityAdjusted', 'commented', 'filtered', 'checked', 'incompleteDetails', 'aggregatedBaseEvent', 'remoteStorage', 'hasDetails', 'hasPayload', 'hasPcap', 'associatedToCaseByFilter', 'severityIncreasedByFilter', 'severityReducedByFilter', 'createdByAnalysisFilter', 'extendEventTtl', 'initialTuning', 'postAnalysis', 'partialSslTerminated', 'sslTerminated', 'autoReport', 'missingTimestamp', 'clockOutOfSync', 'dropAnalysis', 'escalatedByReputation', 'hasSample', 'storeEvent', 'storeAggregated', 'handledByAnalyst', 'slaViolation', 'payloadTruncated', 'hasStringPayload', 'reassessed', 'eventFromOtEnvironment', 'eventFromRestrictedItEnvironment']}, 'uniqueItems': True}, 'id': {'type': 'string', 'description': 'Compatibility ID of the event (<type>/<timestamp>/<customerID>/<uuid>).'}, 'location': {'type': 'object', 'description': 'Location associated with the event.', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the location.'}, 'name': {'type': 'string', 'description': 'Name of the location.'}, 'shortName': {'type': 'string', 'description': 'Short name of the location.'}}}, 'properties': {'type': 'array', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'items': {'type': 'object', 'description': 'If requested, contains a a filtered or full set of properties of the event.', 'properties': {'key': {'type': 'string', 'description': 'Key of the property.'}, 'type': {'type': 'string', 'description': 'Enumerated type of the property.', 'enum': ['boolean', 'long', 'string', 'double']}, 'values': {'type': 'array', 'description': 'Value(s) of the property.', 'items': {'type': 'string', 'description': 'Value(s) of the property.'}}}}, 'uniqueItems': True}, 'protocol': {'type': 'string', 'description': 'Enumerated Internet protocol of the event.', 'enum': ['tcp', 'udp', 'icmp', 'ip', 'esp', 'unknown']}, 'sensor': {'type': 'object', 'description': 'Sensor that registered the event.', 'properties': {'hostName': {'type': 'string', 'description': 'Host name of the device.'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the device.'}, 'ip': {'type': 'string', 'description': 'IP address of the device.'}}}, 'severity': {'type': 'string', 'description': 'Enumerated severity of the event.', 'enum': ['low', 'medium', 'high', 'critical']}, 'signature': {'type': 'object', 'description': 'Signature associated with the event.', 'properties': {'name': {'type': 'string', 'description': 'Name/ID of the signature.'}}}, 'source': {'type': 'object', 'description': 'Destination endpoint of the event.', 'properties': {'address': {'type': 'string', 'description': 'IP address of the endpoint.'}, 'flags': {'type': 'array', 'description': 'Enumerated flags describing the features of the endpoint.', 'items': {'type': 'string', 'description': 'Enumerated flags describing the features of the endpoint.', 'enum': ['isCustomerNet', 'isPartialCustomerNet', 'customAggregation', 'isManagedBySoc']}, 'uniqueItems': True}, 'geoInfo': {'type': 'object', 'description': 'Geo-location info of this endpoint.', 'properties': {'countryCode': {'type': 'string', 'description': 'Two-letter code of the country where this location is in.'}, 'countryName': {'type': 'string', 'description': 'Name of the country where this location is in.'}, 'latitude': {'type': 'number', 'format': 'double', 'description': 'Geographic latitude of the location.'}, 'locationName': {'type': 'string', 'description': 'Name of the location.'}, 'longitude': {'type': 'number', 'format': 'double', 'description': 'Geographic longitude of the location.'}}}, 'host': {'type': 'string', 'description': 'Host name of the endpoint.'}, 'port': {'type': 'integer', 'format': 'int32', 'description': 'UDP or TCP port of the endpoint (0 - 65535).'}, 'user': {'type': 'string', 'description': 'User associated with this endpoint.'}}}, 'subEvents': {'type': 'array', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).', 'items': {'type': 'string', 'description': 'If requested, contains the IDs of the events that the aggregated event consists of (null for raw events).'}, 'uniqueItems': True}, 'timestamps': {'type': 'object', 'description': 'Various timestamps associated with the event', 'properties': {'created': {'type': 'integer', 'format': 'int64', 'description': 'Creation timestamp of the event.'}, 'enginePersisted': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the engine persisted the event.'}, 'firstAssessed': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the event was first assessed.'}, 'firstEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the first observed event (only for aggregated events).'}, 'firstNotified': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the case association with the event.'}, 'lastEvent': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp of the last observed event (only for aggregated events).'}, 'lastUpdated': {'type': 'integer', 'format': 'int64', 'description': 'Last update timestamp of the event (only for aggregated events).'}}}, 'type': {'type': 'string', 'description': 'Enumerated type of the event.', 'enum': ['aggregated', 'raw']}, 'uri': {'type': 'string', 'description': 'URI associated with the event.'}, 'uuid': {'type': 'string', 'format': 'uuid', 'description': 'UUID of the event.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}, 'text/csv': {}, 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': {}, 'application/jsonl': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}, 'text/csv': {}, 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': {}, 'application/jsonl': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}, 'text/csv': {}, 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': {}, 'application/jsonl': {}}}}, 'x-Argus-Required-Permissions': ['eventLookup'], 'x-Argus-ApiStatus': 'DEV'}