"""Autogenerated API schema"""
from argus_api import session


add_country = {'tags': ['/geoip/v1'], 'summary': 'Add new country (DEV)', 'description': '', 'operationId': 'addCountry', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'countryCode': {'type': 'str', 'description': 'The two-letter country-code', 'maxLength': 2, 'minLength': 2}, 'countryName': {'type': 'str', 'description': 'The name of the country', 'maxLength': 100, 'minLength': 0}}, 'required': ['countryCode', 'countryName']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Add new country', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Contains basic data about a country.', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'countryName': {'type': 'string', 'description': 'The name of the country.'}, 'countryCode': {'type': 'string', 'description': 'The two-letter country-code.'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when this country was last updated.'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'deleted']}, 'uniqueItems': True}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addGeoIPData'], 'x-Argus-ApiStatus': 'DEV'}
list_countries = {'tags': ['/geoip/v1'], 'summary': 'List GeoIP countries (INTERNAL)', 'description': '', 'operationId': 'listCountries', 'parameters': [{'name': 'limit', 'in': 'query', 'description': 'Max number of items to return', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'The amount of items to skip from the beginning', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'sortBy', 'in': 'query', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending, supported fields are: id, countryName, countryCode)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'fromID', 'in': 'query', 'description': 'Only return countries with numeric ID greater than or equal to this value', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}], 'responses': {'default': {'description': 'List GeoIP countries', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Contains basic data about a country.', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'countryName': {'type': 'string', 'description': 'The name of the country.'}, 'countryCode': {'type': 'string', 'description': 'The two-letter country-code.'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when this country was last updated.'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'deleted']}, 'uniqueItems': True}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewGeoIPData'], 'x-Argus-ApiStatus': 'INTERNAL'}
search_countries = {'tags': ['/geoip/v1'], 'summary': 'Find GeoIP countries (INTERNAL)', 'description': '', 'operationId': 'searchCountries', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to search for countries', 'properties': {'fromID': {'type': 'int', 'description': 'Only return countries with IDs greater than or equal to this ID.', 'minimum': 0}, 'includeFlags': {'type': 'list', 'description': 'A set of included enumerated flags of the searched countries.', 'items': {'type': 'str', 'description': 'A set of included enumerated flags of the searched countries.', 'enum': ['deleted']}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'A set of excluded enumerated flags of the searched countries.', 'items': {'type': 'str', 'description': 'A set of excluded enumerated flags of the searched countries.', 'enum': ['deleted']}, 'uniqueItems': True}, 'includeDeleted': {'type': 'bool', 'description': 'If true, also include countries marked as deleted.'}, 'limit': {'type': 'int', 'description': 'Max number of results.', 'minimum': 0}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.', 'minimum': 0}, 'sortBy': {'type': 'list', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending).", 'items': {'type': 'str', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending).", 'enum': ['id', 'countryName', 'countryCode', '-id', '-countryName', '-countryCode']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Find GeoIP countries', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Contains basic data about a country.', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'countryName': {'type': 'string', 'description': 'The name of the country.'}, 'countryCode': {'type': 'string', 'description': 'The two-letter country-code.'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when this country was last updated.'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'deleted']}, 'uniqueItems': True}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewGeoIPData'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_country = {'tags': ['/geoip/v1'], 'summary': 'Update an existing country (DEV)', 'description': '', 'operationId': 'updateCountry', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Country ID', 'required': True, 'schema': {'type': 'int'}, 'type': 'int'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'countryName': {'type': 'str', 'description': 'The name of the country', 'maxLength': 100, 'minLength': 0}}, 'required': ['countryName']}}}, 'required': True}, 'responses': {'default': {'description': 'Update an existing country', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Contains basic data about a country.', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'countryName': {'type': 'string', 'description': 'The name of the country.'}, 'countryCode': {'type': 'string', 'description': 'The two-letter country-code.'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when this country was last updated.'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['DELETED', 'deleted']}, 'uniqueItems': True}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateGeoIPData'], 'x-Argus-ApiStatus': 'DEV'}