"""Autogenerated API schema"""
from argus_api import session


add_region = {'tags': ['/geoip/v1'], 'summary': 'Add new region (DEV)', 'description': '', 'operationId': 'addRegion', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Region is a subunit of a country. It contains data about the region and also the country it belongs to.', 'properties': {'id': {'type': 'int'}, 'countryCode': {'type': 'str', 'description': 'The two-letter code of the country where this region is in.'}, 'regionCode': {'type': 'str', 'description': 'The code of the region.'}, 'regionName': {'type': 'str', 'description': 'The name of the region.'}, 'lastUpdatedTimestamp': {'type': 'int', 'description': 'The timestamp when this region was last updated.'}, 'flags': {'type': 'list', 'description': 'Flags assigned to the object.', 'items': {'type': 'str', 'description': 'Flags assigned to the object.', 'enum': ['deleted']}, 'uniqueItems': True}, 'minLocationID': {'type': 'int'}, 'maxLocationID': {'type': 'int'}, 'flag': {'type': 'int', 'writeOnly': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Add new region', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Region is a subunit of a country. It contains data about the region and also the country it belongs to.', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'countryCode': {'type': 'string', 'description': 'The two-letter code of the country where this region is in.'}, 'regionCode': {'type': 'string', 'description': 'The code of the region.'}, 'regionName': {'type': 'string', 'description': 'The name of the region.'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp when this region was last updated.'}, 'flags': {'type': 'array', 'description': 'Flags assigned to the object.', 'items': {'type': 'string', 'description': 'Flags assigned to the object.', 'enum': ['deleted']}, 'uniqueItems': True}, 'minLocationID': {'type': 'integer', 'format': 'int64'}, 'maxLocationID': {'type': 'integer', 'format': 'int64'}, 'flag': {'type': 'integer', 'format': 'int64', 'writeOnly': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addGeoIPData', 'updateGeoIPData'], 'x-Argus-ApiStatus': 'DEV'}