"""Autogenerated API schema"""
from argus_api import session


add_json_object_favorite = {'tags': ['jsonobject/v1/object'], 'summary': "Creates a new JsonObjectFavorite to current user's JsonObject (PUBLIC)", 'description': '', 'operationId': 'addJsonObjectFavorite', 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to favorite.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': "Creates a new JsonObjectFavorite to current user's JsonObject", 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
bulk_grant_json_object_access = {'tags': ['jsonobject/v1/object'], 'summary': 'Bulk adds access entries to the identified JsonObject. (PUBLIC)', 'description': '', 'operationId': 'bulkGrantJsonObjectAccess', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to add the access entries to.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request for adding a bulk of access entries to a JsonObject', 'properties': {'accessEntries': {'type': 'list', 'items': {'type': 'dict', 'description': 'Base request to add access entries to a JsonObject', 'properties': {'customer': {'type': 'str', 'description': 'ID or shortname of customer for granting role-based access. Null if global permission.'}, 'function': {'type': 'str', 'description': 'ID or name of function for granting role-based access.'}, 'level': {'type': 'str', 'description': 'The access level this entry grants.', 'enum': ['read', 'write', 'owner']}, 'searchable': {'type': 'bool', 'default': True, 'description': 'If true, the object will be searchable.'}, 'subject': {'type': 'str', 'description': 'ID or shortname for user or group to grant explicit access to.'}}, 'required': ['level']}, 'maxItems': 2147483647, 'minItems': 1}}, 'required': ['accessEntries']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Bulk adds access entries to the identified JsonObject.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An access entry giving access to a JsonObject for a specific user, groups or functions', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags that are set on this access entry.', 'items': {'type': 'string', 'description': 'Flags that are set on this access entry.', 'enum': ['deleted', 'searchable']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was granted.'}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the access entry.'}, 'level': {'type': 'string', 'description': 'The access level this entry grants.', 'enum': ['read', 'write', 'owner']}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was revoked.'}, 'subject': {'oneOf': [{'allOf': [{'type': 'object', 'description': 'SPI SubjectInfo', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}], 'description': 'SPI GroupInfo', 'required': ['type']}, {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}, 'type': {'type': 'string', 'description': 'The access type this entry grants.', 'enum': ['explicit', 'roleBased']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
create_json_object = {'tags': ['jsonobject/v1/object'], 'summary': 'Creates a new JsonObject of a specified type. (PUBLIC)', 'description': '', 'operationId': 'createJsonObject', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to create a JsonObject', 'properties': {'data': {'type': 'object'}, 'description': {'type': 'str', 'description': 'Description of this object'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Description in specified languages. Required for global objects.'}, 'description': 'Description in specified languages. Required for global objects.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Display name in specified languages. Required for global objects.'}, 'description': 'Display name in specified languages. Required for global objects.'}, 'name': {'type': 'str', 'description': 'Name of this object'}, 'shortName': {'type': 'str', 'description': 'If set, this needs to be unique per type. If not, this will default to the generated UUID of the object.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'tags': {'type': 'list', 'description': 'Tags to set on this object.', 'items': {'type': 'dict', 'properties': {'key': {'type': 'str', 'description': 'Key for this tag. Must be alphanumeric (no spaces), and at most 256 characters', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'value': {'type': 'str', 'description': 'Value for this tag. Must be a string below 1024 characters', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}}, 'required': ['key', 'value']}, 'uniqueItems': True}}, 'required': ['name']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Creates a new JsonObject of a specified type.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addJsonObject'], 'x-Argus-ApiStatus': 'PUBLIC'}
delete_json_object = {'tags': ['jsonobject/v1/object'], 'summary': 'Deletes a JsonObject identified by either id or type+shortname (PUBLIC)', 'description': '', 'operationId': 'deleteJsonObject', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to delete.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Deletes a JsonObject identified by either id or type+shortname', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_json_object = {'tags': ['jsonobject/v1/object'], 'summary': 'Returns a JsonObject identified by either id or type+shortname. (PUBLIC)', 'description': '', 'operationId': 'getJsonObject', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to retrieve.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeData', 'in': 'query', 'description': 'Whether or not to include the actual JsonObject data in the response.', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}], 'responses': {'default': {'description': 'Returns a JsonObject identified by either id or type+shortname.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_json_objects = {'tags': ['jsonobject/v1/object'], 'summary': 'Search json objects with specified query parameters (PUBLIC)', 'description': '', 'operationId': 'getJsonObjects', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'keywords', 'in': 'query', 'description': 'Filter search by JsonObject keyword fields (name and short name)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'favorite', 'in': 'query', 'description': 'Limit search to favorites', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'includeData', 'in': 'query', 'description': 'Whether or not to include the actual JsonObject data in the response.', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Whether or not to include deleted JsonObjects in the response.', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}, {'name': 'limit', 'in': 'query', 'description': 'Limit result', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'Offset result', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}], 'responses': {'default': {'description': 'Search json objects with specified query parameters', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
grant_json_object_access = {'tags': ['jsonobject/v1/object'], 'summary': 'Adds an access entry to the identified JsonObject. (PUBLIC)', 'description': '', 'operationId': 'grantJsonObjectAccess', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to add the access entry to.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to add an access entry to a JsonObject', 'properties': {'customer': {'type': 'str', 'description': 'ID or shortname of customer for granting role-based access. Null if global permission.'}, 'function': {'type': 'str', 'description': 'ID or name of function for granting role-based access.'}, 'level': {'type': 'str', 'description': 'The access level this entry grants.', 'enum': ['read', 'write', 'owner']}, 'searchable': {'type': 'bool', 'default': True, 'description': 'If true, the object will be searchable.'}, 'subject': {'type': 'str', 'description': 'ID or shortname for user or group to grant explicit access to.'}}, 'required': ['level']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Adds an access entry to the identified JsonObject.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'An access entry giving access to a JsonObject for a specific user, groups or functions', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags that are set on this access entry.', 'items': {'type': 'string', 'description': 'Flags that are set on this access entry.', 'enum': ['deleted', 'searchable']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was granted.'}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the access entry.'}, 'level': {'type': 'string', 'description': 'The access level this entry grants.', 'enum': ['read', 'write', 'owner']}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was revoked.'}, 'subject': {'oneOf': [{'allOf': [{'type': 'object', 'description': 'SPI SubjectInfo', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}], 'description': 'SPI GroupInfo', 'required': ['type']}, {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}, 'type': {'type': 'string', 'description': 'The access type this entry grants.', 'enum': ['explicit', 'roleBased']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_json_object_access = {'tags': ['jsonobject/v1/object'], 'summary': 'Returns a list of access entries for a JsonObject identified by either id or type+shortname (PUBLIC)', 'description': '', 'operationId': 'listJsonObjectAccess', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to list access entries for.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Whether or not to include deleted access entries in the response.', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'By how many records to offset results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}], 'responses': {'default': {'description': 'Returns a list of access entries for a JsonObject identified by either id or type+shortname', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An access entry giving access to a JsonObject for a specific user, groups or functions', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags that are set on this access entry.', 'items': {'type': 'string', 'description': 'Flags that are set on this access entry.', 'enum': ['deleted', 'searchable']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was granted.'}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the access entry.'}, 'level': {'type': 'string', 'description': 'The access level this entry grants.', 'enum': ['read', 'write', 'owner']}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was revoked.'}, 'subject': {'oneOf': [{'allOf': [{'type': 'object', 'description': 'SPI SubjectInfo', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}], 'description': 'SPI GroupInfo', 'required': ['type']}, {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}, 'type': {'type': 'string', 'description': 'The access type this entry grants.', 'enum': ['explicit', 'roleBased']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_json_object_revisions = {'tags': ['jsonobject/v1/object'], 'summary': 'Returns the revisions of a JsonObject identified by either id or type+shortname (PUBLIC)', 'description': '', 'operationId': 'listJsonObjectRevisions', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to retrieve revisions for.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'includeData', 'in': 'query', 'description': 'Whether or not to include the actual JsonObject data in the revision responses.', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'By how many records to offset results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}], 'responses': {'default': {'description': 'Returns the revisions of a JsonObject identified by either id or type+shortname', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
remove_json_object_favorite = {'tags': ['jsonobject/v1/object'], 'summary': "Deletes JsonObjectFavorite to current user's JsonObject (PUBLIC)", 'description': '', 'operationId': 'removeJsonObjectFavorite', 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject the favorite should be removed from.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': "Deletes JsonObjectFavorite to current user's JsonObject", 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
revert_json_object = {'tags': ['jsonobject/v1/object'], 'summary': 'Reverts a JsonObject identified by either id or type+shortname to a previous revision (PUBLIC)', 'description': '', 'operationId': 'revertJsonObject', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the current JsonObject.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'revision', 'in': 'path', 'description': 'The revision to revert to.', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Reverts a JsonObject identified by either id or type+shortname to a previous revision', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
revoke_json_object_access = {'tags': ['jsonobject/v1/object'], 'summary': 'Revokes access entity to the identified JsonObject (PUBLIC)', 'description': '', 'operationId': 'revokeJsonObjectAccess', 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject the access entity should be removed from.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'id', 'in': 'path', 'description': 'ID of the access entity to revoke', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}], 'responses': {'default': {'description': 'Revokes access entity to the identified JsonObject', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'An access entry giving access to a JsonObject for a specific user, groups or functions', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags that are set on this access entry.', 'items': {'type': 'string', 'description': 'Flags that are set on this access entry.', 'enum': ['deleted', 'searchable']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was granted.'}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the access entry.'}, 'level': {'type': 'string', 'description': 'The access level this entry grants.', 'enum': ['read', 'write', 'owner']}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this permission was revoked.'}, 'subject': {'oneOf': [{'allOf': [{'type': 'object', 'description': 'SPI SubjectInfo', 'discriminator': {'propertyName': 'type'}, 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}], 'description': 'SPI GroupInfo', 'required': ['type']}, {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}, 'type': {'type': 'string', 'description': 'The access type this entry grants.', 'enum': ['explicit', 'roleBased']}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
search_json_objects = {'tags': ['jsonobject/v1/object'], 'summary': 'Search json objects with specified criteria (PUBLIC)', 'description': '', 'operationId': 'searchJsonObjects', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to search for json objects', 'properties': {'customer': {'type': 'list', 'description': 'Limit search to json objects with the given customers, identified by id or shortname', 'items': {'type': 'str', 'description': 'Limit search to json objects with the given customers, identified by id or shortname'}, 'uniqueItems': True}, 'endTimestamp': {'type': 'int', 'default': 0, 'description': 'Restrict to a time frame based on the set timeFieldStrategy (end timestamp)', 'minimum': 0}, 'excludeFlags': {'type': 'list', 'description': 'Filter out objects with any of these flags set', 'items': {'type': 'str', 'description': 'Filter out objects with any of these flags set', 'enum': ['deleted', 'controlledVersion', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'favorite': {'type': 'bool', 'default': False, 'description': 'Whether to only search for favorites, exclude favorites or neither'}, 'includeData': {'type': 'bool', 'default': False, 'description': 'Whether to include data in the response.'}, 'includeDeleted': {'type': 'bool', 'default': False, 'description': 'Whether to include deleted json objects in the search. Only allowed for users with ´jsonObjectAdministration` permission'}, 'includeFlags': {'type': 'list', 'description': 'Filter by objects with all these flags set', 'items': {'type': 'str', 'description': 'Filter by objects with all these flags set', 'enum': ['deleted', 'controlledVersion', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'includeTags': {'type': 'bool', 'default': False, 'description': 'Whether to include tags in the response.'}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'Defines which fields will be searched by keywords', 'items': {'type': 'str', 'default': 'all', 'description': 'Defines which fields will be searched by keywords', 'enum': ['name', 'shortName', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'Defines how strict different keywords should be matched', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Search for keywords against fields defined by KeywordFieldStrategy', 'items': {'type': 'str', 'description': 'Search for keywords against fields defined by KeywordFieldStrategy'}, 'uniqueItems': True}, 'limit': {'type': 'int', 'default': 25, 'description': 'Limit maximum amount of results', 'minimum': 0}, 'offset': {'type': 'int', 'default': 0, 'description': 'Skip specified amount of results', 'minimum': 0}, 'sortBy': {'type': 'list', 'default': 'createdTimestamp', 'description': 'Which fields to sort json objects by', 'items': {'type': 'str', 'default': 'createdTimestamp', 'description': 'Which fields to sort json objects by', 'enum': ['createdTimestamp', 'name', 'shortName', 'lastUpdatedTimestamp', '-createdTimestamp', '-name', '-shortName', '-lastUpdatedTimestamp']}}, 'startTimestamp': {'type': 'int', 'default': 0, 'description': 'Restrict to a time frame based on the set timeFieldStrategy (start timestamp)', 'minimum': 0}, 'subCriteria': {'type': 'list', 'description': 'Set additional criteria', 'items': {'type': 'dict', 'description': 'Request defining if sub-criteria should be included or excluded', 'properties': {'customer': {'type': 'list', 'description': 'Limit search to json objects with the given customers, identified by id or shortname', 'items': {'type': 'str', 'description': 'Limit search to json objects with the given customers, identified by id or shortname'}, 'uniqueItems': True}, 'endTimestamp': {'type': 'int', 'default': 0, 'description': 'Restrict to a time frame based on the set timeFieldStrategy (end timestamp)', 'minimum': 0}, 'exclude': {'type': 'bool', 'default': False, 'description': 'Exclude objects matching subcriteria? If true the search is NOT-ed'}, 'excludeFlags': {'type': 'list', 'description': 'Filter out objects with any of these flags set', 'items': {'type': 'str', 'description': 'Filter out objects with any of these flags set', 'enum': ['deleted', 'controlledVersion', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'favorite': {'type': 'bool', 'default': False, 'description': 'Whether to only search for favorites, exclude favorites or neither'}, 'includeFlags': {'type': 'list', 'description': 'Filter by objects with all these flags set', 'items': {'type': 'str', 'description': 'Filter by objects with all these flags set', 'enum': ['deleted', 'controlledVersion', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'Defines which fields will be searched by keywords', 'items': {'type': 'str', 'default': 'all', 'description': 'Defines which fields will be searched by keywords', 'enum': ['name', 'shortName', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'all', 'description': 'Defines how strict different keywords should be matched', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Search for keywords against fields defined by KeywordFieldStrategy', 'items': {'type': 'str', 'description': 'Search for keywords against fields defined by KeywordFieldStrategy'}, 'uniqueItems': True}, 'required': {'type': 'bool', 'default': False, 'description': 'Is this subcriteria required? If true the search is AND-ed'}, 'startTimestamp': {'type': 'int', 'default': 0, 'description': 'Restrict to a time frame based on the set timeFieldStrategy (start timestamp)', 'minimum': 0}, 'tags': {'type': 'list', 'description': 'Search for objects matching these tags', 'items': {'type': 'dict', 'properties': {'exclude': {'type': 'bool', 'description': 'If true, exclude any objects matching this tag criteria'}, 'key': {'type': 'str', 'description': 'Key for tag to search for.'}, 'values': {'type': 'list', 'description': 'Values for tag to search for. Will match objects where tag matches key and any of these values. If no values are specified, will match all objects with a tag with this key.', 'items': {'type': 'str', 'description': 'Values for tag to search for. Will match objects where tag matches key and any of these values. If no values are specified, will match all objects with a tag with this key.'}, 'uniqueItems': True}}, 'required': ['key']}, 'uniqueItems': True}, 'timeFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'Defines which timestamp fields will be filtered with start/endTimestamp', 'items': {'type': 'str', 'default': 'all', 'description': 'Defines which timestamp fields will be filtered with start/endTimestamp', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp', 'enum': ['any', 'all']}, 'user': {'type': 'list', 'description': 'Search using users identified by id or shortname. If given a group, we will resolve all members of the group recursively', 'items': {'type': 'str', 'description': 'Search using users identified by id or shortname. If given a group, we will resolve all members of the group recursively'}, 'uniqueItems': True}, 'userFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'Defines which fields will be searched by user', 'items': {'type': 'str', 'default': 'all', 'description': 'Defines which fields will be searched by user', 'enum': ['owner', 'read', 'write', 'createdByUser', 'lastUpdatedByUser', 'all']}, 'uniqueItems': True}}}, 'uniqueItems': True}, 'tags': {'type': 'list', 'description': 'Search for objects matching these tags', 'items': {'type': 'dict', 'properties': {'exclude': {'type': 'bool', 'description': 'If true, exclude any objects matching this tag criteria'}, 'key': {'type': 'str', 'description': 'Key for tag to search for.'}, 'values': {'type': 'list', 'description': 'Values for tag to search for. Will match objects where tag matches key and any of these values. If no values are specified, will match all objects with a tag with this key.', 'items': {'type': 'str', 'description': 'Values for tag to search for. Will match objects where tag matches key and any of these values. If no values are specified, will match all objects with a tag with this key.'}, 'uniqueItems': True}}, 'required': ['key']}, 'uniqueItems': True}, 'timeFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'Defines which timestamp fields will be filtered with start/endTimestamp', 'items': {'type': 'str', 'default': 'all', 'description': 'Defines which timestamp fields will be filtered with start/endTimestamp', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'default': 'any', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp', 'enum': ['any', 'all']}, 'user': {'type': 'list', 'description': 'Search using users identified by id or shortname. If given a group, we will resolve all members of the group recursively', 'items': {'type': 'str', 'description': 'Search using users identified by id or shortname. If given a group, we will resolve all members of the group recursively'}, 'uniqueItems': True}, 'userFieldStrategy': {'type': 'list', 'default': 'all', 'description': 'Defines which fields will be searched by user', 'items': {'type': 'str', 'default': 'all', 'description': 'Defines which fields will be searched by user', 'enum': ['owner', 'read', 'write', 'createdByUser', 'lastUpdatedByUser', 'all']}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search json objects with specified criteria', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}
update_json_object = {'tags': ['jsonobject/v1/object'], 'summary': 'Updates a JsonObject identified by either id or type+shortname (PUBLIC)', 'description': '', 'operationId': 'updateJsonObject', 'parameters': [{'name': 'type', 'in': 'path', 'description': 'The shortName of the JsonObject type.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'idOrShortname', 'in': 'path', 'description': 'Id or shortName of the JsonObject to update.', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to update a JsonObject', 'properties': {'addTags': {'type': 'list', 'description': 'If set, add these tags to the object.', 'items': {'type': 'dict', 'properties': {'key': {'type': 'str', 'description': 'Key for this tag. Must be alphanumeric (no spaces), and at most 256 characters', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'value': {'type': 'str', 'description': 'Value for this tag. Must be a string below 1024 characters', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}}, 'required': ['key', 'value']}, 'uniqueItems': True}, 'data': {'type': 'object'}, 'description': {'type': 'str', 'description': 'Description of this object'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Description in specified languages. Required for global objects.'}, 'description': 'Description in specified languages. Required for global objects.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Display name in specified languages. Required for global objects.'}, 'description': 'Display name in specified languages. Required for global objects.'}, 'name': {'type': 'str', 'description': 'Name of this object'}, 'removeTags': {'type': 'list', 'description': 'If set, remove these tags from the object, by tag ID or key. If key is specified, this will match all tags with this key.', 'items': {'type': 'str', 'description': 'If set, remove these tags from the object, by tag ID or key. If key is specified, this will match all tags with this key.'}, 'uniqueItems': True}, 'shortName': {'type': 'str', 'description': 'If set, this needs to be unique per type.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'skipRevision': {'type': 'bool', 'description': 'If true, do not create a new revision for this update.'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Updates a JsonObject identified by either id or type+shortname', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'JsonObject response. Provides the JsonObject itself along with meta information', 'properties': {'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was created.'}, 'currentUserAccess': {'type': 'string', 'description': 'Which access the current user has for the current JsonObject', 'enum': ['read', 'write', 'owner']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'data': {'type': 'object'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was deleted (if deleted).'}, 'description': {'type': 'string', 'description': 'The description of the JsonObject.'}, 'flags': {'type': 'array', 'description': 'Flags that are set on this JsonObject.', 'items': {'type': 'string', 'description': 'Flags that are set on this JsonObject.', 'enum': ['deleted', 'controlledVersion', 'favorite', 'sharedWithRole', 'sharedWithUserOrGroup', 'sharedGlobal']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the object.'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When this JsonObject was last updated.'}, 'localizedDescription': {'type': 'string', 'description': 'The localized description for the current users language.'}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized descriptions.'}, 'description': 'All available localized descriptions.'}, 'localizedName': {'type': 'string', 'description': 'The localized name for the current users language.'}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available localized names.'}, 'description': 'All available localized names.'}, 'masterID': {'type': 'string', 'format': 'uuid', 'description': 'The UUID of the master JsonObject if this is a revision. Null if not.'}, 'name': {'type': 'string', 'description': 'The name of the JsonObject.'}, 'revision': {'type': 'integer', 'format': 'int32', 'description': 'The change revision of the JsonObject.'}, 'shortName': {'type': 'string', 'description': 'The shortName of the JsonObject.'}, 'tags': {'type': 'array', 'description': 'Tags set on this object', 'items': {'type': 'object', 'description': 'A tag on a JSON object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'An automatically created UUID to identify the tag.'}, 'key': {'type': 'string', 'description': 'The tag key.'}, 'value': {'type': 'string', 'description': 'The tag value.'}}}, 'uniqueItems': True}, 'type': {'type': 'object', 'description': 'Describing a JsonObject type.', 'properties': {'shortName': {'type': 'string', 'description': 'A shortname representing one out of several defined JsonObject types.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewJsonObjects'], 'x-Argus-ApiStatus': 'PUBLIC'}