"""Autogenerated API schema"""
from argus_api import session


submit_csp_log_event = {'tags': ['logging/v1'], 'summary': 'Submit CSP log event (INTERNAL)', 'description': '', 'operationId': 'submitCSPLogEvent', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'blockedUri': {'type': 'str', 'description': 'The URI of the resource that was blocked from loading by the Content Security Policy.'}, 'csp-report': {'type': 'dict', 'additionalProperties': {'type': 'string'}, 'writeOnly': True}, 'disposition': {'type': 'str', 'description': "Either 'enforce' or 'report'."}, 'documentUri': {'type': 'str', 'description': 'The URI of the document in which the violation occurred.'}, 'effectiveDirective': {'type': 'str', 'description': 'The directive whose enforcement caused the violation.'}, 'originalPolicy': {'type': 'str', 'description': 'The original policy as specified by the Content-Security-Policy-Report-Only HTTP header.'}, 'referrer': {'type': 'str', 'description': 'The referrer of the document in which the violation occurred.'}, 'scriptSample': {'type': 'str', 'description': 'The first 40 characters of the inline script, event handler, or style that caused the violation.'}, 'statusCode': {'type': 'int', 'description': 'The HTTP status code of the resource on which the global object was instantiated.'}, 'violatedDirective': {'type': 'str', 'description': 'The name of the policy section that was violated.'}}, 'required': ['blockedUri', 'disposition', 'documentUri', 'originalPolicy', 'violatedDirective']}}, 'application/csp-report': {'schema': {'type': 'object', 'properties': {'blockedUri': {'type': 'string', 'description': 'The URI of the resource that was blocked from loading by the Content Security Policy.'}, 'csp-report': {'type': 'object', 'additionalProperties': {'type': 'string'}, 'writeOnly': True}, 'disposition': {'type': 'string', 'description': "Either 'enforce' or 'report'."}, 'documentUri': {'type': 'string', 'description': 'The URI of the document in which the violation occurred.'}, 'effectiveDirective': {'type': 'string', 'description': 'The directive whose enforcement caused the violation.'}, 'originalPolicy': {'type': 'string', 'description': 'The original policy as specified by the Content-Security-Policy-Report-Only HTTP header.'}, 'referrer': {'type': 'string', 'description': 'The referrer of the document in which the violation occurred.'}, 'scriptSample': {'type': 'string', 'description': 'The first 40 characters of the inline script, event handler, or style that caused the violation.'}, 'statusCode': {'type': 'integer', 'format': 'int32', 'description': 'The HTTP status code of the resource on which the global object was instantiated.'}, 'violatedDirective': {'type': 'string', 'description': 'The name of the policy section that was violated.'}}, 'required': ['blockedUri', 'disposition', 'documentUri', 'originalPolicy', 'violatedDirective']}}}, 'required': True}, 'responses': {'default': {'description': 'Submit CSP log event', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object'}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['submitClientLog'], 'x-Argus-ApiStatus': 'INTERNAL'}