"""Autogenerated API schema"""
from argus_api import session


submit_tooling_log_events_bulk = {'tags': ['logging/v1'], 'summary': 'Submit tool log events in a bulk operation (INTERNAL)', 'description': '', 'operationId': 'submitToolingLogEventsBulk', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'ignoreOnFailed': {'type': 'bool', 'default': False, 'description': 'Set this value for successful response even with failures occur while submitting.'}, 'logEntries': {'type': 'list', 'description': 'Log entries for submission.', 'items': {'type': 'dict', 'description': 'A log entry from tooling', 'properties': {'arguments': {'type': 'str', 'description': 'Arguments used, do not include API keys.'}, 'context': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Additional information that could be relevant in the context. Max length of context values is 4000 characters.'}, 'description': 'Additional information that could be relevant in the context. Max length of context values is 4000 characters.'}, 'currentUser': {'type': 'str', 'description': 'User ID or shortname, used by the script.'}, 'executableName': {'type': 'str', 'description': 'Executable that initiated the script.'}, 'hostname': {'type': 'str', 'description': 'Host running script.'}, 'level': {'type': 'str', 'description': 'Event level: debug, info, warning or error. Defaults to info', 'enum': ['none', 'error', 'warning', 'info', 'debug']}, 'message': {'type': 'str', 'description': 'Event message. Max string length is 4000 characters.'}, 'operatingSystem': {'type': 'str', 'description': 'Operating system running the script.'}, 'platformVersion': {'type': 'str', 'description': 'Platform/Python version.'}, 'reference': {'type': 'str', 'description': 'Reference, such as cronmeta-tag.'}, 'stacktrace': {'type': 'str', 'description': 'Complete stacktrace for event. Max string length is 10000 characters.'}, 'timestamp': {'type': 'int', 'description': 'Timestamp for event. Accepts ISO-8601 timestamp string.', 'minimum': 1}}, 'required': ['currentUser', 'executableName', 'hostname', 'operatingSystem', 'platformVersion']}, 'maxItems': 2147483647, 'minItems': 1}}, 'required': ['logEntries']}}}, 'required': True}, 'responses': {'default': {'description': 'Submit tool log events in a bulk operation', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'properties': {'accepted': {'type': 'integer', 'format': 'int32', 'description': 'Number of successfully submitted logs.'}, 'errorInformationList': {'type': 'array', 'description': 'Information regarding any logs that are rejected during validation.', 'items': {'type': 'object', 'description': 'Contains a description of which log failed to be added and why', 'properties': {'errorMessages': {'type': 'array', 'description': 'String message of error cause.', 'items': {'type': 'string', 'description': 'String message of error cause.'}}, 'logIndex': {'type': 'integer', 'format': 'int32', 'description': 'Index of the log as it appears in the submission request.'}}}}, 'rejected': {'type': 'integer', 'format': 'int32', 'description': 'Number of logs that failed validation.'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['submitToolLog'], 'x-Argus-ApiStatus': 'INTERNAL'}