"""Autogenerated API schema"""
from argus_api import session


add_metric_descriptor = {'tags': ['metrics/v1'], 'summary': 'Add new metric descriptor. (INTERNAL)', 'description': '', 'operationId': 'addMetricDescriptor', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'adminFunction': {'type': 'str', 'description': 'Function required to update this metric descriptor.'}, 'category': {'type': 'str', 'default': 'other', 'description': 'Category of metric descriptor', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'str', 'description': 'ID or shortname of customer bound to this metric descriptor. If not specified, descriptor is domain global'}, 'deduplicationFunction': {'type': 'str', 'default': 'none', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'str', 'description': 'Description of the metric descriptor.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'domain': {'type': 'str', 'default': 'Current user domain', 'description': 'ID or shortname of domain bound to this metric descriptor.'}, 'globalDescriptor': {'type': 'bool', 'default': False, 'description': 'Whether this descriptor is intended for records that are not customer specific.'}, 'keepAuditData': {'type': 'bool', 'default': True, 'description': 'Whether to maintain a record of data useful for auditing.'}, 'keepBackup': {'type': 'bool', 'default': True, 'description': 'Whether to keep a separate record of the metric as a backup outside ElasticSearch.'}, 'keys': {'type': 'list', 'description': 'Descriptors for metric keys.', 'items': {'type': 'dict', 'description': 'Request to create a metric descriptor key', 'properties': {'description': {'type': 'str', 'description': 'Description of the key.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'language': {'type': 'str', 'default': 'ENGLISH', 'description': 'Language of the translation used on the key value.', 'enum': ['english', 'norwegian']}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor key descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor key descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor key names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor key names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': "Name of the metric key. Will be validated against a list of reserved names, which include 'customer'.", 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'translator': {'type': 'str', 'default': 'none', 'description': 'Translator that can be used for the key value.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': 'str', 'options': ['ip', 'hostName', 'integer', 'string', 'uuid']}, 'required': ['description', 'language', 'name', 'translator', 'type']}, 'maxItems': 2147483647, 'minItems': 1}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': 'Name of the metric descriptor. Does not need to be unique.'}, 'readFunction': {'type': 'str', 'description': 'Function required to fetch metric descriptor and associated records.'}, 'shortName': {'type': 'str', 'description': 'Short name of the metric descriptor. Must be unique per domain.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'timeFrameSize': {'type': 'int', 'description': 'Time period used for setting up time frames. For each time frame, deduplicationFunction property is used to determine value(s) of metric record.'}, 'timeFrameSizeUnit': {'type': 'str', 'default': 'milliseconds', 'description': 'Unit of the timeFrameSize value, this is used as the default resolution unit during aggregation.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'useSeparateIndex': {'type': 'bool', 'default': False, 'description': 'Whether the separate index for metric records is used or not.'}, 'values': {'type': 'list', 'description': 'Descriptors for metric values.', 'items': {'type': 'dict', 'description': 'Request to create a metric descriptor value', 'properties': {'defaultAggregationFunction': {'type': 'str', 'default': 'sum', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'str', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'str', 'description': 'Description of the value.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor value descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor value descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor value names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor value names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': 'Name of the metric value.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'unit': {'type': 'str', 'default': 'count', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}, 'required': ['description', 'name']}, 'maxItems': 2147483647, 'minItems': 1}, 'writeFunction': {'type': 'str', 'description': 'Function required to submit metric record.'}}, 'required': ['adminFunction', 'deduplicationFunction', 'description', 'keys', 'readFunction', 'shortName', 'values', 'writeFunction']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Add new metric descriptor.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addCustomerMetricDescriptor', 'addDomainMetricDescriptor'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_metric_descriptor = {'tags': ['metrics/v1'], 'summary': 'Delete metric descriptor (INTERNAL)', 'description': '', 'operationId': 'deleteMetricDescriptor', 'parameters': [{'name': 'descriptor', 'in': 'path', 'description': 'Shortname or ID of descriptor', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'descriptorDomain', 'in': 'query', 'description': "Domain which is used if short name is specified for 'descriptor' parameter. Defaults to current user domain.", 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Delete metric descriptor', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteMetricDescriptor'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_metric_descriptor = {'tags': ['metrics/v1'], 'summary': 'Fetch metric descriptor. (PUBLIC)', 'description': '', 'operationId': 'getMetricDescriptor', 'parameters': [{'name': 'descriptor', 'in': 'path', 'description': 'ID or short name of metric descriptor', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'descriptorDomain', 'in': 'query', 'description': "Domain which is used if short name is specified for 'descriptor' parameter. Defaults to current user domain.", 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch metric descriptor.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCustomerMetricDescriptor', 'viewDomainMetricDescriptor'], 'x-Argus-ApiStatus': 'PUBLIC'}
get_metric_descriptors = {'tags': ['metrics/v1'], 'summary': 'Fetch metric descriptor based on criteria (PUBLIC)', 'description': '', 'operationId': 'getMetricDescriptors', 'parameters': [{'name': 'descriptorDomain', 'in': 'query', 'description': 'Restrict search to entries bound to specified domains (domain ID or shortname)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'customer', 'in': 'query', 'description': 'Restrict search to entries bound to specified customers (customer ID or shortname)', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}], 'responses': {'default': {'description': 'Fetch metric descriptor based on criteria', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCustomerMetricDescriptor', 'viewDomainMetricDescriptor'], 'x-Argus-ApiStatus': 'PUBLIC'}
search_metric_descriptors = {'tags': ['metrics/v1'], 'summary': 'Fetch metric descriptor based on criteria (PUBLIC)', 'description': '', 'operationId': 'searchMetricDescriptors', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'customer': {'type': 'list', 'description': 'Restrict search to entries bound to specified customers (customer ID or shortname).', 'items': {'type': 'str', 'description': 'Restrict search to entries bound to specified customers (customer ID or shortname).'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Restrict search to entries bound to specified domains (domain ID or shortname).', 'items': {'type': 'str', 'description': 'Restrict search to entries bound to specified domains (domain ID or shortname).'}, 'uniqueItems': True}, 'excludeFlags': {'type': 'list', 'description': 'Exclude descriptors which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude descriptors which have excludeFlags set.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'includeDeleted': {'type': 'bool', 'default': False, 'description': 'Include descriptors which have been deleted.'}, 'includeFlags': {'type': 'list', 'description': 'Include descriptors which have includeFlags set.', 'items': {'type': 'str', 'description': 'Include descriptors which have includeFlags set.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'All supported fields', 'description': 'Defines which fields will be searched by keywords', 'items': {'type': 'str', 'default': 'All supported fields', 'description': 'Defines which fields will be searched by keywords', 'enum': ['shortName', 'description', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'Match all keywords', 'description': 'Defines the MatchStrategy for keywords.', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Restrict search to entries containing keywords in description.', 'items': {'type': 'str', 'description': 'Restrict search to entries containing keywords in description.'}, 'uniqueItems': True}, 'limit': {'type': 'int', 'default': 25, 'description': 'Set this value to set max number of results.'}, 'offset': {'type': 'int', 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object.'}, 'subCriteria': {'type': 'list', 'default': 'OR', 'description': 'Set additional criterias to be applied as specified in the subcriteria object(s) (AND, AND NOT, OR).', 'items': {'type': 'dict', 'properties': {'customer': {'type': 'list', 'description': 'Restrict search to entries bound to specified customers (customer ID or shortname).', 'items': {'type': 'str', 'description': 'Restrict search to entries bound to specified customers (customer ID or shortname).'}, 'uniqueItems': True}, 'domain': {'type': 'list', 'description': 'Restrict search to entries bound to specified domains (domain ID or shortname).', 'items': {'type': 'str', 'description': 'Restrict search to entries bound to specified domains (domain ID or shortname).'}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'If set to true, objects matching this subcriteria object will be excluded.'}, 'excludeFlags': {'type': 'list', 'description': 'Exclude descriptors which have excludeFlags set.', 'items': {'type': 'str', 'description': 'Exclude descriptors which have excludeFlags set.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'includeFlags': {'type': 'list', 'description': 'Include descriptors which have includeFlags set.', 'items': {'type': 'str', 'description': 'Include descriptors which have includeFlags set.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'All supported fields', 'description': 'Defines which fields will be searched by keywords', 'items': {'type': 'str', 'default': 'All supported fields', 'description': 'Defines which fields will be searched by keywords', 'enum': ['shortName', 'description', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'Match all keywords', 'description': 'Defines the MatchStrategy for keywords.', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Restrict search to entries containing keywords in description.', 'items': {'type': 'str', 'description': 'Restrict search to entries containing keywords in description.'}, 'uniqueItems': True}, 'required': {'type': 'bool', 'description': 'If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}}}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Fetch metric descriptor based on criteria', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewCustomerMetricDescriptor', 'viewDomainMetricDescriptor'], 'x-Argus-ApiStatus': 'PUBLIC'}
update_metric_descriptor = {'tags': ['metrics/v1'], 'summary': 'Update existing metric descriptor. (INTERNAL)', 'description': '', 'operationId': 'updateMetricDescriptor', 'parameters': [{'name': 'descriptor', 'in': 'path', 'description': 'Shortname or ID of descriptor', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'descriptorDomain', 'in': 'query', 'description': "Domain which is used if short name is specified for 'descriptor' parameter. Defaults to current user domain.", 'schema': {'type': 'string'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'properties': {'addKeys': {'type': 'list', 'description': 'Descriptors for metric keys to add. Previously accepted metrics will still exist and considered valid, but new submissions must match the changed descriptor.', 'items': {'type': 'dict', 'description': 'Request to create a metric descriptor key', 'properties': {'description': {'type': 'str', 'description': 'Description of the key.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'language': {'type': 'str', 'default': 'ENGLISH', 'description': 'Language of the translation used on the key value.', 'enum': ['english', 'norwegian']}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor key descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor key descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor key names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor key names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': "Name of the metric key. Will be validated against a list of reserved names, which include 'customer'.", 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'translator': {'type': 'str', 'default': 'none', 'description': 'Translator that can be used for the key value.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': 'str', 'options': ['ip', 'hostName', 'integer', 'string', 'uuid']}, 'required': ['description', 'language', 'name', 'translator', 'type']}}, 'addValues': {'type': 'list', 'description': 'Descriptors for metric values to add. Previously accepted metrics will still exist and considered valid, but new submissions must match the changed descriptor.', 'items': {'type': 'dict', 'description': 'Request to create a metric descriptor value', 'properties': {'defaultAggregationFunction': {'type': 'str', 'default': 'sum', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'str', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'str', 'description': 'Description of the value.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor value descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor value descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor value names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor value names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': 'Name of the metric value.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'unit': {'type': 'str', 'default': 'count', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}, 'required': ['description', 'name']}}, 'adminFunction': {'type': 'str', 'description': 'Function required to update this metric descriptor.'}, 'category': {'type': 'str', 'description': 'Category of metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'deduplicationFunction': {'type': 'str', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'str', 'description': 'Description of the metric descriptor.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'keepAuditData': {'type': 'bool', 'description': 'Whether to maintain a record of data useful for auditing.'}, 'keepBackup': {'type': 'bool', 'description': 'Whether to keep a separate record of the metric as a backup outside ElasticSearch.'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': 'Name of the metric descriptor. Does not need to be unique.'}, 'readFunction': {'type': 'str', 'description': 'Function required to fetch metric descriptor and associated records.'}, 'removeKeys': {'type': 'list', 'description': 'Descriptors for metric keys to remove. Previously accepted metrics will still exist and considered valid, but new submissions must match the changed descriptor.', 'items': {'type': 'str', 'description': 'Descriptors for metric keys to remove. Previously accepted metrics will still exist and considered valid, but new submissions must match the changed descriptor.'}, 'uniqueItems': True}, 'removeValues': {'type': 'list', 'description': 'Descriptors for metric values to remove. Previously accepted metrics will still exist and considered valid, but new submissions must match the changed descriptor.', 'items': {'type': 'str', 'description': 'Descriptors for metric values to remove. Previously accepted metrics will still exist and considered valid, but new submissions must match the changed descriptor.'}, 'uniqueItems': True}, 'shortName': {'type': 'str', 'description': 'Short name of the metric descriptor. Must be unique per domain.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'timeFrameSize': {'type': 'int', 'description': 'Time period used for setting up time frames. For each time frame, deduplicationFunction property is used to determine value(s) of metric record.'}, 'timeFrameSizeUnit': {'type': 'str', 'default': 'milliseconds', 'description': 'Unit of the timeFrameSize value, this is used as the default resolution unit during aggregation.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'updateKeys': {'type': 'list', 'description': 'Descriptors for metric keys to update. Only the translator and language can be updated while name is used to identify the key to modify.', 'items': {'type': 'dict', 'properties': {'description': {'type': 'str', 'description': 'New description of the key.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'language': {'type': 'str', 'description': 'New Language for the key value.', 'enum': ['english', 'norwegian']}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor key descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor key descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor key names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor key names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': 'Name of the metric key. Used to identify, not update, the key.', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'translator': {'type': 'str', 'description': 'Translator that can be used for the key value.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}}, 'required': ['name']}}, 'updateValues': {'type': 'list', 'description': 'Descriptors for metric values to update. Only the default aggregation and value by weight can be updated while the name is used to identify the value to modify.', 'items': {'type': 'dict', 'description': "Request to update a descriptor a sub-set of a value's, identified by name, fields", 'properties': {'defaultAggregationFunction': {'type': 'str', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'str', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'str', 'description': 'Description of the value.', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'localizedDescriptions': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor value descriptions mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor value descriptions mapped by language. Supported languages are: english, norwegian.'}, 'localizedNames': {'type': 'dict', 'additionalProperties': {'type': 'str', 'description': 'Metric descriptor value names mapped by language. Supported languages are: english, norwegian.'}, 'description': 'Metric descriptor value names mapped by language. Supported languages are: english, norwegian.'}, 'name': {'type': 'str', 'description': 'Name of the metric value. Used to identify, not update, the value.'}, 'unit': {'type': 'str', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}, 'required': ['name']}}, 'useSeparateIndex': {'type': 'bool', 'description': "Whether the separate index for metric records is used or not. If value of this property is 'true', changing is not permitted."}, 'writeFunction': {'type': 'str', 'description': 'Function required to submit metric record.'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update existing metric descriptor.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}, '220': {'description': 'No values updated.', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "Metric descriptor provides information about the structure of the metric, it's keys and values.", 'properties': {'adminFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'category': {'type': 'string', 'description': 'Category of the metric descriptor.', 'enum': ['CASE', 'EVENT', 'ASSET', 'SAMPLE', 'OTHER']}, 'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'deduplicationFunction': {'type': 'string', 'description': 'Function used while submitting a metric record, to calculate value if duplicates within same time frame appear.', 'enum': ['none', 'first', 'last']}, 'description': {'type': 'string', 'description': 'Description of the metric descriptor.'}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': 'Flags assigned to the metric descriptor.', 'items': {'type': 'string', 'description': 'Flags assigned to the metric descriptor.', 'enum': ['deleted', 'usingSeparateIndex', 'keepBackup', 'keepAuditData', 'global']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the response object.'}, 'keys': {'type': 'array', 'description': 'Descriptors for metric keys.', 'items': {'type': 'object', 'description': 'Metric descriptor Key provides information about the metric key.', 'properties': {'description': {'type': 'string', 'description': 'Description of the key.'}, 'language': {'type': 'string', 'description': 'Language used for the human readable string.', 'enum': ['english', 'norwegian']}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric key based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric key'}, 'description': 'All available descriptions of the metric key'}, 'localizedName': {'type': 'string', 'description': "Name of the metric key based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric key'}, 'description': 'All available names of the metric key'}, 'name': {'type': 'string', 'description': 'Name of the metric key.'}, 'translator': {'type': 'string', 'description': 'Translator for key value to human readable string.', 'enum': ['none', 'caseCategory', 'componentHostName', 'eventFilter', 'sensorHostName', 'sensorType', 'serviceName', 'monthOfYear', 'dayOfWeek', 'assetName', 'alarmName', 'hourOfDay', 'casePriority', 'assetGroup', 'vulnerabilityIdentifier', 'logSource']}, 'type': {'type': 'string', 'description': 'Type of the metric key.', 'enum': ['ip', 'hostName', 'integer', 'string', 'uuid']}}}}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric descriptor based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric descriptor'}, 'description': 'All available descriptions of the metric descriptor'}, 'localizedName': {'type': 'string', 'description': "Name of the metric descriptor based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric descriptor'}, 'description': 'All available names of the metric descriptor'}, 'name': {'type': 'string', 'description': 'Name of the metric descriptor. This does not need to be unique.'}, 'readFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'shortName': {'type': 'string', 'description': 'Short name of the metric descriptor. This name is unique per domain.'}, 'timeFrameSize': {'type': 'integer', 'format': 'int64', 'description': 'Time period given in the timeFrameSizeUnit and is used for normalizing the timestamp of submitted metric records.'}, 'timeFrameSizeUnit': {'type': 'string', 'description': 'Largest full time unit that can be made from the timeFrameSize.', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days']}, 'values': {'type': 'array', 'description': 'Descriptors for metric values.', 'items': {'type': 'object', 'description': 'Metric descriptor value provides information about the metric value.', 'properties': {'defaultAggregationFunction': {'type': 'string', 'description': 'Default function applied to calculate values for resolution specified in aggregation request. This property is used only for aggregation queries.', 'enum': ['sum', 'avg', 'min', 'max', 'wavg', 'sumOfSquares', 'last']}, 'defaultWeightByValue': {'type': 'string', 'description': 'Default value used as weight when aggregating using a weighted average function.'}, 'description': {'type': 'string', 'description': 'Description of the value.'}, 'localizedDescription': {'type': 'string', 'description': "Description of the metric value based on the current user's language settings."}, 'localizedDescriptions': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available descriptions of the metric value'}, 'description': 'All available descriptions of the metric value'}, 'localizedName': {'type': 'string', 'description': "Name of the metric value based on the current user's language settings."}, 'localizedNames': {'type': 'object', 'additionalProperties': {'type': 'string', 'description': 'All available names of the metric value'}, 'description': 'All available names of the metric value'}, 'name': {'type': 'string', 'description': 'Name of the metric value.'}, 'unit': {'type': 'string', 'description': 'The unit in which the value is measured', 'enum': ['count', 'milliseconds', 'seconds', 'minutes', 'hours', 'bytes']}}}}, 'writeFunction': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateMetricDescriptor'], 'x-Argus-ApiStatus': 'INTERNAL'}