"""Autogenerated API schema"""
from argus_api import session


search_records_simplified_cof = {'tags': ['pdns/v3'], 'summary': 'Search against PassiveDNS and return matching records in PDNS COF format (PUBLIC)', 'description': 'This endpoint behaves exactly like searchRecordsSimplified, but follows the Passive DNS Common Output Format as specified in Internet Draft draft-dulaunoy-dnsop-passive-dns-cof-06.\nThis means that the return format of this endpoint is a newline-separated list of JSON objects.', 'operationId': 'searchRecordsSimplifiedCOF', 'parameters': [{'name': 'Accept', 'in': 'header', 'schema': {'type': 'string'}}, {'name': 'query', 'in': 'path', 'description': 'Search by query', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'aggregate', 'in': 'query', 'description': 'Whether aggregate records', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'includeAnonymous', 'in': 'query', 'description': 'Whether include anonymous records', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'rrClass', 'in': 'query', 'description': 'Search by recordClass (rrclass)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['in']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['in']}, 'uniqueItems': True}, {'name': 'rrType', 'in': 'query', 'description': 'Search by type (rrtype)', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['a', 'aaaa', 'cname', 'dname', 'mx', 'naptr', 'ns', 'ptr', 'rp', 'soa', 'srv', 'txt']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['a', 'aaaa', 'cname', 'dname', 'mx', 'naptr', 'ns', 'ptr', 'rp', 'soa', 'srv', 'txt']}, 'uniqueItems': True}, {'name': 'customerID', 'in': 'query', 'description': 'Search by customerID', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'tlp', 'in': 'query', 'description': 'Search by TLP', 'schema': {'type': 'list', 'items': {'type': 'str', 'enum': ['white', 'green', 'amber', 'red']}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'str', 'enum': ['white', 'green', 'amber', 'red']}, 'uniqueItems': True}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of records', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Max number of records to be returned', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'queryMatchStrategy', 'in': 'query', 'description': 'Query match strategy, partial must be set to use the wildcard', 'schema': {'type': 'str', 'enum': ['exact', 'includeSubdomains']}, 'type': 'str', 'enum': ['exact', 'includeSubdomains']}], 'responses': {'default': {'description': 'Search against PassiveDNS and return matching records in PDNS COF format', 'content': {'application/json': {}, 'text/csv': {}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}, 'text/csv': {}}}, '402': {'description': 'Resource limit exceeded', 'content': {'application/json': {}, 'text/csv': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}, 'text/csv': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}, 'text/csv': {}}}}, 'x-Argus-ApiStatus': 'PUBLIC'}