"""Autogenerated API schema"""
from argus_api import session


submit_pdns_records_bulk = {'tags': ['pdns/v3'], 'summary': 'Submit PassiveDNS records in a bulk operation (INTERNAL)', 'description': '', 'operationId': 'submitPDNSRecordsBulk', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to bulk submit PDNS records', 'properties': {'records': {'type': 'list', 'description': 'PDNS records for submission.', 'items': {'type': 'dict', 'description': 'Request containing PDNS record information to be submitted', 'properties': {'lastSeen': {'type': 'int', 'description': 'Last seen, defaults to reception from agent. Accepts ISO-8601 timestamp string.'}, 'firstSeen': {'type': 'int', 'description': 'First time record was seen, usually is set by agent. Accepts ISO-8601 timestamp string.'}, 'times': {'type': 'int', 'default': 1, 'description': 'Incident count', 'minimum': 1}, 'minTTLSec': {'type': 'int', 'description': 'Minimum Time to leave in seconds.', 'minimum': 0}, 'maxTTLSec': {'type': 'int', 'description': 'Max Time to leave in seconds.', 'minimum': 0}, 'query': {'type': 'str', 'description': 'Querying address'}, 'answer': {'type': 'str', 'description': 'Answering address'}, 'customer': {'type': 'str', 'description': 'ID or shortname of customer'}, 'tlp': {'type': 'str', 'description': 'Traffic Light Protocol', 'enum': ['white', 'green', 'amber', 'red']}, 'recordClass': {'type': 'str', 'default': 'in', 'description': 'Record class type', 'enum': ['in']}, 'recordType': {'type': 'str', 'description': 'Record recordType', 'enum': ['a', 'aaaa', 'cname', 'dname', 'mx', 'naptr', 'ns', 'ptr', 'rp', 'soa', 'srv', 'txt']}}, 'required': ['answer', 'query', 'recordClass', 'recordType', 'tlp']}, 'maxItems': 2147483647, 'minItems': 1}, 'ignoreOnFailed': {'type': 'bool', 'default': False, 'description': 'Set this value for successful response even failures occur while submitting.'}}, 'required': ['records']}}}, 'required': True}, 'responses': {'default': {'description': 'Submit PassiveDNS records in a bulk operation', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Contains information on the bulk submit results', 'properties': {'accepted': {'type': 'integer', 'format': 'int32', 'description': 'Number of successfully submitted records.'}, 'rejected': {'type': 'integer', 'format': 'int32', 'description': 'Number of records that failed validation.'}, 'errorInformationList': {'type': 'array', 'description': 'Information regarding any records that rejected during validation.', 'items': {'type': 'object', 'description': 'Contains error information from a bulk submit request', 'properties': {'submissionIndex': {'type': 'integer', 'format': 'int32', 'description': 'Index of the submission as it appears in the submission request.'}, 'errorMessages': {'type': 'array', 'description': 'String message of error cause.', 'items': {'type': 'string', 'description': 'String message of error cause.'}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation failed', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['submitPDNSRecord'], 'x-Argus-ApiStatus': 'INTERNAL'}