"""Autogenerated API schema"""
from argus_api import session


add_observations = {'tags': ['reputation/v1'], 'summary': 'Add reputation observations (INTERNAL)', 'description': '', 'operationId': 'addObservations', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'A request to add Observations from a given Source.', 'properties': {'addAddresses': {'type': 'bool', 'default': True, 'description': 'Whether to add addresses'}, 'addDomains': {'type': 'bool', 'default': True, 'description': 'Whether to add domains'}, 'observations': {'type': 'list', 'description': 'Observations to add. Invalid observations will be rejected but not fail the entire request.', 'items': {'type': 'dict', 'description': 'An observation of a host, identified by IP address and / or domain name.', 'properties': {'address': {'type': 'string'}, 'comment': {'type': 'str', 'description': 'Any comment for this observation.No validation performed on the contents other than truncating for max length. Clients cannot make any assumptions as to the contents and should therefore escape everything when rendering.', 'maxLength': 2048, 'minLength': 0}, 'domain': {'type': 'str', 'description': "The host's domain name."}, 'domainName': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'int', 'description': 'When the host was first observed.'}, 'lastSeen': {'type': 'int', 'description': 'When the host was most recently observed.'}, 'observationCount': {'type': 'int', 'description': 'Number of times the host has been observed'}, 'roleAlias': {'type': 'str', 'description': 'Role alias'}}, 'required': ['roleAlias']}, 'maxItems': 2147483647, 'minItems': 1}, 'sourceAlias': {'type': 'str', 'description': "The source's globally unique alias."}, 'sourceID': {'type': 'int', 'description': "The source's ID."}}, 'required': ['observations']}}}, 'required': True}, 'responses': {'default': {'description': 'Add reputation observations', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Value object for reporting the result of adding an Observation back to the caller', 'properties': {'awakenCount': {'type': 'integer', 'format': 'int32', 'description': 'The number of existing Observations awakened by the add operation.'}, 'continueCount': {'type': 'integer', 'format': 'int32', 'description': 'The number of existing Observations continued by the add operation.'}, 'newCount': {'type': 'integer', 'format': 'int32', 'description': 'The number of new Observations created by the add operation.'}, 'rejectedObservations': {'type': 'array', 'description': 'Observations rejected during the add operation.', 'items': {'type': 'object', 'description': 'A rejected Observation.', 'properties': {'address': {'type': 'string'}, 'comment': {'type': 'string', 'description': 'Any comment for this observation.No validation performed on the contents other than truncating for max length. Clients cannot make any assumptions as to the contents and should therefore escape everything when rendering.', 'maxLength': 2048, 'minLength': 0}, 'domain': {'type': 'string', 'description': "The host's domain name."}, 'domainName': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'When the host was first observed.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'When the host was most recently observed.'}, 'observationCount': {'type': 'integer', 'format': 'int32', 'description': 'Number of times the host has been observed'}, 'reason': {'type': 'string', 'description': "The Enumerated Reason why an Observation was rejected. Whitelisted: The Observation's domain/address is whitelisted. Invalid: At least one of the Observation's fields' contents failed validation. Obsolete: The Observation is older than an existing one for the same domain/address. Customer Network: The (Address) Observation is for a known customer network.", 'enum': ['WHITELISTED', 'INVALID', 'OBSOLETE', 'CUSTOMER_NETWORK']}, 'rejectReasons': {'type': 'array', 'items': {'type': 'string'}}, 'roleAlias': {'type': 'string', 'description': 'Role alias'}}, 'required': ['roleAlias']}}, 'skipCount': {'type': 'integer', 'format': 'int32', 'description': 'The number of Observations skipped by the add operation.'}, 'skippedObservations': {'type': 'array', 'description': 'Observations skipped during the add operation.', 'items': {'type': 'object', 'description': 'A rejected Observation.', 'properties': {'address': {'type': 'string'}, 'comment': {'type': 'string', 'description': 'Any comment for this observation.No validation performed on the contents other than truncating for max length. Clients cannot make any assumptions as to the contents and should therefore escape everything when rendering.', 'maxLength': 2048, 'minLength': 0}, 'domain': {'type': 'string', 'description': "The host's domain name."}, 'domainName': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'When the host was first observed.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'When the host was most recently observed.'}, 'observationCount': {'type': 'integer', 'format': 'int32', 'description': 'Number of times the host has been observed'}, 'reason': {'type': 'string', 'description': "The Enumerated Reason why an Observation was rejected. Whitelisted: The Observation's domain/address is whitelisted. Invalid: At least one of the Observation's fields' contents failed validation. Obsolete: The Observation is older than an existing one for the same domain/address. Customer Network: The (Address) Observation is for a known customer network.", 'enum': ['WHITELISTED', 'INVALID', 'OBSOLETE', 'CUSTOMER_NETWORK']}, 'rejectReasons': {'type': 'array', 'items': {'type': 'string'}}, 'roleAlias': {'type': 'string', 'description': 'Role alias'}}, 'required': ['roleAlias']}}, 'whitelistedObservations': {'type': 'array', 'description': 'Observations whitelisted during the add operation.', 'items': {'type': 'object', 'description': 'A rejected Observation.', 'properties': {'address': {'type': 'string'}, 'comment': {'type': 'string', 'description': 'Any comment for this observation.No validation performed on the contents other than truncating for max length. Clients cannot make any assumptions as to the contents and should therefore escape everything when rendering.', 'maxLength': 2048, 'minLength': 0}, 'domain': {'type': 'string', 'description': "The host's domain name."}, 'domainName': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'When the host was first observed.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'When the host was most recently observed.'}, 'observationCount': {'type': 'integer', 'format': 'int32', 'description': 'Number of times the host has been observed'}, 'reason': {'type': 'string', 'description': "The Enumerated Reason why an Observation was rejected. Whitelisted: The Observation's domain/address is whitelisted. Invalid: At least one of the Observation's fields' contents failed validation. Obsolete: The Observation is older than an existing one for the same domain/address. Customer Network: The (Address) Observation is for a known customer network.", 'enum': ['WHITELISTED', 'INVALID', 'OBSOLETE', 'CUSTOMER_NETWORK']}, 'rejectReasons': {'type': 'array', 'items': {'type': 'string'}}, 'roleAlias': {'type': 'string', 'description': 'Role alias'}}, 'required': ['roleAlias']}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_observations = {'tags': ['reputation/v1'], 'summary': 'Delete reputation observations (INTERNAL)', 'description': '', 'operationId': 'deleteObservations', 'parameters': [{'name': 'sourceID', 'in': 'query', 'description': 'Source ID', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}, {'name': 'sourceAlias', 'in': 'query', 'description': 'Source alias', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'address', 'in': 'query', 'description': 'IP Addresses', 'schema': {'type': 'list', 'items': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'uniqueItems': True}, {'name': 'fqdn', 'in': 'query', 'description': 'Domain names', 'schema': {'type': 'list', 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Delete reputation observations', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'properties': {'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
fetch_observations_for_domain = {'tags': ['reputation/v1'], 'summary': 'Look up reputation observations for the given domain (INTERNAL)', 'description': '', 'operationId': 'fetchObservationsForDomain', 'parameters': [{'name': 'fqdn', 'in': 'path', 'description': 'Domain to fetch observations for', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'Look up reputation observations for the given domain', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An observation for a domain name', 'properties': {'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'domainName': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
fetch_observations_for_ip = {'tags': ['reputation/v1'], 'summary': 'Look up reputation observations for the given IP (INTERNAL)', 'description': '', 'operationId': 'fetchObservationsForIP', 'parameters': [{'name': 'ip', 'in': 'path', 'description': 'IP address to fetch observations for', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'Look up reputation observations for the given IP', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An Observation for an IP address', 'properties': {'address': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
find_address_observations = {'tags': ['reputation/v1'], 'summary': 'Search for IP observations (INTERNAL)', 'description': '', 'operationId': 'findAddressObservations', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Search criteria for observations for matching IP addresses', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'description': 'Search criteria for observations for matching IP addresses', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'minimumState': {'type': 'int', 'description': 'Filter results by observations with at least this state'}, 'minimumConfidence': {'type': 'float', 'description': 'Filter results by observations with at least this confidence'}, 'sourceID': {'type': 'list', 'description': 'Filter results by observations from these sources', 'items': {'type': 'int', 'description': 'Filter results by observations from these sources'}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated >= this timestamp'}, 'endTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated <= this timestamp'}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'fromAddress': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'afterAddress': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'addresses': {'type': 'list', 'description': 'Filter results by these IP addresses', 'items': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'address', 'lastModified', 'source', 'role', '-id', '-address', '-lastModified', '-source', '-role']}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'minimumState': {'type': 'int', 'description': 'Filter results by observations with at least this state'}, 'minimumConfidence': {'type': 'float', 'description': 'Filter results by observations with at least this confidence'}, 'sourceID': {'type': 'list', 'description': 'Filter results by observations from these sources', 'items': {'type': 'int', 'description': 'Filter results by observations from these sources'}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated >= this timestamp'}, 'endTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated <= this timestamp'}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'fromAddress': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'afterAddress': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'addresses': {'type': 'list', 'description': 'Filter results by these IP addresses', 'items': {'type': 'dict', 'properties': {'address': {'type': 'str', 'xml': {'attribute': True}}, 'host': {'type': 'bool', 'xml': {'attribute': True}}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'address', 'lastModified', 'source', 'role', '-id', '-address', '-lastModified', '-source', '-role']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search for IP observations', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An Observation for an IP address', 'properties': {'address': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
find_domain_observations = {'tags': ['reputation/v1'], 'summary': 'Search for domain observations (INTERNAL)', 'description': '', 'operationId': 'findDomainObservations', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Search criteria for observations for matching domains', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'description': 'Search criteria for observations for matching domains', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'minimumState': {'type': 'int', 'description': 'Filter results by observations with at least this state'}, 'minimumConfidence': {'type': 'float', 'description': 'Filter results by observations with at least this confidence'}, 'sourceID': {'type': 'list', 'description': 'Filter results by observations from these sources', 'items': {'type': 'int', 'description': 'Filter results by observations from these sources'}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated >= this timestamp'}, 'endTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated <= this timestamp'}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'fromDomainName': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'afterDomainName': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'domainNames': {'type': 'list', 'deprecated': True, 'description': 'Search for observations by domain name. Deprecated, use domains instead.', 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'domains': {'type': 'list', 'description': 'Search for observations by domain name.', 'items': {'type': 'str', 'description': 'Search for observations by domain name.'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'domainName', 'domain', 'lastModified', 'source', 'role', '-id', '-domainName', '-domain', '-lastModified', '-source', '-role']}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'minimumState': {'type': 'int', 'description': 'Filter results by observations with at least this state'}, 'minimumConfidence': {'type': 'float', 'description': 'Filter results by observations with at least this confidence'}, 'sourceID': {'type': 'list', 'description': 'Filter results by observations from these sources', 'items': {'type': 'int', 'description': 'Filter results by observations from these sources'}, 'uniqueItems': True}, 'startTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated >= this timestamp'}, 'endTimestamp': {'type': 'int', 'description': 'Filter results by observations last updated <= this timestamp'}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'fromDomainName': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'afterDomainName': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'domainNames': {'type': 'list', 'deprecated': True, 'description': 'Search for observations by domain name. Deprecated, use domains instead.', 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'domains': {'type': 'list', 'description': 'Search for observations by domain name.', 'items': {'type': 'str', 'description': 'Search for observations by domain name.'}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'domainName', 'domain', 'lastModified', 'source', 'role', '-id', '-domainName', '-domain', '-lastModified', '-source', '-role']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search for domain observations', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An observation for a domain name', 'properties': {'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'domainName': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_address_observations = {'tags': ['reputation/v1'], 'summary': 'List IP observations (INTERNAL)', 'description': '', 'operationId': 'listAddressObservations', 'parameters': [{'name': 'sourceID', 'in': 'query', 'description': 'Limit result to observations from specified source', 'schema': {'type': 'int'}, 'type': 'int'}, {'name': 'minimumState', 'in': 'query', 'description': 'Limit result to observations with this state or higher', 'schema': {'type': 'int'}, 'type': 'int'}, {'name': 'minimumConfidence', 'in': 'query', 'description': 'Limit result to observations bound to sources with at least this confidence', 'schema': {'type': 'float', 'enum': ['range[0.0', '1.0]']}, 'type': 'float', 'enum': ['range[0.0', '1.0]']}, {'name': 'limit', 'in': 'query', 'description': 'Limit result', 'schema': {'type': 'int', 'default': '25'}, 'type': 'int', 'default': '25'}, {'name': 'offset', 'in': 'query', 'description': 'Offset result', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'List IP observations', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An Observation for an IP address', 'properties': {'address': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_domain_observations = {'tags': ['reputation/v1'], 'summary': 'List domain observations (INTERNAL)', 'description': '', 'operationId': 'listDomainObservations', 'parameters': [{'name': 'sourceID', 'in': 'query', 'description': 'Limit result to observations from specified source', 'schema': {'type': 'int'}, 'type': 'int'}, {'name': 'minimumState', 'in': 'query', 'description': 'Limit result to observations with this state or higher', 'schema': {'type': 'int'}, 'type': 'int'}, {'name': 'minimumConfidence', 'in': 'query', 'description': 'Limit result to observations bound to sources with at least this confidence', 'schema': {'type': 'float', 'enum': ['range[0.0', '1.0]']}, 'type': 'float', 'enum': ['range[0.0', '1.0]']}, {'name': 'limit', 'in': 'query', 'description': 'Limit result', 'schema': {'type': 'int', 'default': '25'}, 'type': 'int', 'default': '25'}, {'name': 'offset', 'in': 'query', 'description': 'Offset result', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'List domain observations', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An observation for a domain name', 'properties': {'comment': {'type': 'string', 'description': 'The comment associated with this observation'}, 'domainName': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}, 'firstSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the first observation of the IP first made by this source'}, 'id': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'Last time the observation was modified.'}, 'lastSeen': {'type': 'integer', 'format': 'int64', 'description': 'The timestamp of the most recent observation of the IP first made by this source'}, 'numObservations': {'type': 'integer', 'format': 'int32', 'description': 'The number of times the IP address was observed during the time period.'}, 'role': {'type': 'object', 'description': "Metadata for an Observation's Role", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Role."}}}, 'source': {'type': 'object', 'description': "Metadata for an Observation's Source", 'properties': {'alias': {'type': 'string', 'description': "Globally unique alias for the Observation's Role"}, 'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string', 'description': "Full name of the Observation's Source"}}}, 'state': {'type': 'integer', 'format': 'int32', 'description': 'The state of the observation.'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewObservationData'], 'x-Argus-ApiStatus': 'INTERNAL'}