"""Autogenerated API schema"""
from argus_api import session


add_address_overrides = {'tags': ['reputation/v1'], 'summary': 'Add reputation IP override (INTERNAL)', 'description': '', 'operationId': 'addAddressOverrides', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to add an address override entry to an override list.', 'properties': {'clear': {'type': 'bool', 'default': False, 'description': 'Whether to remove all current override entries in the override list.'}, 'listID': {'type': 'int', 'description': "The ID of the override list to which we're adding the address override entries."}, 'listName': {'type': 'str', 'description': "The globally unique name of the override list to which we're adding the address override entries."}, 'overrides': {'type': 'list', 'description': 'The address override entries to add.', 'items': {'type': 'dict', 'description': 'An IP address override entry.', 'properties': {'cutoff': {'type': 'int', 'description': 'Timestamp when, in epoch millis, this override entry expires.'}, 'ipRange': {'type': 'string'}, 'reason': {'type': 'str', 'description': 'The reason this override entry was created.'}, 'value': {'type': 'float', 'description': 'The value for this override entry. Ranges from 0 to 1.0'}}}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Add reputation IP override', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
add_domain_override = {'tags': ['reputation/v1'], 'summary': 'Add reputation domain override (INTERNAL)', 'description': '', 'operationId': 'addDomainOverride', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to add a domain name override entry to an override list.', 'properties': {'clear': {'type': 'bool', 'default': False, 'description': 'Whether to remove all current override entries in the override list.'}, 'listID': {'type': 'int', 'description': "The ID of the override list to which we're adding the domain override entries."}, 'listName': {'type': 'str', 'description': "The globally unique name of the override list to which we're adding the domain override entries."}, 'overrides': {'type': 'list', 'description': 'The domain override entries to add.', 'items': {'type': 'dict', 'description': 'A domain name override entry.', 'properties': {'cutoff': {'type': 'int', 'description': 'Timestamp when, in epoch millis, this override entry expires.'}, 'domainPattern': {'type': 'string'}, 'reason': {'type': 'str', 'description': 'The reason this override entry was created.'}, 'value': {'type': 'float', 'description': 'The value for this override entry. Ranges from 0 to 1.0'}}}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Add reputation domain override', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
add_override_list = {'tags': ['reputation/v1'], 'summary': 'Add reputation override list (INTERNAL)', 'description': '', 'operationId': 'addOverrideList', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to create a new Override List.', 'properties': {'description': {'type': 'str', 'description': 'Override list description', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'name': {'type': 'str', 'description': 'Unique Override list name', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'useForDefaultValues': {'type': 'bool', 'default': False, 'description': 'If true, enable use of the overrides in this list as default values.'}, 'useForInputFiltering': {'type': 'bool', 'default': False, 'description': 'If true, enable use of the overrides in this list for observation input filtering.'}, 'useForReputationCalc': {'type': 'bool', 'default': False, 'description': 'If true, enable use of the overrides in this list when calculating reputation values.'}}, 'required': ['description', 'name']}}}, 'required': True}, 'responses': {'default': {'description': 'Add reputation override list', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'A collection of override entries.', 'properties': {'defaultValues': {'type': 'boolean'}, 'description': {'type': 'string', 'description': "The Override List's description."}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'string', 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_address_override = {'tags': ['reputation/v1'], 'summary': 'Delete reputation IP override (INTERNAL)', 'description': '', 'operationId': 'deleteAddressOverride', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override entry to remove', 'required': True, 'schema': {'type': 'int'}, 'type': 'int'}], 'responses': {'default': {'description': 'Delete reputation IP override', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_address_overrides = {'tags': ['reputation/v1'], 'summary': 'Bulk delete reputation IP overrides (INTERNAL)', 'description': '', 'operationId': 'deleteAddressOverrides', 'parameters': [{'name': 'id', 'in': 'query', 'description': 'IDs of IP overrides', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Bulk delete reputation IP overrides', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_domain_override = {'tags': ['reputation/v1'], 'summary': 'Delete reputation domain override (INTERNAL)', 'description': '', 'operationId': 'deleteDomainOverride', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override entry to remove', 'required': True, 'schema': {'type': 'int'}, 'type': 'int'}], 'responses': {'default': {'description': 'Delete reputation domain override', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_domain_overrides = {'tags': ['reputation/v1'], 'summary': 'Bulk delete reputation domain overrides (INTERNAL)', 'description': '', 'operationId': 'deleteDomainOverrides', 'parameters': [{'name': 'id', 'in': 'query', 'description': 'IDs of reputation overrides', 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}], 'responses': {'default': {'description': 'Bulk delete reputation domain overrides', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_override_list = {'tags': ['reputation/v1'], 'summary': 'Delete reputation override list (INTERNAL)', 'description': '', 'operationId': 'deleteOverrideList', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override list to remove', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Delete reputation override list', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'A collection of override entries.', 'properties': {'defaultValues': {'type': 'boolean'}, 'description': {'type': 'string', 'description': "The Override List's description."}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'string', 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
find_address_overrides = {'tags': ['reputation/v1'], 'summary': 'Search IP overrides (INTERNAL)', 'description': '', 'operationId': 'findAddressOverrides', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Search criteria for overrides for matching IP addresses', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'description': 'Search criteria for overrides for matching IP addresses', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'description': "Collection of override lists' IDs", 'items': {'type': 'int', 'description': "Collection of override lists' IDs"}}, 'listName': {'type': 'list', 'description': "Collection of override lists' names", 'items': {'type': 'str', 'description': "Collection of override lists' names"}}, 'includedListFlags': {'type': 'int', 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'items': {'type': 'str', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}, 'uniqueItems': True}, 'minValue': {'type': 'float', 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'items': {'type': 'str', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy'}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Define which field(s) to be matched against keywords', 'items': {'type': 'str', 'description': 'Define which field(s) to be matched against keywords', 'enum': ['reason', 'range', 'all']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'lastModified', 'range', '-id', '-lastModified', '-range']}}, 'ranges': {'type': 'list', 'items': {'type': 'string'}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'description': "Collection of override lists' IDs", 'items': {'type': 'int', 'description': "Collection of override lists' IDs"}}, 'listName': {'type': 'list', 'description': "Collection of override lists' names", 'items': {'type': 'str', 'description': "Collection of override lists' names"}}, 'includedListFlags': {'type': 'int', 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'items': {'type': 'str', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}, 'uniqueItems': True}, 'minValue': {'type': 'float', 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'items': {'type': 'str', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy'}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Define which field(s) to be matched against keywords', 'items': {'type': 'str', 'description': 'Define which field(s) to be matched against keywords', 'enum': ['reason', 'range', 'all']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'lastModified', 'range', '-id', '-lastModified', '-range']}}, 'ranges': {'type': 'list', 'items': {'type': 'string'}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search IP overrides', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
find_domain_overrides = {'tags': ['reputation/v1'], 'summary': 'Search domain overrides (INTERNAL)', 'description': '', 'operationId': 'findDomainOverrides', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Search criteria for overrides for matching domains', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': {'type': 'dict', 'description': 'Search criteria for overrides for matching domains', 'properties': {'limit': {'type': 'int', 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'description': 'Set additional criterias which are applied using a logical OR.', 'items': [], 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'description': "Collection of override lists' IDs", 'items': {'type': 'int', 'description': "Collection of override lists' IDs"}}, 'listName': {'type': 'list', 'description': "Collection of override lists' names", 'items': {'type': 'str', 'description': "Collection of override lists' names"}}, 'includedListFlags': {'type': 'int', 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'items': {'type': 'str', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}, 'uniqueItems': True}, 'minValue': {'type': 'float', 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'items': {'type': 'str', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy'}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'domainPatternBases': {'type': 'list', 'description': 'Collection of domain pattern bases', 'items': {'type': 'str', 'description': 'Collection of domain pattern bases'}}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Define which field(s) to be matched against keywords', 'items': {'type': 'str', 'description': 'Define which field(s) to be matched against keywords', 'enum': ['reason', 'domainPattern', 'all']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'lastModified', 'domainPattern', '-id', '-lastModified', '-domainPattern']}}}}, 'uniqueItems': True}, 'exclude': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'description': "Collection of override lists' IDs", 'items': {'type': 'int', 'description': "Collection of override lists' IDs"}}, 'listName': {'type': 'list', 'description': "Collection of override lists' names", 'items': {'type': 'str', 'description': "Collection of override lists' names"}}, 'includedListFlags': {'type': 'int', 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'items': {'type': 'str', 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}, 'uniqueItems': True}, 'minValue': {'type': 'float', 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'items': {'type': 'str', 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy'}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'countMaxWait': {'type': 'int', 'description': 'How many seconds to wait for count calculation to complete. -1: Skip counting altogether to return search results immediately. 0: Unlimited count time for when the count matters and response time does not. Defaults to 2 seconds.', 'minimum': -1}, 'domainPatternBases': {'type': 'list', 'description': 'Collection of domain pattern bases', 'items': {'type': 'str', 'description': 'Collection of domain pattern bases'}}, 'keywordFieldStrategy': {'type': 'list', 'description': 'Define which field(s) to be matched against keywords', 'items': {'type': 'str', 'description': 'Define which field(s) to be matched against keywords', 'enum': ['reason', 'domainPattern', 'all']}, 'uniqueItems': True}, 'sortBy': {'type': 'list', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'enum': ['id', 'lastModified', 'domainPattern', '-id', '-lastModified', '-domainPattern']}}}}}}, 'required': True}, 'responses': {'default': {'description': 'Search domain overrides', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_override_for_domain = {'tags': ['reputation/v1'], 'summary': 'Look up domain override value by ID (INTERNAL)', 'description': '', 'operationId': 'getOverrideForDomain', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override object', 'required': True, 'schema': {'type': 'int'}, 'type': 'int'}], 'responses': {'default': {'description': 'Look up domain override value by ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_override_for_ip = {'tags': ['reputation/v1'], 'summary': 'Look up IP override value by ID (INTERNAL)', 'description': '', 'operationId': 'getOverrideForIP', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override object', 'required': True, 'schema': {'type': 'int'}, 'type': 'int'}], 'responses': {'default': {'description': 'Look up IP override value by ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_override_list_by_id = {'tags': ['reputation/v1'], 'summary': 'Get override list by ID (INTERNAL)', 'description': '', 'operationId': 'getOverrideListByID', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of OverrideList', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'responses': {'default': {'description': 'Get override list by ID', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'A collection of override entries.', 'properties': {'defaultValues': {'type': 'boolean'}, 'description': {'type': 'string', 'description': "The Override List's description."}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'string', 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_override_lists = {'tags': ['reputation/v1'], 'summary': 'List all override lists (INTERNAL)', 'description': '', 'operationId': 'getOverrideLists', 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'sortBy', 'in': 'query', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending, supported fields are: id, lastModified)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'q', 'in': 'query', 'description': '', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywords', 'in': 'query', 'description': 'Filter override lists by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Whether to include deleted results (not included by default)', 'schema': {'type': 'boolean'}, 'type': 'bool'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'List all override lists', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A collection of override entries.', 'properties': {'defaultValues': {'type': 'boolean'}, 'description': {'type': 'string', 'description': "The Override List's description."}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'string', 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_overrides_for_domain = {'tags': ['reputation/v1'], 'summary': 'Look up domain override value by FQDN (INTERNAL)', 'description': '', 'operationId': 'getOverridesForDomain', 'parameters': [{'name': 'fqdn', 'in': 'path', 'description': 'Domain/domain pattern to fetch overrides for', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'Look up domain override value by FQDN', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_overrides_for_ip = {'tags': ['reputation/v1'], 'summary': 'Look up domain override value by IP address (INTERNAL)', 'description': '', 'operationId': 'getOverridesForIP', 'parameters': [{'name': 'ip', 'in': 'path', 'description': 'IP to search overrides for', 'required': True, 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'Look up domain override value by IP address', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_address_overrides = {'tags': ['reputation/v1'], 'summary': 'List address overrides (INTERNAL)', 'description': '', 'operationId': 'listAddressOverrides', 'parameters': [{'name': 'list', 'in': 'query', 'description': 'Limit results to overrides from this list', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'sortBy', 'in': 'query', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending, supported fields are: id, lastModified, range)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'limit', 'in': 'query', 'description': 'Limit results', 'schema': {'type': 'int', 'default': '25'}, 'type': 'int', 'default': '25'}, {'name': 'offset', 'in': 'query', 'description': 'Offset results', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'List address overrides', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'An IP address entry in an Override List.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'range': {'type': 'object', 'description': 'The IP range for which this override entry applies', 'properties': {'fromAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}, 'toAddress': {'type': 'object', 'properties': {'address': {'type': 'string', 'xml': {'attribute': True}}, 'host': {'type': 'boolean', 'xml': {'attribute': True}}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}}}}}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_domain_overrides = {'tags': ['reputation/v1'], 'summary': 'List domain overrides (INTERNAL)', 'description': '', 'operationId': 'listDomainOverrides', 'parameters': [{'name': 'list', 'in': 'query', 'description': 'Limit results to overrides from this list', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'sortBy', 'in': 'query', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending, supported fields are: id, lastModified, domainPattern)", 'schema': {'type': 'list', 'items': {'type': 'string'}}, 'type': 'list', 'items': {'type': 'string'}}, {'name': 'limit', 'in': 'query', 'description': 'Limit results', 'schema': {'type': 'int', 'default': '25'}, 'type': 'int', 'default': '25'}, {'name': 'offset', 'in': 'query', 'description': 'Offset results', 'schema': {'type': 'int', 'default': '0'}, 'type': 'int', 'default': '0'}, {'name': 'countMaxWait', 'in': 'query', 'description': 'Max wait time for result count calculation. 0 equates to unlimited wait and -1 to skip counting altogether. Defaults to 2 seconds.', 'schema': {'type': 'int', 'minimum': -1}, 'type': 'int', 'minimum': -1}], 'responses': {'default': {'description': 'List domain overrides', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'A Domain Name entry in an override list.', 'properties': {'data': {'type': 'object', 'description': 'Common data for an override entry.', 'properties': {'cutoff': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp, in epoch millis, until which the override entry is valid.'}, 'entryTime': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was created.'}, 'reason': {'type': 'string', 'description': 'The reason this override was created.'}, 'user': {'type': 'object', 'description': 'Metadata of the user that created the override entry.', 'properties': {'customer': {'type': 'object', 'properties': {'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}}}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}, 'userName': {'type': 'string'}}}, 'userID': {'type': 'integer', 'format': 'int64', 'deprecated': True, 'description': 'Deprecated, use the user field.'}, 'value': {'type': 'number', 'format': 'double', 'description': "The override entry's value."}}}, 'defaultValue': {'type': 'boolean', 'description': 'Whether this override entry may be used as a default value'}, 'deleted': {'type': 'boolean'}, 'domainPattern': {'type': 'string'}, 'domainPatternBase': {'type': 'string', 'description': "The domain name's pattern base"}, 'expired': {'type': 'boolean'}, 'flags': {'type': 'integer', 'format': 'int64', 'description': 'Flags for the override entry'}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'When the override entry was last updated.'}, 'listName': {'type': 'string', 'description': 'The name of the override list to which this override entry belongs.'}, 'publicPrefixMatch': {'type': 'boolean'}, 'wildcardMatch': {'type': 'boolean'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_override_list = {'tags': ['reputation/v1'], 'summary': 'Update reputation override list (INTERNAL)', 'description': '', 'operationId': 'updateOverrideList', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of reputation override list', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to update an existing Override List.', 'properties': {'description': {'type': 'str', 'description': 'If set, update the description of this list', 'pattern': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'id': {'type': 'int', 'description': "The Override List's unique ID."}, 'name': {'type': 'str', 'description': 'If set, update the name of this list', 'pattern': '[a-zA-Z0-9_:\\-\\.]*'}, 'useForDefaultValues': {'type': 'bool', 'description': 'If set, enable/disable use of the overrides in this list as default values'}, 'useForInputFiltering': {'type': 'bool', 'description': 'If set, enable/disable use of the overrides in this list for observation input filtering'}, 'useForReputationCalc': {'type': 'bool', 'description': 'If set, enable/disable use of the overrides in this list when calculating reputation values'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update reputation override list', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'A collection of override entries.', 'properties': {'defaultValues': {'type': 'boolean'}, 'description': {'type': 'string', 'description': "The Override List's description."}, 'id': {'type': 'integer', 'format': 'int32'}, 'lastModified': {'type': 'integer', 'format': 'int64', 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'string', 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['editOverrideData'], 'x-Argus-ApiStatus': 'INTERNAL'}