"""Autogenerated API schema"""
from argus_api import session


add_default_analysis_rule = {'tags': ['sampledb/v2'], 'summary': 'Endpoint for registering a new analysis policy rule (INTERNAL)', 'description': '', 'operationId': 'addAnalysisRule', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to add an Analysis rule', 'properties': {'action': {'type': 'dict', 'description': 'The actions which are performed when a custom rule matches. A rule can change both workers and options', 'properties': {'options': {'type': 'dict', 'description': 'The actions applied to options', 'properties': {'add': {'type': 'list', 'description': 'Add to the options of the default policy', 'items': {'type': 'dict', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'str', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'str', 'description': 'Stringified value of the option.'}}, 'required': ['key', 'value']}, 'uniqueItems': True}, 'remove': {'type': 'list', 'description': 'Remove from the options of the default policy', 'items': {'type': 'str', 'description': 'Remove from the options of the default policy'}, 'uniqueItems': True}, 'set': {'type': 'list', 'description': 'Overwrite the options of the default policy', 'items': {'type': 'dict', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'str', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'str', 'description': 'Stringified value of the option.'}}, 'required': ['key', 'value']}, 'uniqueItems': True}}}, 'workers': {'type': 'dict', 'description': 'The action applied to workers', 'properties': {'add': {'type': 'list', 'description': 'The id or shortName of the workers to add to the default policy', 'items': {'type': 'str', 'description': 'The id or shortName of the workers to add to the default policy'}, 'uniqueItems': True}, 'remove': {'type': 'list', 'description': 'The id or shortName of the workers to remove from the default policy', 'items': {'type': 'str', 'description': 'The id or shortName of the workers to remove from the default policy'}, 'uniqueItems': True}, 'set': {'type': 'list', 'description': 'The id or shortName of the workers to set to the default policy', 'items': {'type': 'str', 'description': 'The id or shortName of the workers to set to the default policy'}, 'uniqueItems': True}}}}}, 'description': {'type': 'str', 'description': 'Longer description of the custom rule'}, 'match': {'type': 'dict', 'description': 'The clause the custom rule is matching. A rule can only have one match, either customer, classification or submission', 'properties': {'classification': {'type': 'dict', 'description': 'Clause to match by classification', 'properties': {'superType': {'type': 'list', 'description': 'The classification supertype being matched', 'items': {'type': 'str', 'description': 'The classification supertype being matched'}, 'uniqueItems': True}, 'type': 'list'}}, 'customer': {'type': 'dict', 'description': 'Clause to match by customer or group', 'properties': {'customerOrGroup': {'type': 'list', 'description': 'The customers or groups being matched. Specify id or shortName', 'items': {'type': 'str', 'description': 'The customers or groups being matched. Specify id or shortName'}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}}, 'required': ['customerOrGroup']}, 'submission': {'type': 'dict', 'description': 'Clause to match by submission', 'properties': {'metaDataKey': {'type': 'list', 'description': 'The submission meta data key being matched', 'items': {'type': 'str', 'description': 'The submission meta data key being matched'}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}, 'metaDataValue': {'type': 'list', 'description': 'The submission meta data value being matched', 'items': {'type': 'str', 'description': 'The submission meta data value being matched'}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}}, 'required': ['metaDataKey', 'metaDataValue']}}}, 'name': {'type': 'str', 'description': 'Name of the custom analysis rule to add'}}, 'required': ['action', 'description', 'match', 'name']}}}, 'required': True}, 'responses': {'default': {'description': 'default response', 'content': {'application/json': {}}}, '201': {'description': 'Successfully registered new analysis rule', 'content': {'application/json': {}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['addAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}
delete_default_analysis_rule = {'tags': ['sampledb/v2'], 'summary': 'Deletes a custom analysis policy rule by id (INTERNAL)', 'description': '', 'operationId': 'deleteAnalysisRule', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Id of the analysis policy rule to delete', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}], 'responses': {'default': {'description': 'Deletes a custom analysis policy rule by id', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Custom policy rule defining the actions and options for the analysis workers', 'properties': {'action': {'type': 'object', 'description': 'The actions which are performed when a custom rule matches. A rule can change both workers and options', 'properties': {'options': {'type': 'object', 'description': 'The actions applied to options', 'properties': {'add': {'type': 'array', 'description': 'Add to the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the options of the default policy', 'items': {'type': 'string', 'description': 'Remove from the options of the default policy'}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}}}, 'workers': {'type': 'object', 'description': 'The action applied to workers', 'properties': {'add': {'type': 'array', 'description': 'Add to the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}}}}}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was created'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was deleted'}, 'description': {'type': 'string', 'description': 'Longer description of the custom rule'}, 'flags': {'type': 'array', 'description': 'Flags defined for the analysis policy rule', 'items': {'type': 'string', 'description': 'Flags defined for the analysis policy rule', 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'Unique ID of the custom rule'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was last updated'}, 'match': {'type': 'object', 'description': 'The clause the custom rule is matching. A rule can only have one match, either customer, classification or submission', 'properties': {'classification': {'type': 'object', 'description': 'Clause to match by classification', 'properties': {'superType': {'type': 'array', 'description': 'The classification supertype being matched', 'items': {'type': 'string', 'description': 'The classification supertype being matched'}, 'uniqueItems': True}, 'type': {'type': 'array', 'description': 'The classification type being matched', 'items': {'type': 'string', 'description': 'The classification type being matched'}, 'uniqueItems': True}}}, 'customer': {'type': 'object', 'description': 'Clause to match by customer or group', 'properties': {'customer': {'type': 'array', 'description': 'The customers or groups being matched', 'items': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'uniqueItems': True}}}, 'submission': {'type': 'object', 'description': 'Clause to match by submission', 'properties': {'metaDataKey': {'type': 'array', 'description': 'The submission meta data key being matched', 'items': {'type': 'string', 'description': 'The submission meta data key being matched'}, 'uniqueItems': True}, 'metaDataValue': {'type': 'array', 'description': 'The submission meta data value being matched', 'items': {'type': 'string', 'description': 'The submission meta data value being matched'}, 'uniqueItems': True}}}}}, 'name': {'type': 'string', 'description': 'Name of the custom rule'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['deleteAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_default_analysis_policy = {'tags': ['sampledb/v2'], 'summary': 'Fetch the default analysis policy (INTERNAL)', 'description': '', 'operationId': 'getAnalysisPolicy', 'responses': {'default': {'description': 'Fetch the default analysis policy', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Policy defining which workers to execute during analysis of a sample', 'properties': {'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy was last updated'}, 'options': {'type': 'array', 'description': 'Parameters workers should respect during analysis', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}, 'workers': {'type': 'array', 'description': 'Workers executed during analysis of a sample', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}
get_default_analysis_policy_rule = {'tags': ['sampledb/v2'], 'summary': 'Fetch the analysis policy rule by id (INTERNAL)', 'description': '', 'operationId': 'getAnalysisPolicyRule', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Id of the analysis policy rule to fetch', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}], 'responses': {'default': {'description': 'Fetch the analysis policy rule by id', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Custom policy rule defining the actions and options for the analysis workers', 'properties': {'action': {'type': 'object', 'description': 'The actions which are performed when a custom rule matches. A rule can change both workers and options', 'properties': {'options': {'type': 'object', 'description': 'The actions applied to options', 'properties': {'add': {'type': 'array', 'description': 'Add to the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the options of the default policy', 'items': {'type': 'string', 'description': 'Remove from the options of the default policy'}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}}}, 'workers': {'type': 'object', 'description': 'The action applied to workers', 'properties': {'add': {'type': 'array', 'description': 'Add to the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}}}}}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was created'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was deleted'}, 'description': {'type': 'string', 'description': 'Longer description of the custom rule'}, 'flags': {'type': 'array', 'description': 'Flags defined for the analysis policy rule', 'items': {'type': 'string', 'description': 'Flags defined for the analysis policy rule', 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'Unique ID of the custom rule'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was last updated'}, 'match': {'type': 'object', 'description': 'The clause the custom rule is matching. A rule can only have one match, either customer, classification or submission', 'properties': {'classification': {'type': 'object', 'description': 'Clause to match by classification', 'properties': {'superType': {'type': 'array', 'description': 'The classification supertype being matched', 'items': {'type': 'string', 'description': 'The classification supertype being matched'}, 'uniqueItems': True}, 'type': {'type': 'array', 'description': 'The classification type being matched', 'items': {'type': 'string', 'description': 'The classification type being matched'}, 'uniqueItems': True}}}, 'customer': {'type': 'object', 'description': 'Clause to match by customer or group', 'properties': {'customer': {'type': 'array', 'description': 'The customers or groups being matched', 'items': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'uniqueItems': True}}}, 'submission': {'type': 'object', 'description': 'Clause to match by submission', 'properties': {'metaDataKey': {'type': 'array', 'description': 'The submission meta data key being matched', 'items': {'type': 'string', 'description': 'The submission meta data key being matched'}, 'uniqueItems': True}, 'metaDataValue': {'type': 'array', 'description': 'The submission meta data value being matched', 'items': {'type': 'string', 'description': 'The submission meta data value being matched'}, 'uniqueItems': True}}}}}, 'name': {'type': 'string', 'description': 'Name of the custom rule'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}
list_default_analysis_rules = {'tags': ['sampledb/v2'], 'summary': 'List custom analysis policy rules (INTERNAL)', 'description': '', 'operationId': 'searchAnalysisRules', 'parameters': [{'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Include deleted analysis policy rules', 'schema': {'type': 'bool', 'default': 'false', 'enum': ['true', 'false']}, 'type': 'bool', 'default': 'false', 'enum': ['true', 'false']}], 'responses': {'default': {'description': 'List custom analysis policy rules', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': 'Custom policy rule defining the actions and options for the analysis workers', 'properties': {'action': {'type': 'object', 'description': 'The actions which are performed when a custom rule matches. A rule can change both workers and options', 'properties': {'options': {'type': 'object', 'description': 'The actions applied to options', 'properties': {'add': {'type': 'array', 'description': 'Add to the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the options of the default policy', 'items': {'type': 'string', 'description': 'Remove from the options of the default policy'}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}}}, 'workers': {'type': 'object', 'description': 'The action applied to workers', 'properties': {'add': {'type': 'array', 'description': 'Add to the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}}}}}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was created'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was deleted'}, 'description': {'type': 'string', 'description': 'Longer description of the custom rule'}, 'flags': {'type': 'array', 'description': 'Flags defined for the analysis policy rule', 'items': {'type': 'string', 'description': 'Flags defined for the analysis policy rule', 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'Unique ID of the custom rule'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was last updated'}, 'match': {'type': 'object', 'description': 'The clause the custom rule is matching. A rule can only have one match, either customer, classification or submission', 'properties': {'classification': {'type': 'object', 'description': 'Clause to match by classification', 'properties': {'superType': {'type': 'array', 'description': 'The classification supertype being matched', 'items': {'type': 'string', 'description': 'The classification supertype being matched'}, 'uniqueItems': True}, 'type': {'type': 'array', 'description': 'The classification type being matched', 'items': {'type': 'string', 'description': 'The classification type being matched'}, 'uniqueItems': True}}}, 'customer': {'type': 'object', 'description': 'Clause to match by customer or group', 'properties': {'customer': {'type': 'array', 'description': 'The customers or groups being matched', 'items': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'uniqueItems': True}}}, 'submission': {'type': 'object', 'description': 'Clause to match by submission', 'properties': {'metaDataKey': {'type': 'array', 'description': 'The submission meta data key being matched', 'items': {'type': 'string', 'description': 'The submission meta data key being matched'}, 'uniqueItems': True}, 'metaDataValue': {'type': 'array', 'description': 'The submission meta data value being matched', 'items': {'type': 'string', 'description': 'The submission meta data value being matched'}, 'uniqueItems': True}}}}}, 'name': {'type': 'string', 'description': 'Name of the custom rule'}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_default_analysis_policy = {'tags': ['sampledb/v2'], 'summary': 'Update the default analysis policy (INTERNAL)', 'description': '', 'operationId': 'updateAnalysisPolicy', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Update the default analysis policy', 'properties': {'options': {'type': 'list', 'description': 'Parameters workers should respect during analysis. All parameters must be specified and will overwrite the existing list. There can only exist one parameter for a given key (no duplicated keys).', 'items': {'type': 'dict', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'str', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'str', 'description': 'Stringified value of the option.'}}, 'required': ['key', 'value']}, 'uniqueItems': True}, 'workers': {'type': 'list', 'description': 'Workers executed during analysis of a sample (identified by id-or-shortName). All (and at least one) workers must be specified and will overwrite the existing list.', 'items': {'type': 'str', 'description': 'Workers executed during analysis of a sample (identified by id-or-shortName). All (and at least one) workers must be specified and will overwrite the existing list.'}, 'uniqueItems': True}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update the default analysis policy', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Policy defining which workers to execute during analysis of a sample', 'properties': {'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy was last updated'}, 'options': {'type': 'array', 'description': 'Parameters workers should respect during analysis', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}, 'workers': {'type': 'array', 'description': 'Workers executed during analysis of a sample', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}
update_default_analysis_rule = {'tags': ['sampledb/v2'], 'summary': 'Update an existing custom rule (INTERNAL)', 'description': '', 'operationId': 'updateAnalysisRule', 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Id of the custom analysis rule to update', 'required': True, 'schema': {'type': 'str'}, 'type': 'str'}], 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to update an existing custom rule', 'properties': {'action': {'type': 'dict', 'description': 'The actions which are performed when a custom rule matches. A rule can change both workers and options', 'properties': {'options': {'type': 'dict', 'description': 'The actions applied to options', 'properties': {'add': {'type': 'list', 'description': 'Add to the options of the default policy', 'items': {'type': 'dict', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'str', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'str', 'description': 'Stringified value of the option.'}}, 'required': ['key', 'value']}, 'uniqueItems': True}, 'remove': {'type': 'list', 'description': 'Remove from the options of the default policy', 'items': {'type': 'str', 'description': 'Remove from the options of the default policy'}, 'uniqueItems': True}, 'set': {'type': 'list', 'description': 'Overwrite the options of the default policy', 'items': {'type': 'dict', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'str', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'str', 'description': 'Stringified value of the option.'}}, 'required': ['key', 'value']}, 'uniqueItems': True}}}, 'workers': {'type': 'dict', 'description': 'The action applied to workers', 'properties': {'add': {'type': 'list', 'description': 'The id or shortName of the workers to add to the default policy', 'items': {'type': 'str', 'description': 'The id or shortName of the workers to add to the default policy'}, 'uniqueItems': True}, 'remove': {'type': 'list', 'description': 'The id or shortName of the workers to remove from the default policy', 'items': {'type': 'str', 'description': 'The id or shortName of the workers to remove from the default policy'}, 'uniqueItems': True}, 'set': {'type': 'list', 'description': 'The id or shortName of the workers to set to the default policy', 'items': {'type': 'str', 'description': 'The id or shortName of the workers to set to the default policy'}, 'uniqueItems': True}}}}}, 'description': {'type': 'str', 'description': 'If set change the description of the custom rule'}, 'match': {'type': 'dict', 'description': 'The clause the custom rule is matching. A rule can only have one match, either customer, classification or submission', 'properties': {'classification': {'type': 'dict', 'description': 'Clause to match by classification', 'properties': {'superType': {'type': 'list', 'description': 'The classification supertype being matched', 'items': {'type': 'str', 'description': 'The classification supertype being matched'}, 'uniqueItems': True}, 'type': 'list'}}, 'customer': {'type': 'dict', 'description': 'Clause to match by customer or group', 'properties': {'customerOrGroup': {'type': 'list', 'description': 'The customers or groups being matched. Specify id or shortName', 'items': {'type': 'str', 'description': 'The customers or groups being matched. Specify id or shortName'}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}}, 'required': ['customerOrGroup']}, 'submission': {'type': 'dict', 'description': 'Clause to match by submission', 'properties': {'metaDataKey': {'type': 'list', 'description': 'The submission meta data key being matched', 'items': {'type': 'str', 'description': 'The submission meta data key being matched'}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}, 'metaDataValue': {'type': 'list', 'description': 'The submission meta data value being matched', 'items': {'type': 'str', 'description': 'The submission meta data value being matched'}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}}, 'required': ['metaDataKey', 'metaDataValue']}}}, 'name': {'type': 'str', 'description': 'If set change the name of the custom rule'}}}}}, 'required': True}, 'responses': {'default': {'description': 'Update an existing custom rule', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': 'Custom policy rule defining the actions and options for the analysis workers', 'properties': {'action': {'type': 'object', 'description': 'The actions which are performed when a custom rule matches. A rule can change both workers and options', 'properties': {'options': {'type': 'object', 'description': 'The actions applied to options', 'properties': {'add': {'type': 'array', 'description': 'Add to the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the options of the default policy', 'items': {'type': 'string', 'description': 'Remove from the options of the default policy'}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the options of the default policy', 'items': {'type': 'object', 'description': 'Parameter sent to a worker in the analysis pipeline', 'properties': {'key': {'type': 'string', 'description': 'Unique key of the option, e.g. meta.sampledb.allowInternetAccess.'}, 'value': {'type': 'string', 'description': 'Stringified value of the option.'}}}, 'uniqueItems': True}}}, 'workers': {'type': 'object', 'description': 'The action applied to workers', 'properties': {'add': {'type': 'array', 'description': 'Add to the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'remove': {'type': 'array', 'description': 'Remove from the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}, 'set': {'type': 'array', 'description': 'Overwrite the workers of the default policy', 'items': {'type': 'object', 'description': 'Configuration of a worker in the analysis pipeline - info object', 'properties': {'id': {'type': 'string', 'format': 'uuid', 'description': 'ID of the analysis worker'}, 'localizedName': {'type': 'string', 'description': "Display name of the analysis worker in the current user's language"}, 'shortName': {'type': 'string', 'description': 'Unique short name of the analysis worker'}}}, 'uniqueItems': True}}}}}, 'createdByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was created'}, 'deletedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was deleted'}, 'description': {'type': 'string', 'description': 'Longer description of the custom rule'}, 'flags': {'type': 'array', 'description': 'Flags defined for the analysis policy rule', 'items': {'type': 'string', 'description': 'Flags defined for the analysis policy rule', 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'string', 'format': 'uuid', 'description': 'Unique ID of the custom rule'}, 'lastUpdatedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'Timestamp when the analysis policy rule was last updated'}, 'match': {'type': 'object', 'description': 'The clause the custom rule is matching. A rule can only have one match, either customer, classification or submission', 'properties': {'classification': {'type': 'object', 'description': 'Clause to match by classification', 'properties': {'superType': {'type': 'array', 'description': 'The classification supertype being matched', 'items': {'type': 'string', 'description': 'The classification supertype being matched'}, 'uniqueItems': True}, 'type': {'type': 'array', 'description': 'The classification type being matched', 'items': {'type': 'string', 'description': 'The classification type being matched'}, 'uniqueItems': True}}}, 'customer': {'type': 'object', 'description': 'Clause to match by customer or group', 'properties': {'customer': {'type': 'array', 'description': 'The customers or groups being matched', 'items': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'uniqueItems': True}}}, 'submission': {'type': 'object', 'description': 'Clause to match by submission', 'properties': {'metaDataKey': {'type': 'array', 'description': 'The submission meta data key being matched', 'items': {'type': 'string', 'description': 'The submission meta data key being matched'}, 'uniqueItems': True}, 'metaDataValue': {'type': 'array', 'description': 'The submission meta data value being matched', 'items': {'type': 'string', 'description': 'The submission meta data value being matched'}, 'uniqueItems': True}}}}}, 'name': {'type': 'string', 'description': 'Name of the custom rule'}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['updateAnalysisPolicy'], 'x-Argus-ApiStatus': 'INTERNAL'}