"""Autogenerated API schema"""
from argus_api import session


grant_permission = {'tags': ['useradmin/v2'], 'summary': 'Grants a permission to a user (PUBLIC)', 'description': '', 'operationId': 'grantPermission', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to grant a permission to a user or group', 'properties': {'comment': {'type': 'str', 'description': 'Comment to describe the reason for this change'}, 'customer': {'type': 'str', 'description': 'Customer that the function is valid for (id or name)'}, 'function': {'type': 'str', 'description': 'Function to grant (id or name)'}, 'subject': {'type': 'str', 'description': 'Subject to grant the function to (id or name)'}}, 'required': ['customer', 'function', 'subject']}}}, 'required': True}, 'responses': {'default': {'description': 'Grants a permission to a user', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "User SPI Permission. This class is a model for a permission.\n\nPermissions let's a subject use a function for a given customer.\n", 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags set on the permission', 'items': {'type': 'string', 'description': 'Flags set on the permission', 'enum': ['deleted']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'functionInfo': {'type': 'object', 'description': 'Basic function response object providing detailed information about functions', 'properties': {'flags': {'type': 'array', 'description': 'Set of flags that are true for this function', 'items': {'type': 'string', 'description': 'Set of flags that are true for this function', 'enum': ['deleted', 'role', 'sysadm', 'readOnly']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the function'}, 'localizedDescription': {'type': 'string', 'description': "Function description based on the current user's language settings"}, 'localizedName': {'type': 'string', 'description': "Function name based on the current user's language settings"}, 'minimumSecurityLevel': {'type': 'string', 'description': 'The minimum security level of the function', 'enum': ['administrative', 'standard', 'external']}, 'name': {'type': 'string', 'description': 'Name of the function'}, 'roleType': {'type': 'string', 'description': 'The role type of the function', 'enum': ['service', 'case', 'tool', 'other']}}}, 'grantComment': {'type': 'string', 'description': 'The comment given when granting this permission'}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was granted'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'revokeComment': {'type': 'string', 'description': 'The comment given when revoking this permission'}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was revoked'}, 'subject': {'oneOf': [{'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'description': 'SPI GroupInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['grantRole'], 'x-Argus-ApiStatus': 'PUBLIC'}
grant_permissions_bulk = {'tags': ['useradmin/v2'], 'summary': 'Bulk-grant permissions (PUBLIC)', 'description': '', 'operationId': 'grantPermissionsBulk', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to grant multiple permissions in a single bulk', 'properties': {'permissions': {'type': 'list', 'description': 'A set of permissions to grant', 'items': {'type': 'dict', 'description': 'Request to grant a permission to a user or group', 'properties': {'comment': {'type': 'str', 'description': 'Comment to describe the reason for this change'}, 'customer': {'type': 'str', 'description': 'Customer that the function is valid for (id or name)'}, 'function': {'type': 'str', 'description': 'Function to grant (id or name)'}, 'subject': {'type': 'str', 'description': 'Subject to grant the function to (id or name)'}}, 'required': ['customer', 'function', 'subject']}, 'maxItems': 2147483647, 'minItems': 1, 'uniqueItems': True}}, 'required': ['permissions']}}}, 'required': True}, 'responses': {'default': {'description': 'Bulk-grant permissions', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': "User SPI Permission. This class is a model for a permission.\n\nPermissions let's a subject use a function for a given customer.\n", 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags set on the permission', 'items': {'type': 'string', 'description': 'Flags set on the permission', 'enum': ['deleted']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'functionInfo': {'type': 'object', 'description': 'Basic function response object providing detailed information about functions', 'properties': {'flags': {'type': 'array', 'description': 'Set of flags that are true for this function', 'items': {'type': 'string', 'description': 'Set of flags that are true for this function', 'enum': ['deleted', 'role', 'sysadm', 'readOnly']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the function'}, 'localizedDescription': {'type': 'string', 'description': "Function description based on the current user's language settings"}, 'localizedName': {'type': 'string', 'description': "Function name based on the current user's language settings"}, 'minimumSecurityLevel': {'type': 'string', 'description': 'The minimum security level of the function', 'enum': ['administrative', 'standard', 'external']}, 'name': {'type': 'string', 'description': 'Name of the function'}, 'roleType': {'type': 'string', 'description': 'The role type of the function', 'enum': ['service', 'case', 'tool', 'other']}}}, 'grantComment': {'type': 'string', 'description': 'The comment given when granting this permission'}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was granted'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'revokeComment': {'type': 'string', 'description': 'The comment given when revoking this permission'}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was revoked'}, 'subject': {'oneOf': [{'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'description': 'SPI GroupInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['grantRole'], 'x-Argus-ApiStatus': 'PUBLIC'}
list_permissions = {'tags': ['useradmin/v2'], 'summary': 'Searches for permissions, defaults to showing all permissions (PUBLIC)', 'description': '', 'operationId': 'listPermissions', 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'schema': {'type': 'int', 'default': '0', 'minimum': 0}, 'type': 'int', 'default': '0', 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'schema': {'type': 'int', 'default': '25', 'minimum': 0}, 'type': 'int', 'default': '25', 'minimum': 0}, {'name': 'domain', 'in': 'query', 'description': 'Name or ID of the domain to search', 'schema': {'type': 'string'}, 'type': 'str'}, {'name': 'subject', 'in': 'query', 'description': 'Name or ID of the subject', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'customer', 'in': 'query', 'description': 'Name or ID of the customer', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'function', 'in': 'query', 'description': 'Name or ID of the function', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'includeSubjectAscendants', 'in': 'query', 'description': 'Include permissions for ascending subjects', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'includeSubjectDescendants', 'in': 'query', 'description': 'Include permissions for descending subjects', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'includeCustomerAscendants', 'in': 'query', 'description': 'Include permissions for ascending customers', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'includeCustomerDescendants', 'in': 'query', 'description': 'Include permissions for descending customers', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'includeFunctionAscendants', 'in': 'query', 'description': 'Include permissions for ascending functions', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'includeFunctionDescendants', 'in': 'query', 'description': 'Include permissions for descending functions', 'schema': {'type': 'bool', 'default': 'true'}, 'type': 'bool', 'default': 'true'}, {'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'schema': {'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'string'}, 'uniqueItems': True}, {'name': 'keywordMatch', 'in': 'query', 'description': 'Set match strategy for keyword search', 'schema': {'type': 'str', 'default': 'all', 'enum': ['any', 'all']}, 'type': 'str', 'default': 'all', 'enum': ['any', 'all']}, {'name': 'keywordField', 'in': 'query', 'description': 'Set field strategy for keyword search', 'schema': {'type': 'list', 'default': 'all', 'items': {'type': 'str', 'enum': ['function', 'subject', 'customer', 'all']}, 'uniqueItems': True}, 'type': 'list', 'default': 'all', 'items': {'type': 'str', 'enum': ['function', 'subject', 'customer', 'all']}, 'uniqueItems': True}, {'name': 'includeDeleted', 'in': 'query', 'description': 'Include deleted permissions', 'schema': {'type': 'bool', 'default': 'false'}, 'type': 'bool', 'default': 'false'}], 'responses': {'default': {'description': 'Searches for permissions, defaults to showing all permissions', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': "User SPI Permission. This class is a model for a permission.\n\nPermissions let's a subject use a function for a given customer.\n", 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags set on the permission', 'items': {'type': 'string', 'description': 'Flags set on the permission', 'enum': ['deleted']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'functionInfo': {'type': 'object', 'description': 'Basic function response object providing detailed information about functions', 'properties': {'flags': {'type': 'array', 'description': 'Set of flags that are true for this function', 'items': {'type': 'string', 'description': 'Set of flags that are true for this function', 'enum': ['deleted', 'role', 'sysadm', 'readOnly']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the function'}, 'localizedDescription': {'type': 'string', 'description': "Function description based on the current user's language settings"}, 'localizedName': {'type': 'string', 'description': "Function name based on the current user's language settings"}, 'minimumSecurityLevel': {'type': 'string', 'description': 'The minimum security level of the function', 'enum': ['administrative', 'standard', 'external']}, 'name': {'type': 'string', 'description': 'Name of the function'}, 'roleType': {'type': 'string', 'description': 'The role type of the function', 'enum': ['service', 'case', 'tool', 'other']}}}, 'grantComment': {'type': 'string', 'description': 'The comment given when granting this permission'}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was granted'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'revokeComment': {'type': 'string', 'description': 'The comment given when revoking this permission'}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was revoked'}, 'subject': {'oneOf': [{'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'description': 'SPI GroupInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewPermissions'], 'x-Argus-ApiStatus': 'PUBLIC'}
revoke_permission = {'tags': ['useradmin/v2'], 'summary': 'Revokes a permission from a user (PUBLIC)', 'description': '', 'operationId': 'revokePermission', 'parameters': [{'name': 'permissionID', 'in': 'path', 'description': 'ID of permission', 'required': True, 'schema': {'type': 'int', 'minimum': 1}, 'type': 'int', 'minimum': 1}, {'name': 'comment', 'in': 'query', 'description': 'Comment to describe the reason for this change', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Revokes a permission from a user', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'object', 'description': "User SPI Permission. This class is a model for a permission.\n\nPermissions let's a subject use a function for a given customer.\n", 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags set on the permission', 'items': {'type': 'string', 'description': 'Flags set on the permission', 'enum': ['deleted']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'functionInfo': {'type': 'object', 'description': 'Basic function response object providing detailed information about functions', 'properties': {'flags': {'type': 'array', 'description': 'Set of flags that are true for this function', 'items': {'type': 'string', 'description': 'Set of flags that are true for this function', 'enum': ['deleted', 'role', 'sysadm', 'readOnly']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the function'}, 'localizedDescription': {'type': 'string', 'description': "Function description based on the current user's language settings"}, 'localizedName': {'type': 'string', 'description': "Function name based on the current user's language settings"}, 'minimumSecurityLevel': {'type': 'string', 'description': 'The minimum security level of the function', 'enum': ['administrative', 'standard', 'external']}, 'name': {'type': 'string', 'description': 'Name of the function'}, 'roleType': {'type': 'string', 'description': 'The role type of the function', 'enum': ['service', 'case', 'tool', 'other']}}}, 'grantComment': {'type': 'string', 'description': 'The comment given when granting this permission'}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was granted'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'revokeComment': {'type': 'string', 'description': 'The comment given when revoking this permission'}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was revoked'}, 'subject': {'oneOf': [{'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'description': 'SPI GroupInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['revokeRole'], 'x-Argus-ApiStatus': 'PUBLIC'}
revoke_permissions_bulk = {'tags': ['useradmin/v2'], 'summary': 'Revokes a set of permissions (PUBLIC)', 'description': '', 'operationId': 'revokePermissionsBulk', 'parameters': [{'name': 'permission', 'in': 'query', 'description': 'ID of permissions to revoke', 'required': True, 'schema': {'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, 'type': 'list', 'items': {'type': 'int'}, 'uniqueItems': True}, {'name': 'comment', 'in': 'query', 'description': 'Comment to describe the reason for this change', 'schema': {'type': 'string'}, 'type': 'str'}], 'responses': {'default': {'description': 'Revokes a set of permissions', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': "User SPI Permission. This class is a model for a permission.\n\nPermissions let's a subject use a function for a given customer.\n", 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags set on the permission', 'items': {'type': 'string', 'description': 'Flags set on the permission', 'enum': ['deleted']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'functionInfo': {'type': 'object', 'description': 'Basic function response object providing detailed information about functions', 'properties': {'flags': {'type': 'array', 'description': 'Set of flags that are true for this function', 'items': {'type': 'string', 'description': 'Set of flags that are true for this function', 'enum': ['deleted', 'role', 'sysadm', 'readOnly']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the function'}, 'localizedDescription': {'type': 'string', 'description': "Function description based on the current user's language settings"}, 'localizedName': {'type': 'string', 'description': "Function name based on the current user's language settings"}, 'minimumSecurityLevel': {'type': 'string', 'description': 'The minimum security level of the function', 'enum': ['administrative', 'standard', 'external']}, 'name': {'type': 'string', 'description': 'Name of the function'}, 'roleType': {'type': 'string', 'description': 'The role type of the function', 'enum': ['service', 'case', 'tool', 'other']}}}, 'grantComment': {'type': 'string', 'description': 'The comment given when granting this permission'}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was granted'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'revokeComment': {'type': 'string', 'description': 'The comment given when revoking this permission'}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was revoked'}, 'subject': {'oneOf': [{'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'description': 'SPI GroupInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '404': {'description': 'Object not found', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['revokeRole'], 'x-Argus-ApiStatus': 'PUBLIC'}
search_permissions = {'tags': ['useradmin/v2'], 'summary': 'Searches for permissions, defaults to showing all permissions (PUBLIC)', 'description': '', 'operationId': 'searchPermissions', 'requestBody': {'content': {'application/json': {'schema': {'type': 'object', 'description': 'Request to search for permissions', 'properties': {'customer': {'type': 'list', 'description': 'The ID or shortname of customers to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of customers to search for'}, 'uniqueItems': True}, 'domain': {'type': 'str', 'description': 'The ID or shortname of the domain where the subjects and customers are located'}, 'endTimestamp': {'type': 'str', 'description': 'Restrict search to data before this time (epoch millis) according to selected TimeFieldStrategies. Allows unix timestamp (milliseconds), ISO timestamp, or relative time specifies. See https://docs.mnemonic.no/x/AQDXAQ  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'function': {'type': 'list', 'description': 'The ID or shortname of functions to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of functions to search for'}, 'uniqueItems': True}, 'includeCustomerAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for customer ascendants'}, 'includeCustomerDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for customer descendants'}, 'includeDeleted': {'type': 'bool', 'default': False, 'description': 'Include deleted permissions'}, 'includeFunctionAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for function ascendants'}, 'includeFunctionDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for function descendants'}, 'includeSubjectAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for subject ascendants'}, 'includeSubjectDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for subject descendants'}, 'keywordFieldStrategy': {'type': 'list', 'default': 'All supported fields', 'description': 'Which fields will be searched for the given keyword', 'items': {'type': 'str', 'default': 'All supported fields', 'description': 'Which fields will be searched for the given keyword', 'enum': ['function', 'subject', 'customer', 'all']}, 'uniqueItems': True}, 'keywordMatchStrategy': {'type': 'str', 'default': 'Match all keywords (AND)', 'description': 'Search based on all keywords (AND), or based on any keyword (OR)', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Keywords to search for', 'items': {'type': 'str', 'description': 'Keywords to search for'}, 'uniqueItems': True}, 'limit': {'type': 'int', 'default': 25, 'description': 'The max amount of items to display', 'minimum': 0}, 'offset': {'type': 'int', 'default': 0, 'description': 'The amount of items to skip', 'minimum': 0}, 'sortBy': {'type': 'list', 'default': 'subject', 'description': 'Field to sort result by (will sort by the fields ID, not name)', 'items': {'type': 'str', 'default': 'subject', 'description': 'Field to sort result by (will sort by the fields ID, not name)'}}, 'startTimestamp': {'type': 'str', 'description': 'Restrict search to data after this time (epoch millis) according to selected TimeFieldStrategies. Allows unix timestamp (milliseconds), ISO timestamp, or relative time specifies. See https://docs.mnemonic.no/x/AQDXAQ  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'subCriteria': {'type': 'list', 'items': {'type': 'dict', 'properties': {'keywordMatchStrategy': {'type': 'str', 'default': 'Match all keywords (AND)', 'description': 'Search based on all keywords (AND), or based on any keyword (OR)', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Keywords to search for', 'items': {'type': 'str', 'description': 'Keywords to search for'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'All supported fields', 'description': 'Which fields will be searched for the given keyword', 'items': {'type': 'str', 'default': 'All supported fields', 'description': 'Which fields will be searched for the given keyword', 'enum': ['function', 'subject', 'customer', 'all']}, 'uniqueItems': True}, 'startTimestamp': {'type': 'str', 'description': 'Restrict search to data after this time (epoch millis) according to selected TimeFieldStrategies. Allows unix timestamp (milliseconds), ISO timestamp, or relative time specifies. See https://docs.mnemonic.no/x/AQDXAQ  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Restrict search to data before this time (epoch millis) according to selected TimeFieldStrategies. Allows unix timestamp (milliseconds), ISO timestamp, or relative time specifies. See https://docs.mnemonic.no/x/AQDXAQ  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeMatchStrategy': {'type': 'str', 'description': 'Specify if the specified time period must match all the searched time fields, or if it will match for any field. Default is any.', 'enum': ['any', 'all']}, 'timeFieldStrategy': {'type': 'list', 'description': 'Determine fields to search for by time (defaults to all)', 'items': {'type': 'str', 'description': 'Determine fields to search for by time (defaults to all)', 'enum': ['grantedTimestamp', 'revokedTimestamp', 'all']}, 'uniqueItems': True}, 'subject': {'type': 'list', 'description': 'The ID or shortname of subjects to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of subjects to search for'}, 'uniqueItems': True}, 'customer': {'type': 'list', 'description': 'The ID or shortname of customers to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of customers to search for'}, 'uniqueItems': True}, 'function': {'type': 'list', 'description': 'The ID or shortname of functions to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of functions to search for'}, 'uniqueItems': True}, 'domain': {'type': 'str', 'description': 'The ID or shortname of the domain where the subjects and customers are located'}, 'sortBy': {'type': 'list', 'default': 'subject', 'description': 'Field to sort result by (will sort by the fields ID, not name)', 'items': {'type': 'str', 'default': 'subject', 'description': 'Field to sort result by (will sort by the fields ID, not name)'}}, 'includeSubjectAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for subject ascendants'}, 'includeSubjectDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for subject descendants'}, 'includeCustomerAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for customer ascendants'}, 'includeCustomerDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for customer descendants'}, 'includeFunctionAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for function ascendants'}, 'includeFunctionDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for function descendants'}, 'includeDeleted': {'type': 'bool', 'default': False, 'description': 'Include deleted permissions'}, 'required': {'type': 'bool', 'default': False, 'description': 'Is this subcriteria required? If false it is OR-ed, if true it is AND-ed'}, 'exclude': {'type': 'bool', 'default': False, 'description': 'Exclude objects matching subcriteria? If true, the criteria is NOT-ed.'}, 'excluded': {'type': 'dict', 'properties': {'keywordMatchStrategy': {'type': 'str', 'default': 'Match all keywords (AND)', 'description': 'Search based on all keywords (AND), or based on any keyword (OR)', 'enum': ['any', 'all']}, 'keywords': {'type': 'list', 'description': 'Keywords to search for', 'items': {'type': 'str', 'description': 'Keywords to search for'}, 'uniqueItems': True}, 'keywordFieldStrategy': {'type': 'list', 'default': 'All supported fields', 'description': 'Which fields will be searched for the given keyword', 'items': {'type': 'str', 'default': 'All supported fields', 'description': 'Which fields will be searched for the given keyword', 'enum': ['function', 'subject', 'customer', 'all']}, 'uniqueItems': True}, 'startTimestamp': {'type': 'str', 'description': 'Restrict search to data after this time (epoch millis) according to selected TimeFieldStrategies. Allows unix timestamp (milliseconds), ISO timestamp, or relative time specifies. See https://docs.mnemonic.no/x/AQDXAQ  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'endTimestamp': {'type': 'str', 'description': 'Restrict search to data before this time (epoch millis) according to selected TimeFieldStrategies. Allows unix timestamp (milliseconds), ISO timestamp, or relative time specifies. See https://docs.mnemonic.no/x/AQDXAQ  Allows to specify a unix timestamp (milliseconds), ISO timestamp, or relative time.', 'externalDocs': {'description': 'See documentation', 'url': 'https://docs.mnemonic.no/api/general_integration_guide/08-time_fields.html#api-iguide-general-time-search'}}, 'timeMatchStrategy': {'type': 'str', 'description': 'Specify if the specified time period must match all the searched time fields, or if it will match for any field. Default is any.', 'enum': ['any', 'all']}, 'timeFieldStrategy': {'type': 'list', 'description': 'Determine fields to search for by time (defaults to all)', 'items': {'type': 'str', 'description': 'Determine fields to search for by time (defaults to all)', 'enum': ['grantedTimestamp', 'revokedTimestamp', 'all']}, 'uniqueItems': True}, 'subject': {'type': 'list', 'description': 'The ID or shortname of subjects to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of subjects to search for'}, 'uniqueItems': True}, 'customer': {'type': 'list', 'description': 'The ID or shortname of customers to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of customers to search for'}, 'uniqueItems': True}, 'function': {'type': 'list', 'description': 'The ID or shortname of functions to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of functions to search for'}, 'uniqueItems': True}, 'domain': {'type': 'str', 'description': 'The ID or shortname of the domain where the subjects and customers are located'}, 'sortBy': {'type': 'list', 'default': 'subject', 'description': 'Field to sort result by (will sort by the fields ID, not name)', 'items': {'type': 'str', 'default': 'subject', 'description': 'Field to sort result by (will sort by the fields ID, not name)'}}, 'includeSubjectAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for subject ascendants'}, 'includeSubjectDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for subject descendants'}, 'includeCustomerAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for customer ascendants'}, 'includeCustomerDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for customer descendants'}, 'includeFunctionAscendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for function ascendants'}, 'includeFunctionDescendants': {'type': 'bool', 'default': True, 'description': 'Incude permissions given for function descendants'}, 'includeDeleted': {'type': 'bool', 'default': False, 'description': 'Include deleted permissions'}, 'required': {'type': 'bool', 'default': False, 'description': 'Is this subcriteria required? If false it is OR-ed, if true it is AND-ed'}, 'exclude': {'type': 'bool', 'default': False, 'description': 'Exclude objects matching subcriteria? If true, the criteria is NOT-ed.'}, 'excluded': []}, 'required': ['keywordFieldStrategy', 'keywordMatchStrategy']}}, 'required': ['keywordFieldStrategy', 'keywordMatchStrategy']}, 'uniqueItems': True}, 'subject': {'type': 'list', 'description': 'The ID or shortname of subjects to search for', 'items': {'type': 'str', 'description': 'The ID or shortname of subjects to search for'}, 'uniqueItems': True}, 'timeFieldStrategy': {'type': 'list', 'description': 'Determine fields to search for by time (defaults to all)', 'items': {'type': 'str', 'description': 'Determine fields to search for by time (defaults to all)', 'enum': ['grantedTimestamp', 'revokedTimestamp', 'all']}, 'uniqueItems': True}, 'timeMatchStrategy': {'type': 'str', 'description': 'Specify if the specified time period must match all the searched time fields, or if it will match for any field. Default is any.', 'enum': ['any', 'all']}}, 'required': ['keywordFieldStrategy', 'keywordMatchStrategy']}}}, 'required': True}, 'responses': {'default': {'description': 'Searches for permissions, defaults to showing all permissions', 'content': {'application/json': {'schema': {'type': 'object', 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string', 'description': 'Message text'}, 'messageTemplate': {'type': 'string', 'description': 'Message template'}, 'type': {'type': 'string', 'description': 'Message type', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string', 'description': 'Field which this message applies to'}, 'parameter': {'type': 'string', 'description': 'The affected parameter'}}}}, 'data': {'type': 'array', 'items': {'type': 'object', 'description': "User SPI Permission. This class is a model for a permission.\n\nPermissions let's a subject use a function for a given customer.\n", 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'flags': {'type': 'array', 'description': 'Flags set on the permission', 'items': {'type': 'string', 'description': 'Flags set on the permission', 'enum': ['deleted']}, 'uniqueItems': True}, 'function': {'type': 'object', 'description': 'SPI FunctionInfo', 'properties': {'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the function.'}}}, 'functionInfo': {'type': 'object', 'description': 'Basic function response object providing detailed information about functions', 'properties': {'flags': {'type': 'array', 'description': 'Set of flags that are true for this function', 'items': {'type': 'string', 'description': 'Set of flags that are true for this function', 'enum': ['deleted', 'role', 'sysadm', 'readOnly']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the function'}, 'localizedDescription': {'type': 'string', 'description': "Function description based on the current user's language settings"}, 'localizedName': {'type': 'string', 'description': "Function name based on the current user's language settings"}, 'minimumSecurityLevel': {'type': 'string', 'description': 'The minimum security level of the function', 'enum': ['administrative', 'standard', 'external']}, 'name': {'type': 'string', 'description': 'Name of the function'}, 'roleType': {'type': 'string', 'description': 'The role type of the function', 'enum': ['service', 'case', 'tool', 'other']}}}, 'grantComment': {'type': 'string', 'description': 'The comment given when granting this permission'}, 'grantedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'grantedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was granted'}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'revokeComment': {'type': 'string', 'description': 'The comment given when revoking this permission'}, 'revokedByUser': {'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, 'revokedTimestamp': {'type': 'integer', 'format': 'int64', 'description': 'The time the permission was revoked'}, 'subject': {'oneOf': [{'type': 'object', 'description': 'SPI UserInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}, {'type': 'object', 'description': 'SPI GroupInfo', 'properties': {'customer': {'type': 'object', 'description': 'SPI CustomerInfo', 'properties': {'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the customer.'}, 'shortName': {'type': 'string', 'description': 'Shortname of the customer.'}}}, 'domain': {'type': 'object', 'description': 'SPI DomainInfo', 'properties': {'id': {'type': 'integer', 'format': 'int32', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': 'Name of the domain.'}}}, 'flags': {'type': 'array', 'description': "The subject's flags", 'items': {'type': 'string', 'description': "The subject's flags", 'enum': ['deleted']}, 'uniqueItems': True}, 'id': {'type': 'integer', 'format': 'int64', 'description': 'ID of the response object.'}, 'name': {'type': 'string', 'description': "The subject's name"}, 'shortName': {'type': 'string', 'description': "The subject's short name"}, 'type': {'type': 'string', 'description': 'Type of the subject', 'enum': ['user', 'group'], 'readOnly': True}}}]}}}}}}}}}, '401': {'description': 'Authentication failed', 'content': {'application/json': {}}}, '403': {'description': 'Access denied', 'content': {'application/json': {}}}, '412': {'description': 'Validation error', 'content': {'application/json': {}}}}, 'x-Argus-Required-Permissions': ['viewPermissions'], 'x-Argus-ApiStatus': 'PUBLIC'}